//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#ifndef __IRCcomandos_h__
#define __IRCcomandos_h__

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "constantes.h"

//////////////////////////////
class comIRCComandoBASE
{
 protected:
  string strComando;
  void *Padre;
 public:
  comIRCComandoBASE(string Comando, void* Padre);
  virtual ~comIRCComandoBASE(){};
  bool Accion(string Comando);
 protected:
  virtual bool onAccion(vector<string> ComandoParceado) = 0;
};






///////////// NUEVAPARTIDA /////////////
class comIRCComandoNUEVAPARTIDA : public comIRCComandoBASE
{
 public:
  comIRCComandoNUEVAPARTIDA(void *Padre):comIRCComandoBASE("NUEVAPARTIDA", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// PING /////////////
class comIRCComandoPING : public comIRCComandoBASE
{
 public:
  comIRCComandoPING(void *Padre):comIRCComandoBASE("PING", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// 001 /////////////
class comIRCComando001 : public comIRCComandoBASE
{
 public:
  comIRCComando001(void *Padre):comIRCComandoBASE("001", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// CONEXION /////////////
class comIRCComandoCONEXION : public comIRCComandoBASE
{
 public:
  comIRCComandoCONEXION(void *Padre):comIRCComandoBASE("CONEXION", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// MSG_PRIVADO /////////////
class comIRCComandoMSG_PRIVADO : public comIRCComandoBASE
{
 public:
  comIRCComandoMSG_PRIVADO(void *Padre):comIRCComandoBASE("MSG_PRIVADO", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// MSG CANAL /////////////
class comIRCComandoMSG_CANAL : public comIRCComandoBASE
{
 public:
  comIRCComandoMSG_CANAL(void *Padre):comIRCComandoBASE("MSG_CANAL", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// MSG CANAL /////////////
class comIRCComandoJOIN_YO : public comIRCComandoBASE
{
 public:
  comIRCComandoJOIN_YO(void *Padre):comIRCComandoBASE("JOIN_YO", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// MSG CANAL /////////////
class comIRCComandoJOIN_OTRO : public comIRCComandoBASE
{
 public:
  comIRCComandoJOIN_OTRO(void *Padre):comIRCComandoBASE("JOIN_OTRO", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// MSG CANAL /////////////
class comIRCComandoLISTA_DE_NICKS : public comIRCComandoBASE
{
 public:
  comIRCComandoLISTA_DE_NICKS(void *Padre):comIRCComandoBASE("LISTA_DE_NICKS", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// PART /////////////
class comIRCComandoPART : public comIRCComandoBASE
{
 public:
  comIRCComandoPART(void *Padre):comIRCComandoBASE("PART", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// MSG CANAL /////////////
class comIRCComandoQUIT : public comIRCComandoBASE
{
 public:
  comIRCComandoQUIT(void *Padre):comIRCComandoBASE("QUIT", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// NICK /////////////
class comIRCComandoNICK : public comIRCComandoBASE
{
 public:
  comIRCComandoNICK(void *Padre):comIRCComandoBASE("NICK", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// MIIP /////////////
class comIRCComandoMIIP : public comIRCComandoBASE
{
 public:
  comIRCComandoMIIP(void *Padre):comIRCComandoBASE("MIIP", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};


///////////// ERROR /////////////
class comIRCComandoERROR : public comIRCComandoBASE
{
 public:
  comIRCComandoERROR(void *Padre):comIRCComandoBASE("ERROR", Padre){};
  bool onAccion (vector<string> ComandoParceado);
};

#endif
