//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "Mouse.h"
#include "eventos.h"

#include "Solar3DWidGets/Solar3DWidGetEntorno.h"

// ----------------------------------------- 
Mouse::Mouse()
{

  MouseState.boton = 0;
  MouseState.estado = 1;
  MouseState.x = 400;
  Mouse::MouseState.y = 300;

}

// ----------------------------------------- 
void Mouse::MouseEventos (int x, int y, int boton, int estado)
{


  int ClicSolarWidGet = -1;

  switch (boton)
    {
    case 0:  ClicSolarWidGet = S3DWM_MouseBotonIzquierdo; break;
    case 1:  ClicSolarWidGet = S3DWM_MouseBotonDerecho; break;
    }

  float X = (float)x / Mouse::Pantalla.x;
  float Y = (float)y / Mouse::Pantalla.y;

  static int dobleClicTime = 0;

  int dobleClicTimeNow;

  if (boton >= -1 && Mouse::MouseState.estado == 0 &&  estado == 1)
    {

      dobleClicTimeNow = glutGet(GLUT_ELAPSED_TIME);
      if (dobleClicTimeNow < (dobleClicTime+250) && (boton != 3) && (boton != 4))
	{
	  Mouse_dobleClic (X, Y, boton);
	  
	  Solar3DWidGetEntorno::ME()->mouseEventosDobleClic(x, y, ClicSolarWidGet);
	      
	}
      else 
	{
	  if (fabs(x-Mouse::MouseState.x_down) < 2.0 && 
	      fabs(y-Mouse::MouseState.y_down) < 2.0)
	    {
	      Mouse_clic(X, Y, boton);
	      Solar3DWidGetEntorno::ME()->mouseEventosClic(x, y, ClicSolarWidGet);
	    }
	  else
	    {
	      Mouse_dragNdrop (X, Y,
			       (float)Mouse::MouseState.x_down / Mouse::Pantalla.x, 
			       (float)Mouse::MouseState.y_down / Mouse::Pantalla.y,
			       boton);
	      Solar3DWidGetEntorno::ME()->mouseEventosDragAndDrop(x, y, 
								  (int)Mouse::MouseState.x_down, 
								  (int)Mouse::MouseState.y_down, 
								  ClicSolarWidGet);
	    }
	}
      dobleClicTime = dobleClicTimeNow;
      Mouse_up (X, Y, boton);
    }

  if (boton >= -1 && Mouse::MouseState.estado == 1 &&  estado == 0)
    {
      Mouse::MouseState.x_down = x;
      Mouse::MouseState.y_down = y;
      Mouse_down (X, Y, boton);
    }

  Mouse_move(X, Y);

  //cout << "Idle" << Solar3DWidGetEntorno::ME()->//Nombre << " :" << Hijos.size() << endl;

  Solar3DWidGetEntorno::ME()->mouseEventosMove(x, y);

  if (boton != -1) Mouse::MouseState.boton = boton;
  if (estado != -1) Mouse::MouseState.estado = estado;

  Mouse::MouseState.x = x;
  Mouse::MouseState.y = y;

}

// ---------------------------------------------------------
int Mouse::Mouse_move (float x, float y)
{
  switch (Eventos::ME()->getRenderModo())
    {
    case(pModoPartida): case(pModoMenu): case(pModoInicio):
      {
	break; 
      }
    case (pModoJuego):
      {
	Eventos::ME()->Mouse_move (x, y);
	break;
      }
    }
 return 0;
}

// ---------------------------------------------------------
int Mouse::Mouse_clic(float x, float y, int boton)
{

  switch (Eventos::ME()->getRenderModo())
    {
    case(pModoPartida): case(pModoMenu): case(pModoInicio):
      {
	break;
      }
    case (pModoJuego):
      {
	Eventos::ME()->Mouse_clic(x, y, boton);
	break;
      }
    }
 return 0;
}


// ---------------------------------------------------------
int Mouse::Mouse_dragNdrop (float x, float y, float x2, float y2, int boton)
{
  switch (Eventos::ME()->getRenderModo())
    {
    case(pModoPartida): case(pModoMenu): case(pModoInicio):
      {    
	break;
      }
    case (pModoJuego):
      {
	Eventos::ME()->Mouse_dragNdrop (x, y, x2, y2, boton);
	break;
      }
    }
 return 0;
}

// ---------------------------------------------------------
int Mouse::Mouse_dobleClic (float x, float y, int boton)
{
  switch (Eventos::ME()->getRenderModo())
    {
     case(pModoPartida): case(pModoMenu): case(pModoInicio):
      {
	break;
      }
    case (pModoJuego):
      {
	Eventos::ME()->Mouse_dobleClic(x, y, boton);
	break;
      }
    }
 return 0;
}


// ---------------------------------------------------------
int Mouse::Mouse_down (float x, float y, int boton)
{
  switch (Eventos::ME()->getRenderModo())
    {
    case(pModoPartida): case(pModoMenu): case(pModoInicio):
      {
	break;
      }
    case (pModoJuego):
      {
	Eventos::ME()->Mouse_down(x, y, boton);
	break;
      }
    }
 return 0;
}


// ---------------------------------------------------------
int Mouse::Mouse_up (float x, float y, int boton)
{

 switch (Eventos::ME()->getRenderModo())
    {
    case(pModoPartida): case(pModoMenu): case(pModoInicio):
      {
	break;
      }
    case (pModoJuego):
      {
	Eventos::ME()->Mouse_up(x, y, boton);
	break;
      }
    }
 return 0;
}
