//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "PanelDeComandos.h"


#include "ejercito.h"

// ---------------------------------------
void PanelDeComandos::Inicia (float PosX, float PosY, float Ancho, float Alto, int ID)
{
  PanelMovible::Inicia(PosX, PosY, Ancho, Alto, ID);


  AddSetDeBotones ("BichoMilitarSet");
  AddBoton ("Hud/Yens/ataque.tga", PanelClicAtaque, 0);
  AddBoton ("Hud/Yens/alto.tga", PanelClicAlto, 0);
  AddBoton ("Hud/Yens/guardia.tga", PanelClicGuardia, 0);


  AddSetDeBotones ("EdificioCreacionDeBichos");
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicNuevoBicho01, 1);
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicNuevoBicho02, 1);
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicNuevoBicho03, 1);
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicNuevoBicho04, 1);
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicNuevoBicho05, 1);
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicNuevoBicho06, 1);
  AddBoton ("Hud/Yens/banderita.tga", PanelClicBandera, 1);

  unsigned int i;

  AddSetDeBotones ("BichoConstructorSet01");
  for (i = 0 ; i < MaxBotonesEdificios ; i++)
    {
        AddBoton ("Hud/Yens/nuevoBicho.tga", (i + PanelClicNuevoEdificio), 2);
    }
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicSiguiente, 2);

  AddSetDeBotones ("BichoConstructorSet02");

  for (i = 0 ; i < MaxBotonesEdificios ; i++)
    {
        AddBoton ("Hud/Yens/nuevoBicho.tga", (i + PanelClicNuevoEdificio) + MaxBotonesEdificios, 3);
    }
  AddBoton ("Hud/Yens/nuevoBicho.tga", PanelClicSiguiente, 3);

  BotonAgresivo = false;
  BotonGuardia = false;
  BotonBandera = false;

  BotonNuevoEdificio = 0;
  PanelDeCostructorActivo = 0;

}


// ---------------------------------------
int PanelDeComandos::Mouse_down (float x, float y, int boton)
{

 int PanelBoton = PanelMovible::Mouse_down(x, y, boton);

 // Originalmente Mouse_clic regresa el ID del BotonClicqueado, pero vamos 
 // a forzar a que ahora regrese el ID del Panel.

 if (PanelBoton != 0)
   {
     return IDPanelDeControl;
   }
 else
   {
     return 0;
   }
}


// ---------------------------------------
int PanelDeComandos::Mouse_clic (float x, float y, int boton)
{
  
 int PanelBoton = PanelMovible::Mouse_clic(x, y, boton);


 oEdificio* Edificio = Ejercito::EdificioSelecionado;

 switch (PanelBoton)
    {
    case -1: case 0:
      {
	break;
      }
    case PanelClicAlto:
      {
	vector<oSoldado*>::iterator Bicho;
	vector<oSoldado*> *EjeX = Ejercito::TodosLosEjercitos.begin()->getEjercito();
	for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
	  { //Ponemos en modo Quieto a todos los Bichos seleccionados.
	    
	    if ((*Bicho)->Seleccionado)
	      {
		(*Bicho)->setModo(ModoQuieto, 0.0, 0.0, 0, (*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y);
	      }
	  }
	break;
      }
    case PanelClicAtaque:
      {
	BotonAgresivo = true;
	break;
      }
    case PanelClicGuardia:
      {
	BotonGuardia = true;
	break;
      }
    case PanelClicNuevoBicho01:
      {
	if (Edificio != (oEdificio*)NULL)
	  {
	    int Respuesta = Edificio->nuevoBicho(Edificio->getUnidades()[0]->ID);
	    MensajeBoton(Respuesta);
	  }
	break;
      }

    case PanelClicNuevoBicho02:
      {
	if (Edificio != (oEdificio*)NULL)
	  {
	    int Respuesta = Edificio->nuevoBicho(Edificio->getUnidades()[1]->ID);
	    MensajeBoton(Respuesta);
	  }
	break;
      }
      
    case PanelClicNuevoBicho03:
      {
	if (Edificio != (oEdificio*)NULL)
	  {
	    
	    int Respuesta = Edificio->nuevoBicho(Edificio->getUnidades()[2]->ID);
	    MensajeBoton(Respuesta);
	    
	  }
	break;
      }

  case PanelClicNuevoBicho04:
      {
	if (Edificio != (oEdificio*)NULL)
	  {
	    
	    int Respuesta = Edificio->nuevoBicho(Edificio->getUnidades()[3]->ID);
	    MensajeBoton(Respuesta);
	    
	  }
	break;
      }

  case PanelClicNuevoBicho05:
      {
	if (Edificio != (oEdificio*)NULL)
	  {
	    
	    int Respuesta = Edificio->nuevoBicho(Edificio->getUnidades()[4]->ID);
	    MensajeBoton(Respuesta);
	    
	  }
	break;
      }

  case PanelClicNuevoBicho06:
      {
	if (Edificio != (oEdificio*)NULL)
	  {
	    
	    int Respuesta = Edificio->nuevoBicho(Edificio->getUnidades()[5]->ID);
	    MensajeBoton(Respuesta);
	    
	  }
	break;
      }
      
    case PanelClicBandera:
      {
	BotonBandera = true;
	break;
      }

    case PanelClicSiguiente:
      {
	if (PanelDeCostructorActivo == 0)
	  {
	    PanelDeCostructorActivo = 1;
	  }
	else
	  {
	    PanelDeCostructorActivo = 0;
	  }
	break;
      }

    default:
      {
	BotonNuevoEdificio = PanelBoton;
	cout << "BotonNuevoEdificio: " << BotonNuevoEdificio << endl;

	int Respuesta = ValidaNuevoEdificio(BotonNuevoEdificio-PanelClicNuevoEdificio+1);

	if (Respuesta != NuevoEdificioError_TodoOK)
	  {
	    MensajeBoton(Respuesta);
	    BotonNuevoEdificio = 0;
	  }

	break;
      }
    }


 // Originalmente Mouse_clic regresa el ID del BotonClicqueado, pero vamos 
 // a forzar a que ahora regrese el ID del Panel.

 if (PanelBoton != 0)
   {
     return IDPanelDeControl;
   }
 else
   {
     return 0;
   }
 
}

// ---------------------------------------------------------
int PanelDeComandos::ValidaNuevoEdificio (int Tipo)
{
  int costo = 0;

    for (int X = 0 ; X < Ejercito::TodosLosEjercitos.begin()->getArmy()->getNumConstrucciones(); X++)
    {
      if (Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].ID == Tipo)  
	{
	  costo = Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].costo;
	  cout << "Costo: " << costo << endl;
	  
	  if ((Ejercito::TodosLosEjercitos.begin()->getRecursos()->getRecursosCombustible() - costo) > 0)
	    {
	      return NuevoEdificioError_TodoOK;  
	    }
	  else
	    {
	      return NuevoEdificioError_NoHayRecursos;
	    }
	}	
    }
  War3DWarning("OSOLDADOCONSTRUCTOR", "Intentando crear un edificio de tipo no valido, consulta con Zeru");
  return  NuevoEdificioError_BichoNoValido;
}

// ---------------------------------------------------------
int PanelDeComandos::Mouse_move (float x, float y)
{
  int BotonID = PanelMovible::Mouse_move (x, y);

  Costos = "";

  if(BotonID != 0)
    {

      oEdificio* Edificio = Ejercito::EdificioSelecionado;
      if (Edificio != (oEdificio*)NULL)
	{
	  switch(BotonID)
	    {
	    case PanelClicNuevoBicho01:
	      {
		Costos = zitoa(Edificio->getCostoUnidad(Edificio->getUnidades()[0]->ID)) + "/0";
		break;
	      }
	    case PanelClicNuevoBicho02:
	      {
		Costos = zitoa(Edificio->getCostoUnidad(Edificio->getUnidades()[1]->ID)) + "/0";
		break;
	      }
	    case PanelClicNuevoBicho03:
	      {
		Costos = zitoa(Edificio->getCostoUnidad(Edificio->getUnidades()[2]->ID)) + "/0";
		break;
	      }
	    case PanelClicNuevoBicho04:
	      {
		Costos = zitoa(Edificio->getCostoUnidad(Edificio->getUnidades()[3]->ID)) + "/0";
		break;
	      }
	    case PanelClicNuevoBicho05:
	      {
		Costos = zitoa(Edificio->getCostoUnidad(Edificio->getUnidades()[4]->ID)) + "/0";
		break;
	      }
	    }
	}

      oSoldado * Bicho;
      Bicho = Ejercito::BichoSeleccionado;
      if (Bicho != (oSoldado*) NULL)
	{
	  if(Bicho->getTipo() == 1)
	    {
	      int  Tipo = BotonID-PanelClicNuevoEdificio+1;
	      for (int X = 0 ; X < Ejercito::TodosLosEjercitos.begin()->getArmy()->getNumConstrucciones(); X++)
		{
		  if (Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].ID == Tipo)  
		    {
		      Costos = zitoa(Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].costo) + "/0";
		    }	
		}
	    }
	}
    }

  MousePos.x = x;
  MousePos.y = y;

  return  0;
}


// ---------------------------------------------------------
void PanelDeComandos::DibujaCursorEdificio(rendereable *ModeloEdificio, float x, float y)
{

  float zoom = ModeloEdificio->getRadio() / 0.08; // Este numero se obtuvo experimentalmente
  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0, zoom, 0, zoom, -10, 10);
  glMatrixMode(GL_MODELVIEW);  // Escogemos la matriz de vista
  glLoadIdentity();
  glDisable(GL_LIGHTING);
  glEnable(GL_TEXTURE_2D);

  glPushMatrix();

  glTranslatef((x) * zoom,(1.0 - (y)) * zoom, 0.1);

  glRotatef(90, 0.5, 0.8, 0.0);  

  static float AnguloDeBicho;

  AnguloDeBicho = AnguloDeBicho + 12.0/Retardo;
  
  glRotatef((int)AnguloDeBicho%360, 0.0, 1.0, 0.0);
  
  glColor4f(1.0, 1.0, 1.0, 0.5);
  ModeloEdificio->dibujame(0.0, 0.0, 0.0, 1, 0.0, 0.0);

  glPopMatrix();
}

// ---------------------------------------------------------
void PanelDeComandos::MensajeBoton(int Respuesta)
{
  switch (Respuesta)
    {
    case NuevoBichoError_TodoOK:
      {
	break;
      }
    case NuevoBichoError_MuchoEnCola:
      {
	Errores->Escribe(0.60 , 0.95, "Lista de espera llena", 7);
	break;
      }
    case NuevoBichoError_NoHayRecursos:
      {
	Errores->Escribe(0.60 , 0.95, "No hay recursos", 7);
	break;
      }
    case NuevoBichoError_EdificioNoTerminado:
      {
	Errores->Escribe(0.60 , 0.95, "Edificio no terminado", 7);
	break;
      }
    case NuevoBichoError_LimiteDePoblacion:
      {
	Errores->Escribe(0.60 , 0.95, "Necesitas mas estacias", 7);
	break;
      }
    case NuevoBichoError_BichoNoValido:
      {
	Errores->Escribe(0.60 , 0.95, "Error interno [Reportalo]", 7);
	break;
      }
    }
}

// ---------------------------------------
void PanelDeComandos::AddBoton (string Textura, int ID, int numSetDeBotones)
{

  const int Separador = 2;
  const int Cuadrito = 14;

  if (numSetDeBotones > -1 && numSetDeBotones < (int)SetDeBotones.size())  
    {
      
      float PosX = ((Cuadrito + Separador) * 1 * Pixel_H + Pixel_H) + 
	((Cuadrito + Separador) * 2 * Pixel_H) * (SetDeBotones[numSetDeBotones].size() % 3);
      float PosY = ((Cuadrito + Separador) * 5 * Pixel_V + Pixel_V) +
	((Cuadrito + Separador) * 2 * Pixel_V) * (SetDeBotones[numSetDeBotones].size() / 3);
      
      Boton NuevoBoton(Textura, PosX, PosY, 
		       ((Cuadrito * 2 + Separador) * Pixel_H),
		       ((Cuadrito * 2 + Separador) * Pixel_V),
		       ID);
      
      SetDeBotones[numSetDeBotones].push_back(NuevoBoton);
    }
  else
    {
      War3DError ("PANELDECOMANDOS", "Intento de agregar un nuevo boton aun un set de botones inexistente");
    }

}



// ---------------------------------------
// Funciones Extras
// ---------------------------------------
void PanelDeComandos::Update()
{

  oEdificio* Edificio = Ejercito::EdificioSelecionado;
  oSoldado* Bicho = Ejercito::BichoSeleccionado;

  SetDeBotnesActivo = -1;

  if (Bicho != (oSoldado*) NULL)
    {
      if(Bicho->getTipo() == 1)
	{
	  // El bicho seleccionado es un costructor
	  SetDeBotnesActivo = 2 + PanelDeCostructorActivo;
	  
	  int Contador = PanelDeCostructorActivo * MaxBotonesEdificios;
	  
	  vector<Boton>::iterator Bot;

	  for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
	    {
	      Bot->Activo = false;
	      if (Contador == MaxBotonesEdificios * (PanelDeCostructorActivo+1))
		{
		  Bot->Activo = true;
		  break; 
		}

	      for (int X = 0 ; X < Ejercito::TodosLosEjercitos.begin()->getArmy()->getNumConstrucciones(); X++)
		{
		  if (Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].ID == Contador + 1)  
		    {
		      Bot->Activo = true;
		      Bot->setTexturaNueva(Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].MiniFoto); 
		      break;    
		    }	
		}
	      Contador ++;
	    }
	}
      else
	{
	  // El bicho seleccionado es militar
	  SetDeBotnesActivo = 0;
	}
    }
  else if(Edificio != (oEdificio*) NULL)
    {
      SetDeBotnesActivo = 1;

      int Contador = 0;
      
      vector<Boton>::iterator Bot;
      for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
	{
	  if (Edificio->getNumUnidades() > Contador|| Contador > 5)
	    {
	      Bot->Activo = true;
	      if (Edificio->getNumUnidades() > Contador)
		{
		  Bot->setTexturaNueva(Edificio->getUnidades()[Contador]->MiniFoto);
		}
	    }
	  else
	    {
	      Bot->Activo = false;
	    }
	  
	  Contador ++;
	}

    }

}



// ---------------------------------------
void PanelDeComandos::Dibujame ()
{
  PanelMovible::Dibujame();

  for (int X = 0 ; X < Ejercito::TodosLosEjercitos.begin()->getArmy()->getNumConstrucciones(); X++)
    {
      if (Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].ID == BotonNuevoEdificio-PanelClicNuevoEdificio+1)  
	{
	  
	  DibujaCursorEdificio(Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].Modelo, MousePos.x, MousePos.y);
	  return;
	}	
    }

  DibujaCostos();
}


// ---------------------------------------
void PanelDeComandos::ResetPresionados()
{
  BotonAgresivo = false;
  BotonGuardia = false;
  BotonBandera = false;

  BotonNuevoEdificio = 0;

}


// ---------------------------------------
void PanelDeComandos::DibujaCostos()
{
 
  const int Separador = 2;
  const int Cuadrito = 14;

  if (Costos.length()!= 0)
    {

      float PosX;
      float PosY;
      PosX = ((Cuadrito + Separador) * 2 * Pixel_H + Pixel_H) + PosicionDelPanel.x;	 
      PosY = ((Cuadrito + Separador) * 3 * Pixel_V + Pixel_V) + PosicionDelPanel.y;
      TextServer.Escribe (Costos, PosX, PosY, 5, 1, 0.7, 0.7, 1.0, Alpha);

    }

}
