//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "PanelDeMiniMapa.h"

#include "ejercito.h"

#include "eventos.h"
#include "navegacion.h"
#include "Mouse.h"


#define ZoomEstatico 0.8

// ---------------------------------------
void PanelDeMiniMapa::Inicia (float PosX, float PosY, float Ancho, float Alto, int ID)
{
  PanelMovible::Inicia(PosX, PosY, Ancho, Alto, ID);


  dibujo = new GLubyte [MiniMapaResolucion*MiniMapaResolucion*3];
  mapaescenario = new GLubyte [MiniMapaResolucion*MiniMapaResolucion*3]; 
  
  memset(dibujo, 0, MiniMapaResolucion*MiniMapaResolucion*3); 
  
  glGenTextures(1, &GLTextura);
  glBindTexture(GL_TEXTURE_2D,  GLTextura); 
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, MiniMapaResolucion, MiniMapaResolucion, 0, GL_RGB, GL_UNSIGNED_BYTE, dibujo);
  
  
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST /*GL_LINEAR*/);		// La m
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST /*GL_LINEAR*/); 
  
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

  Dios.x = 0;
  Dios.y = 0;

}

// ---------------------------------------
void PanelDeMiniMapa::AddBoton (string Textura, int ID, int numSetDeBotones)
{
  
  
}


// ---------------------------------------
int PanelDeMiniMapa::Mouse_clic (float x, float y, int boton)
{
  
  const int Separador = 2;
  const int Cuadrito = 14;


  PanelMovible::Mouse_clic(x, y, boton);
  
  z2DVector Pantalla = Mouse::ME()->getPantalla();
  strLocalizacion Localizacion = Navegacion::ME()->getLocalizacion();
  
  z3DVector Centro;
  
  Centro.x = PosicionDelPanel.x + ((Cuadrito + Separador) * 1 * Pixel_H + Pixel_H) + (AnchoYAltoDelPanel.x - (Cuadrito + Separador) * 2 * Pixel_H + Pixel_H) / 2.0;
  Centro.y = PosicionDelPanel.y + ((Cuadrito + Separador) * 1 * Pixel_V + Pixel_V) + (AnchoYAltoDelPanel.y - (Cuadrito + Separador) * 5 * Pixel_V + Pixel_V) / 2.0;


  float yy1 = (y-Centro.y) / ((AnchoYAltoDelPanel.y - (Cuadrito + Separador) * 5 * Pixel_V + Pixel_V));
  float xx1 = (x-Centro.x) / ((AnchoYAltoDelPanel.x - (Cuadrito + Separador) * 2 * Pixel_H + Pixel_H));


  if (xx1 > 0.5 || xx1 < -0.5 || yy1 > 0.5 || yy1 < -0.5) return IDPanelDeMiniMapa;

  
  float xx2 = +zsin(Localizacion.AngVista) * yy1 + zcos(Localizacion.AngVista) * xx1;
  float yy2 = +zcos(Localizacion.AngVista) * yy1 - zsin(Localizacion.AngVista) * xx1;

  cout << xx2 << " " << yy2 << endl;

  if (xx2 < (ZoomEstatico/2.0) && xx2 > (-ZoomEstatico/2.0))
    {
      if (yy2 < (ZoomEstatico/2.0) && yy2 > (-ZoomEstatico/2.0))
      {			


	xx2 = xx2 / ZoomEstatico;
	yy2 = yy2 / ZoomEstatico;

	xx2 = (xx2+0.5) * Tierra::ME()->getAncho() / Densidad;
	yy2 = (yy2+0.5) * Tierra::ME()->getAlto() / Densidad;
	
	Navegacion::ME()->setLocalizacion(xx2, yy2);
	
	cout << "ok" << endl;
      }
    }

  return IDPanelDeMiniMapa;
}



// ---------------------------------------
// ---------------------------------------
void PanelDeMiniMapa::Dibujame ()
{
  PanelMovible::Dibujame();

  strLocalizacion Localizacion = Navegacion::ME()->getLocalizacion();
  Dios.x = Localizacion.TierraX;
  Dios.y = Localizacion.TierraY;

  DibujaMapa(Localizacion.AngVista);
}


// ---------------------------------------
void PanelDeMiniMapa::DibujaMapa (float angulo)
{

  Refresaca();
  
  z2DVector Pantalla = Mouse::ME()->getPantalla();


  const int Separador = 2;
  const int Cuadrito = 14;

  glViewport((int)((PosicionDelPanel.x + (Cuadrito + Separador) * 1 * Pixel_H + Pixel_H) *Pantalla.x), 
	     (int)((1.0-PosicionDelPanel.y - AnchoYAltoDelPanel.y + (Cuadrito + Separador) * 4 * Pixel_V+ Pixel_V) *Pantalla.y), 
	     (int)((AnchoYAltoDelPanel.x - (Cuadrito + Separador) * 2 * Pixel_H + Pixel_H) *Pantalla.x),
	     (int)((AnchoYAltoDelPanel.y - (Cuadrito + Separador) * 5 * Pixel_V+ Pixel_V) *Pantalla.y));
 
  glPushMatrix();

  //glTranslatef(PosicionDelPanel.x + 0.1875/2.0, PosicionDelPanel.y + 0.29166/2.0, 0.0);

  glTranslatef(0.5, 0.5, 0.0);

  glRotatef(angulo, 0.0, 0.0, 1.0);
  
  glEnable(GL_TEXTURE_2D);
  glColor4f(1.0, 1.0, 1.0, 0.9);
  glBindTexture(GL_TEXTURE_2D,  GLTextura); 
  
  glBegin(GL_QUADS);
  {
    
    glTexCoord2f(0,0);
    glVertex2f(-ZoomEstatico/2, -ZoomEstatico/2);

    glTexCoord2f(1,0);
    glVertex2f( ZoomEstatico/2, -ZoomEstatico/2);

    glTexCoord2f(1,1);
    glVertex2f( ZoomEstatico/2,  ZoomEstatico/2);

    glTexCoord2f(0,1);	
    glVertex2f(-ZoomEstatico/2,  ZoomEstatico/2);	
  }
  glEnd();

  float xx = (((Dios.x*Densidad)/Tierra::ME()->getAncho()) *  ZoomEstatico) - ZoomEstatico/2;
  float yy = (((Dios.y*Densidad)/Tierra::ME()->getAlto()) * ZoomEstatico)- ZoomEstatico/2;

  glDisable(GL_TEXTURE_2D);
      
  glColor4f(1.0, 1.0, 1.0, 0.25);
  glBegin(GL_QUADS);
  {
    glVertex2f(-2.5/Tierra::ME()->getAncho()+xx, -2.5/Tierra::ME()->getAlto()+yy);
    glVertex2f( 2.5/Tierra::ME()->getAncho()+xx, -2.5/Tierra::ME()->getAlto()+yy);
    glVertex2f( 2.5/Tierra::ME()->getAncho()+xx,  2.5/Tierra::ME()->getAlto()+yy);
    glVertex2f(-2.5/Tierra::ME()->getAncho()+xx,  2.5/Tierra::ME()->getAlto()+yy);
  }
  glEnd();

  glPopMatrix();

  glViewport(0, 0, (int)Pantalla.x, (int)Pantalla.y);

}


void PanelDeMiniMapa::Refresaca()
{
  PutEjercitos();
  PutFogWar();
  PutRecursos();

  glBindTexture(GL_TEXTURE_2D,  GLTextura);
  glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, MiniMapaResolucion, MiniMapaResolucion, GL_RGB, GL_UNSIGNED_BYTE, dibujo);

}

// -----------------------
void PanelDeMiniMapa::PutPixel(unsigned int x, unsigned int y, GLubyte R, GLubyte G, GLubyte B, GLubyte * Mapa)
{

  if (x<MiniMapaResolucion && y<MiniMapaResolucion)
    {
      Mapa[(y*MiniMapaResolucion + x)*3+0]=R;
      Mapa[(y*MiniMapaResolucion + x)*3+1]=G;
      Mapa[(y*MiniMapaResolucion + x)*3+2]=B;
    }
}


// -----------------------
void PanelDeMiniMapa::PutEcenario()
{

  verticeTierra *v=(verticeTierra *)Tierra::ME()->getVertices();
  

  int x, y;

  for(x=0; x<MiniMapaResolucion; x++)
    {
      for (y=0; y<MiniMapaResolucion; y++)
	{
	  if (v[(y*Tierra::ME()->getAlto() / MiniMapaResolucion)*Tierra::ME()->getAncho() + (x*Tierra::ME()->getAncho() / MiniMapaResolucion)].ObjetosMap != NULL)
	    {
	      
	      PutPixel(x, y, 60, 60, 60, mapaescenario);
	      
	    }
	  else
	    {
	      int Gris = 50 + (int)(100 * (v[(y*Tierra::ME()->getAlto() / MiniMapaResolucion)*Tierra::ME()->getAncho() + (x*Tierra::ME()->getAncho() / MiniMapaResolucion)].Altura));
	      PutPixel(x, y, Gris, Gris, Gris, mapaescenario);
	    }  
	  
	}
    }
}

// -----------------------
void PanelDeMiniMapa::PutRecursos()
{

  int x, y;
  int xx, yy;

  vector<RecursoCombustible>::iterator Ite;

  for(x=0; x<MiniMapaResolucion; x++)
    { 
      for (y=0; y<MiniMapaResolucion; y++)
	{
	  for(Ite = Recursos::ME()->TodosLosRecursos.begin() ; Ite != Recursos::ME()->TodosLosRecursos.end() ; Ite++)
	    {
	      xx = (int)(((Ite->localizacion.x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	      yy = (int)(((Ite->localizacion.y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	      PutPixel(xx, yy, 255, 255, 255, dibujo);
	    }
	}
    }
}

void PanelDeMiniMapa::PutFogWar()
{

  int x, y;
  int xx, yy;


  vector<Ejercito>::iterator Ejers;
  Ejers = Ejercito::TodosLosEjercitos.begin();
  
  int Radio1 = (int)((MiniMapaResolucion*0.25)*(MiniMapaResolucion*0.25));
  int Radio2 = (int)(Radio1 * 1.6 * 1.6);

  for(x=0; x<MiniMapaResolucion; x++)
    {
      for (y=0; y<MiniMapaResolucion; y++)
	{
	  if (!Tierra::ME()->fow.GetPoint((x*Tierra::ME()->getAncho() / MiniMapaResolucion),(y*Tierra::ME()->getAlto() / MiniMapaResolucion)))
	    {
	      PutPixel(x, y, 60, 60, 100, dibujo);
	    }


          xx = (x-(int)(((Ejers->getBaseLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion))*
	    (x-(int)(((Ejers->getBaseLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion));
	  yy = (y-(int)(((Ejers->getBaseLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion))*
	    (y-(int)(((Ejers->getBaseLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion));
	  

	  if(xx+yy >= Radio1)
	    {
	      if(xx+yy <= Radio2)
		{
		  if (dibujo[(y*MiniMapaResolucion + x)*3+2] + 40 < 255)
		    {
		      dibujo[(y*MiniMapaResolucion + x)*3+2]= dibujo[(y*MiniMapaResolucion + x)*3+2] + 40;
		    }
		  else
		    {
		      dibujo[(y*MiniMapaResolucion + x)*3+2]=255;
		    }
		}
	    }


	}
    }

}




// -----------------------
void PanelDeMiniMapa::PutEjercitos()
{
  
  vector<Ejercito>::iterator Ejers;
  vector<oSoldado*> *EjeX;
  vector<oSoldado*>::iterator Bicho;
  vector<oEdificio*> *EdiX;
  vector<oEdificio*>::iterator EdiIte;

  int xx;
  int yy;

  int Color;


  memcpy(dibujo, mapaescenario, MiniMapaResolucion*MiniMapaResolucion*3);

 
  


  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      
  
      if (Ejers->getMiejercito())
	{
	  Color = 150;
	}
      else
	{
	  Color = 200;
	}
      EjeX = Ejers->getEjercito();
      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
	{

	  xx = (int)((((*Bicho)->getLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  yy = (int)((((*Bicho)->getLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  PutPixel(xx, yy, 200, Color, 150, dibujo);
	}

      EdiX = Ejers->getEdificios();
      for (EdiIte=EdiX->begin(); EdiIte != EdiX->end(); EdiIte++)
	{
	  xx = (int)((((*EdiIte)->getLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  yy = (int)((((*EdiIte)->getLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  PutPixel(xx, yy, Color, 150, 200, dibujo);
	    

	}
      
    }

}
