//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "PanelMovible.h"

// -----------------------------------------
PanelMovible::PanelMovible()
{
  TexturaDelPanelInicializada = false; 
  ArrastrandoPanel = false;

  FijarInicializada = false; 
  PanelFijo = true;
  Alpha = 0.6;

}


// -----------------------------------------
void PanelMovible::Inicia (float PosX, float PosY, float Ancho, float Alto, int ID)
{

  PosicionDelPanel.x = PosX;
  PosicionDelPanel.y = PosY; 

  AnchoYAltoDelPanel.x = Ancho;
  AnchoYAltoDelPanel.y = Alto;

  this->ID = ID;

  SetDeBotnesActivo = -1;

  Errores = new TextoTemporal2;

}


// -----------------------------------------
void PanelMovible::setTextura (string Textura, float SobranteAncho, float SobranteAlto)
{

  TexturaDelPanel = ServidorDeTexturas::ME()->Nueva(Textura.c_str());
  SobrantesDeLaTextura.x = SobranteAncho;
  SobrantesDeLaTextura.y = SobranteAlto;
  TexturaDelPanelInicializada = true;
}


// -----------------------------------------
void PanelMovible::setFijar (string Textura, float PosX, float PosY, float Ancho, float Alto)
{
  botFijar = new Boton(Textura, PosX, PosY, Ancho, Alto, BotonFijarPanel);
  FijarInicializada = true;
}



// -----------------------------------------
void PanelMovible::DibujameFondo()
{
  
  if (!PanelFijo) Alpha = 1.0;


  if (Mouse.x > PosicionDelPanel.x && Mouse.x < (PosicionDelPanel.x +AnchoYAltoDelPanel.x))
    {
      if (Mouse.y > PosicionDelPanel.y && Mouse.y < (PosicionDelPanel.y +AnchoYAltoDelPanel.y))
	{
	  Alpha = 1.0;
	}
    }
 

  miVistaGL.setVista(VistaGL_Ortogonal);

  glPushMatrix();

  glTranslatef(PosicionDelPanel.x, PosicionDelPanel.y, 0);
  
  glColor4f(1.0, 1.0, 1.0, Alpha);

  if (TexturaDelPanelInicializada)
    {
      glEnable(GL_TEXTURE_2D);

      if (!configuracion::Debug)
	{
	  TexturaDelPanel.usaGLTextura(TextAltaCalidad);
	}
      else
	{
	  TexturaDelPanel.usaGLTextura(TextBajaCalidad);
	}
    }

  glBegin (GL_QUADS);
  { 
    glTexCoord2f(0, 1.0);
    glVertex2f(0.0,                  0.0);

    glTexCoord2f(1.0 - SobrantesDeLaTextura.x, 1.0);
    glVertex2f(AnchoYAltoDelPanel.x, 0.0); 

    glTexCoord2f(1.0 - SobrantesDeLaTextura.x, SobrantesDeLaTextura.y);
    glVertex2f(AnchoYAltoDelPanel.x, AnchoYAltoDelPanel.y);

    glTexCoord2f(0.0,                          SobrantesDeLaTextura.y);
    glVertex2f(0.0,                  AnchoYAltoDelPanel.y); 
  }
  glEnd();


  if (FijarInicializada)
    { 
      botFijar->Dibujame(0.9);
    }

  glPopMatrix();

}



// -----------------------------------------
void PanelMovible::DibujameBotones()
{


  miVistaGL.setVista(VistaGL_Ortogonal);

  glPushMatrix();

  glTranslatef(PosicionDelPanel.x, PosicionDelPanel.y, 0);

  int SetDeBotonesActivo = getSetDeBotnesActivo();
  if (SetDeBotonesActivo > -1 && SetDeBotonesActivo < (int)SetDeBotones.size())
    {
      vector<Boton>::iterator Bot;
      for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
	{
	  if (Bot->Activo)
	    {
	      Bot->Dibujame(0.9);
	    }
	}
    }

  glPopMatrix();

}


// -----------------------------------------
void PanelMovible::Dibujame()
{

  Alpha = 0.6;

  DibujameFondo();
  DibujameBotones();
  Errores->Dibujame();
}


// -----------------------------------------
int PanelMovible::Mouse_clic (float x, float y, int boton)
{



  if (x > PosicionDelPanel.x && x < (PosicionDelPanel.x +AnchoYAltoDelPanel.x))
    {
      if (y > PosicionDelPanel.y && y < (PosicionDelPanel.y +AnchoYAltoDelPanel.y))
	{  

	  x = x - PosicionDelPanel.x;
	  y = y - PosicionDelPanel.y;

	  int SetDeBotonesActivo = getSetDeBotnesActivo();
	  if (SetDeBotonesActivo > -1 && SetDeBotonesActivo < (int)SetDeBotones.size())
	    {
	      
	      vector<Boton>::iterator Bot;
	      
	      if (boton == 0)
		{
		  for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
		    {
		      if (y > Bot->PosicionDelBoton.y && y < Bot->PosicionDelBoton.y+Bot->AnchoYAltoBoton.y)
			{
			  if (x > Bot->PosicionDelBoton.x && x < Bot->PosicionDelBoton.x+Bot->AnchoYAltoBoton.x)
			    {
			      if (Bot->Activo)
				{
				  Bot->Pres = 1.0;
				  return Bot->ID;
				}
			    }
			}
		    }
		}
	    }



	  if (FijarInicializada)
	    {
	      if (y > botFijar->PosicionDelBoton.y && y < botFijar->PosicionDelBoton.y+botFijar->AnchoYAltoBoton.y)
		{ 
		  if (x > botFijar->PosicionDelBoton.x && x < botFijar->PosicionDelBoton.x+botFijar->AnchoYAltoBoton.x)
		    { 

		      if (botFijar->Activo)
			{
			  botFijar->Pres = 1.0;
			  PanelFijo = !PanelFijo;
			}
		    }
		}
	    }



	  cout << "Clic en Zona de arrastre" << endl;
	  return ClicZonaDeArrastre;
	}
    }

  return 0;  
}


// -----------------------------------------
int PanelMovible::Mouse_move (float x, float y)
{


  int BotonID = 0;

  Mouse.x = x;
  Mouse.y = y;

  if (ArrastrandoPanel && !PanelFijo)
    {

      if ((x - PuntoDeArrastre.x) < 0)
	{
	  x = PuntoDeArrastre.x;
	}
      
      if (((x - PuntoDeArrastre.x) + AnchoYAltoDelPanel.x) > 1.0)
	{
	  x = PuntoDeArrastre.x + (1.0 - AnchoYAltoDelPanel.x);
	}
      
      
      
      if ((y - PuntoDeArrastre.y) < 0)
	{
	  y = PuntoDeArrastre.y;
	}
      
      if (((y - PuntoDeArrastre.y) + AnchoYAltoDelPanel.y) > 1.0)
	{
	  y = PuntoDeArrastre.y + (1.0 - AnchoYAltoDelPanel.y);
	}

      setPosPanelDeComandos (x - PuntoDeArrastre.x , y - PuntoDeArrastre.y);
      return ID;
    }
  

  x = x - PosicionDelPanel.x;
  y = y - PosicionDelPanel.y;

  int SetDeBotonesActivo = getSetDeBotnesActivo();
  if (SetDeBotonesActivo > -1 && SetDeBotonesActivo < (int)SetDeBotones.size())
    {
      
      vector<Boton>::iterator Bot;
      

      for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
	{

	  Bot->DebajoDelMouse = false;

	  if (y > Bot->PosicionDelBoton.y && y < Bot->PosicionDelBoton.y+Bot->AnchoYAltoBoton.y)
	    {
	      if (x > Bot->PosicionDelBoton.x && x < Bot->PosicionDelBoton.x+Bot->AnchoYAltoBoton.x)
		{
		  if (Bot->Activo)
		    {
		      BotonID = Bot->ID;
		      Bot->DebajoDelMouse = true;
		    }
		}
	    }
	}
    }

  if (FijarInicializada)
    {

      botFijar->DebajoDelMouse = false;
    
      if (y > botFijar->PosicionDelBoton.y && y < botFijar->PosicionDelBoton.y+botFijar->AnchoYAltoBoton.y)
	{ 
	  if (x > botFijar->PosicionDelBoton.x && x < botFijar->PosicionDelBoton.x+botFijar->AnchoYAltoBoton.x)
	    { 
	      if (botFijar->Activo)
		{
		  botFijar->DebajoDelMouse = true;
		}
	    }
	}
    }
    
  
  return BotonID;
}


// -----------------------------------------
int PanelMovible::Mouse_down (float x, float y, int boton)
{
  if (x > PosicionDelPanel.x && x < (PosicionDelPanel.x +AnchoYAltoDelPanel.x))
    {
      if (y > PosicionDelPanel.y && y < (PosicionDelPanel.y +AnchoYAltoDelPanel.y))
	{
	  
	  x = x - PosicionDelPanel.x;
	  y = y - PosicionDelPanel.y;

	  if (boton == 0)
	    {
	      
	      int SetDeBotonesActivo = getSetDeBotnesActivo();
	      if (SetDeBotonesActivo > -1 && SetDeBotonesActivo < (int)SetDeBotones.size())
		{
		  vector<Boton>::iterator Bot;
		  for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
		    {
		      if (y > Bot->PosicionDelBoton.y && y < Bot->PosicionDelBoton.y+Bot->AnchoYAltoBoton.y)
			{
			  if (x > Bot->PosicionDelBoton.x && x < Bot->PosicionDelBoton.x+Bot->AnchoYAltoBoton.x)
			    {
			      if (Bot->Activo)
				{
				  return Bot->ID;
				}
			    }
			}
		    }
      
		}

	      if (!PanelFijo)
		{

		  cout << "Mouse_down en Zona de arrastre" << endl;
	      
		  PuntoDeArrastre.x = x;
		  PuntoDeArrastre.y = y;
		  ArrastrandoPanel = true;
	      
		  return ID;
		}
	    }

	}
    }
  return 0; 
}
 

// -----------------------------------------
int PanelMovible::Mouse_up (float x, float y, int boton)
{
 
  if (ArrastrandoPanel && !PanelFijo)

    {

      if ((x - PuntoDeArrastre.x) < 0)
	{
	  x = PuntoDeArrastre.x;
	}
      
      if (((x - PuntoDeArrastre.x) + AnchoYAltoDelPanel.x) > 1.0)
	{
	  x = PuntoDeArrastre.x + (1.0 - AnchoYAltoDelPanel.x);
	}
            
      if ((y - PuntoDeArrastre.y) < 0)
	{
	  y = PuntoDeArrastre.y;
	}
      
      if (((y - PuntoDeArrastre.y) + AnchoYAltoDelPanel.y) > 1.0)
	{
	  y = PuntoDeArrastre.y + (1.0 - AnchoYAltoDelPanel.y);
	}
      
      setPosPanelDeComandos (x - PuntoDeArrastre.x , y - PuntoDeArrastre.y);
    }

  ArrastrandoPanel = false;


  Update();

  return 0; 
}


// -----------------------------------------
int PanelMovible::AddSetDeBotones (string Nombre)
{
  vector <Boton> NuevoSetDeBotones;
  SetDeBotones.push_back(NuevoSetDeBotones);

  return SetDeBotones.size()-1;
}
