//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

/* ZeruGiran  zerugiran@gmail.com */


#include "W3DPlayer.h"

#include "W3DServer.h"


////////////////////////
W3DPlayer::W3DPlayer(int ID, W3DServer *ServerPadre)
{
  this->ID = ID;
  this->ServerPadre = ServerPadre;
  W3DPlayerComandos.push_back(new W3DPlayerComandoSETARMY((void*)this));
  W3DPlayerComandos.push_back(new W3DPlayerComandoLISTO((void*)this));
  W3DPlayerComandos.push_back(new W3DPlayerComandoNICK((void*)this));
  W3DPlayerComandos.push_back(new W3DPlayerComandoCHAT((void*)this));
  W3DPlayerComandos.push_back(new W3DPlayerComandoINICIA((void*)this));
  W3DPlayerComandos.push_back(new W3DPlayerComandoAGREGAEDIFICIO((void*)this));
  W3DPlayerComandos.push_back(new W3DPlayerComandoAGREGASOLDADO((void*)this));
  W3DPlayerComandos.push_back(new W3DPlayerComandoMOD((void*)this));
  PosIniX = 0;
  PosIniY = 0;
  Admin = false;
  Listo = false;
}

////////////////////////
void W3DPlayer::Send(string Comando)
{
  ServerPadre->ServidorDeSockets.Send(Comando + "\r\n", ID);
  cout << Comando << " | a:" << ID << endl;
}

////////////////////////
void W3DPlayer::ConexionRecive(string Mensaje)
{
  bool Itera = false;
  
  // comunicaciones::Ocupado.Lock();

  // Concatenamos
  Comandos = Comandos + Mensaje;

  int fin;
  string CadenaCompleta;

  // Buscamos en return
  fin = Comandos.find("\r\n");
  // Si no lo encontramos no hacemos nada, en espera de que lleguen mas datos.
  if (fin == (int)string::npos) return;

  // Si encontramos un Fin de linea o return, cortamos hasta encontrar el return
  CadenaCompleta = Comandos.substr(0, fin+2);
  // Y el resto lo dejamos para la siguente.
  Comandos = Comandos.substr(fin+2, 999);


  cout << "W3DComando[" << ID << "]: " << CadenaCompleta;

  vector<W3DPlayerComandoBASE*>::iterator Ite;
  for (Ite = W3DPlayerComandos.begin(); Ite != W3DPlayerComandos.end(); Ite++)
    {

      (*Ite)->Accion(CadenaCompleta);

    }

  fin = Comandos.find("\r\n");
  Itera = fin != (int)string::npos;

  // comunicaciones::Ocupado.UnLock();

  if (Itera) ConexionRecive("");

  return;
}

// --------------------
void W3DPlayer::sendPOSINI()
{
  // TODO ZG. Leer estas posiciones del archivo de mapa y no calcularlas.

  PosIniY = (ServerPadre->W3DPlayers.size()-1)*12000 + 1200;
  PosIniX = 5000;

  Send("POSINI " + zitoa(ID) + " " + zitoa(PosIniX) + " " + zitoa(PosIniY));
}

// --------------------
void W3DPlayer::sendLISTANICKS()
{
  vector<W3DPlayer*>::iterator Cli;
  for (Cli = ServerPadre->W3DPlayers.begin(); Cli != ServerPadre->W3DPlayers.end() ; Cli++)
    {
      // Iteramos por todo los cliente que tenemos conectado y enviamos su ID y su Nick al nuevo.     
      Send (string("LISTANICKS ") + zitoa((*Cli)->ID) + " " + (*Cli)->Nick + " " + (*Cli)->Army);  
    }
}

// --------------------
void W3DPlayer::sendENTRA()
{
  // Avisamos a todo que hay un nuevo cliente
  ServerPadre->ServidorDeSockets.SendMulticast(string("ENTRA ") + zitoa(ID) + "\r\n", ID);
}


// --------------------
void W3DPlayer::sendADMIN()
{
  // Si este player es el primero lo asignamos como admin.
  if (ServerPadre->W3DPlayers.size() == 1)
    {
      Admin = true;
      Send ("ADMIN");
    }
}
