//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

/* ZeruGiran  zerugiran@gmail.com */

#ifndef __W3DServer_h__
#define __W3DServer_h__

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "../constantes.h"

#include <SolarSockets/SolarSockets.h> // Libreria http://solar-opensource.org

#define DiaNoche_Adelanto 110
#define DiaNoche_Dia 200
#define DiaNoche_Noche 65

class W3DServer;

#include "W3DPlayer.h"
#include "../singleton.h"

class W3DServer: public singleton<W3DServer>
{

 public:

  ////// VARIABLES DE LA ISLA //////
 public:
 // En esta variable se almacena el tiempo trasncurrido desde la creacion de la partida
  long int Tiempo;

 public:
  // Lista de habitantes
  vector <W3DPlayer*> W3DPlayers;
  ////// COMUNICACIONES //////  
 public:
  // Servidor de SolarSockets
  ssServer ServidorDeSockets;
 public:
  // Eventos
  bool Recive (string Cadena, int ID, ssServer* Server); 
  void Cierra (int ID, ssServer* Server);
  void Conectado (int ID, ssServer* Server);
  void Error(int ssError, int ID, ssServer* Server);

 private:
  void sendCLIMA(bool Dia, int Duracion);
  void sendRECURSOS(int x, int y, int cantidad);


  ////// METODOS  //////
 private:
  void putRecursos();
  void Clima(int TIncremento);

 public:
  // Inicializacion de la isla.
  W3DServer();
  void Reset();
  void Inicializa();
  void Retardo();

 private:
  ssMutex MutexW3DPlayers;

};

#endif

