// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.

// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

#include "Solar3DWidGetBase.h"

// ---------------------------------------------------------

#include "Solar3DWidGetEntorno.h"

// ---------------------------------------------------------
// ---------------------------------------------------------
// --------------------------------------------------------


// ----------------------------------------------
Solar3DWidGetBase::Solar3DWidGetBase()
{

  Padre = NULL;

  onRender = NULL;

  onMouseClic = NULL;
  onMouseDobleClic = NULL;
  onMouseMove = NULL;
  onMouseDragAndDrop = NULL;
  onChange = NULL;
  onKeyPress = NULL;

  Visible = true;
  Enable = true;

  izq = 0.4;           
  arriba = 0.4;         
  ancho = 0.2;         
  alto = 0.2; 

  IsMouseOver = false;

  ColorNoEnable.setColor(0.4, 0.4, 0.4, 0.4);


}


// ----------------------------------------------
Solar3DWidGetBase::Solar3DWidGetBase(string Nombre, float izq, float arriba, float ancho, float alto)
{

  Padre = NULL;

  onRender = NULL;

  onMouseClic = NULL;
  onMouseDobleClic = NULL;
  onMouseMove = NULL;
  onMouseDragAndDrop = NULL;
  onChange = NULL;
  onKeyPress = NULL;

  Visible = true;
  Enable = true;

  this->Nombre = Nombre;
  this->izq = izq;           
  this->arriba = arriba;         
  this->ancho = ancho;         
  this->alto = alto; 

  IsMouseOver = false;

  ColorNoEnable.setColor(0.4, 0.4, 0.4, 0.4);
}


// ----------------------------------------------
float Solar3DWidGetBase::getIzqAbsoluto()
{
  float Result;
  if (Padre == NULL) Result = izq;
  else Result = Padre->getIzqAbsoluto() + izq;
  return Result;
}

// ----------------------------------------------
float Solar3DWidGetBase::getArribaAbsoluto()
{
  float Result;
  if (Padre == NULL) Result = arriba;
  else Result = Padre->getArribaAbsoluto() + arriba;
  return Result;
}


// ----------------------------------------------
void Solar3DWidGetBase::setColor(float R, float G, float B, float A)
{
  ColorDeFondo.setColor(R, G, B, A);
}

// ----------------------------------------------
void Solar3DWidGetBase::setTexturaDeFondo(string sTextura)
{
  TexturaDeFondo = ServidorDeTexturas::ME()->Nueva(sTextura.c_str());
}


// ----------------------------------------------
void Solar3DWidGetBase::renderFondo()
{

  if (Visible)
    {

      ColorNoEnable.usaColor();    

      if (TexturaDeFondo.isInicializada)
	{
	  // Si el Widget tiene textura la usamos.
	  if (Enable)
	    {	  
	      ColorDeFondo.usaColor();
	    }
	  glEnable(GL_TEXTURE_2D);
	  TexturaDeFondo.usaGLTextura(TextAltaCalidad);
	}
      else
	{
	  // Si el Widget no tiene textura desabilitamos las texturas.
	  glDisable(GL_TEXTURE_2D);
	}
      
      glBegin (GL_QUADS);
      { 
	// Si el Widget tiene textura la usamos.
	if (!TexturaDeFondo.isInicializada && Enable) glColor4f(0.0, 0.0, 0.0, 0.9);
	
	if (TexturaDeFondo.isInicializada) glTexCoord2f(0,1);
	glVertex2f(izq + 00000, arriba + 0000);
	
	if (!TexturaDeFondo.isInicializada && Enable) glColor4f(0.3, 0.3, 1.0, 0.7);
	
	if (TexturaDeFondo.isInicializada) glTexCoord2f(1,1);
	glVertex2f(izq + ancho, arriba + 0000); 
	
	if (TexturaDeFondo.isInicializada) glTexCoord2f(1,0);
	glVertex2f(izq + ancho, arriba + alto);
	
	if (TexturaDeFondo.isInicializada) glTexCoord2f(0,0);
	glVertex2f(izq + 00000, arriba + alto); 
      }
  glEnd();
    }

}

// ----------------------------------------------
void Solar3DWidGetBase::render()
{



  IsMouseOver=false;
  
  if (Solar3DWidGetEntorno::ME()->MouseX > getIzqAbsoluto() && Solar3DWidGetEntorno::ME()->MouseX < getIzqAbsoluto() + ancho)
    {
      if (Solar3DWidGetEntorno::ME()->MouseY > getArribaAbsoluto() && Solar3DWidGetEntorno::ME()->MouseY < getArribaAbsoluto() + alto)
	{
	  IsMouseOver = true;
	}
    }
      

  if (Visible)
    {
      
      renderFondo();    

      if (onRender != NULL) onRender(this);
      
      glPushMatrix();
      glTranslatef(izq, arriba, 0);
      for (vector<Solar3DWidGetBase*>::iterator Ite = Hijos.begin(); Ite != Hijos.end(); Ite++)
	{
		  	   
	  (*Ite)->render();
	}
      glPopMatrix();
    }


  int zError;
  zError = glGetError();
  if(zError!=0){ cout << "Solar3DWidGet " << Nombre << ":" << zError << endl;}



}



// ----------------------------------------------
void Solar3DWidGetBase::agregarHijo(Solar3DWidGetBase* NuevoHijo)
{
  // Lo agregamos a la lista y hacemos el call back
  Hijos.push_back(NuevoHijo);
  NuevoHijo->Padre = this;
}



// ----------------------------------------------
bool Solar3DWidGetBase::conector(Solar3DWidGetMensaje *Mensaje)
{
  bool Afectado = false; 
  bool AfectaHijos = false; 


  if (Visible && Enable)
    {

      // ZG. Miramos si el evento a fecta a este WidGet
      Afectado = Mensaje->afecta(this);

      if (Afectado)
	{ // ZG. Ahora sabemos que el evento si afecto a este WidGet, por tanto tambien sus hijos
	  // tienen que ser afectados.
	  for (vector<Solar3DWidGetBase*>::iterator Ite = Hijos.begin(); Ite != Hijos.end(); Ite++)
	    {
	      AfectaHijos = (*Ite)->conector(Mensaje) || AfectaHijos;
	    }

	  if (!AfectaHijos)
	    { // ZG. Si ninguno de los hijos fue afectado entonces el evento iba explisitamente dirijido a 
	      // este WidGet, por tanto ejecutamos el evento, si es que fue definido.
	      Mensaje->elevaEvento(this);
	    } 
	}
    }

  return Afectado;

}

// ----------------------------------------------
void Solar3DWidGetBase::mouseClic (unsigned int boton, float x, float y)
{
  if (onMouseClic != NULL) 
    { // Si esta definido el evento, lo elevamos.
      onMouseClic(boton, x, y, this);
    }
}

// ----------------------------------------------
void Solar3DWidGetBase::mouseDobleClic(unsigned int boton, float x, float y)
{
  if (onMouseDobleClic != NULL) 
    { // Si esta definido el evento, lo elevamos.
      onMouseDobleClic(boton, x, y, this);
    }
}


// ----------------------------------------------
void Solar3DWidGetBase::mouseMove(float x, float y)
{
  if (onMouseMove != NULL) 
    { // Si esta definido el evento, lo elevamos.
      onMouseMove(x, y, this);
    }
}


// ----------------------------------------------
void Solar3DWidGetBase::mouseDragAndDrop(unsigned int boton, float x, float y, float xorigen, float yorigen)
{
  if (onMouseDragAndDrop != NULL) 
    { // Si esta definido el evento, lo elevamos.
      onMouseDragAndDrop(boton, x, y, xorigen, yorigen, this);
    }
}


// ----------------------------------------------
void Solar3DWidGetBase::change()
{
  if (onChange != NULL)
    { // Si esta definido el evento, lo elevamos.
      onChange(this);
    }
}


// ----------------------------------------------
void Solar3DWidGetBase::keyPress(const char key)
{
  if (onKeyPress != NULL)
    { // Si esta definido el evento, lo elevamos.
      onKeyPress(key, this);
    }
}
