// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.

// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource


#ifndef __Solar3DWidGetBase_h__
#define __Solar3DWidGetBase_h__

#include <iostream>
#include <string>
#include <fstream>

using namespace std;

#include <math.h>
#include "../texturas.h"

class Solar3DWidGetBase;

#include "Solar3DWidGetMensajes.h"

#define S3DWM_MouseBotonDerecho      001
#define S3DWM_MouseBotonIzquierdo    002

#define S3DWM_Tipo_MouseClic         000
#define S3DWM_Tipo_MouseDobleClic    001
#define S3DWM_Tipo_MouseMove         002
#define S3DWM_Tipo_KeyPress          003


// ---------------------------
class SolarColor
{
 public:
  float R;
  float G;
  float B;
  float A;

  inline SolarColor(){R = 1.0; G = 1.0; B = 1.0; A = 0.8;};
  inline SolarColor(float R, float G, float B, float A){setColor(R, G, B, A);};
  inline void setColor(float R, float G, float B, float A)
    {this->R = R; this->G = G; this->B = B; this->A = A;};
  inline void usaColor(){glColor4f(R, G, B, A);};
};


// ---------------------------
class Solar3DWidGetBase
{
  // Arreglo de Hijos
  vector<Solar3DWidGetBase*> Hijos;
  Solar3DWidGetBase* Padre;

 protected:

  SolarColor ColorDeFondo;
  SolarColor ColorNoEnable;
  Textura TexturaDeFondo;

  
  // Funciones
  virtual void renderFondo();

 public:
  string Nombre;        // Name
  void * Etiqueta;      // Tag
  bool Visible;
  bool Enable;

  // Dimensiones 
  float izq;            // lefth
  float arriba;         // top
  float ancho;          // width
  float alto;           // heigth

  float getIzqAbsoluto();
  float getArribaAbsoluto();
  inline Solar3DWidGetBase* getPadre() {return Padre;};

  void render();

  Solar3DWidGetBase();  
  Solar3DWidGetBase(string Nombre, float izq, float arriba, float ancho, float alto);

  virtual ~Solar3DWidGetBase(){};

  void setColor(float R, float G, float B, float A);
  void setTexturaDeFondo(string sTextura); // Colocamos una textura de fondo.

  void agregarHijo(Solar3DWidGetBase*);
  bool conector(Solar3DWidGetMensaje *Mensaje);


  // Estados
  bool IsMouseOver;

  // Eventos
  void (*onRender)(Solar3DWidGetBase* This);

  virtual void mouseClic (unsigned int boton, float x, float y);
  void (*onMouseClic)(unsigned int boton, float x, float y, Solar3DWidGetBase* This);

  virtual void mouseDobleClic(unsigned int boton, float x, float y);
  void (*onMouseDobleClic)(unsigned int boton, float x, float y, Solar3DWidGetBase* This);

  virtual void mouseMove(float x, float y);
  void (*onMouseMove)(float x, float y, Solar3DWidGetBase* This);


  virtual void mouseDragAndDrop(unsigned int boton, float x, float y, float xorigen, float yorigen);
  void (*onMouseDragAndDrop)(unsigned int boton, float x, float y, float xorigen, float yorigen, Solar3DWidGetBase* This);

  virtual void change();
  void (*onChange)(Solar3DWidGetBase* This);

  virtual void keyPress(const char key);
  void (*onKeyPress)(const char key, Solar3DWidGetBase* This);

};


#endif
