#include "Solar3DWidGetBase.h"

// ----------------------------------------------
// ----------------------------------------------
// ----------------------------------------------
Solar3DWidGetMensaje_MouseClic::Solar3DWidGetMensaje_MouseClic(unsigned int boton, float x, float y)
{ 
  Tipo = S3DWM_Tipo_MouseClic;
  this->boton = boton;
  this->x = x;
  this->y = y;
}

// ----------------------------------------------
bool Solar3DWidGetMensaje_MouseClic::afecta(Solar3DWidGetBase* SolarWidGet)
{
  // ZG. Vetificamos si el evento afecta al WidGet.

  bool Afectado = false;
  if ((x > SolarWidGet->getIzqAbsoluto()) && (x < SolarWidGet->getIzqAbsoluto() + SolarWidGet->ancho))
    {
      if ((y > SolarWidGet->getArribaAbsoluto()) && (y < SolarWidGet->getArribaAbsoluto() + SolarWidGet->alto))
	{
	  Afectado = true;
	}
    }
  return Afectado;
}

// ----------------------------------------------
void Solar3DWidGetMensaje_MouseClic::elevaEvento(Solar3DWidGetBase* SolarWidGet)
{
  SolarWidGet->mouseClic(boton, x-SolarWidGet->getIzqAbsoluto(), y-SolarWidGet->getArribaAbsoluto());
}


// ----------------------------------------------
// ----------------------------------------------
// ----------------------------------------------
Solar3DWidGetMensaje_MouseDobleClic::Solar3DWidGetMensaje_MouseDobleClic(unsigned int boton, float x, float y)
{ 
  Tipo = S3DWM_Tipo_MouseDobleClic;
  this->boton = boton;
  this->x = x;
  this->y = y;
}

// ----------------------------------------------
bool Solar3DWidGetMensaje_MouseDobleClic::afecta(Solar3DWidGetBase* SolarWidGet)
{
  // ZG. Vetificamos si el evento afecta al WidGet.

  bool Afectado = false;
  if ((x > SolarWidGet->getIzqAbsoluto()) && (x < SolarWidGet->getIzqAbsoluto() + SolarWidGet->ancho))
    {
      if ((y > SolarWidGet->getArribaAbsoluto()) && (y < SolarWidGet->getArribaAbsoluto() + SolarWidGet->alto))
	{
	  Afectado = true;
	}
    }
  return Afectado;
}

// ----------------------------------------------
void Solar3DWidGetMensaje_MouseDobleClic::elevaEvento(Solar3DWidGetBase* SolarWidGet)
{
  SolarWidGet->mouseDobleClic(boton, x-SolarWidGet->getIzqAbsoluto(), y-SolarWidGet->getArribaAbsoluto());
}


// ----------------------------------------------
// ----------------------------------------------
// ----------------------------------------------
Solar3DWidGetMensaje_MouseMove::Solar3DWidGetMensaje_MouseMove(float x, float y)
{
  Tipo = S3DWM_Tipo_MouseMove;
  this->x = x;
  this->y = y;
}

// ----------------------------------------------
bool Solar3DWidGetMensaje_MouseMove::afecta(Solar3DWidGetBase* SolarWidGet)
{
  // ZG. Vetificamos si el evento afecta al WidGet.

  bool Afectado = false;
  if ((x > SolarWidGet->getIzqAbsoluto()) && (x < SolarWidGet->getIzqAbsoluto() + SolarWidGet->ancho))
    {
      if ((y > SolarWidGet->getArribaAbsoluto()) && (y < SolarWidGet->getArribaAbsoluto() + SolarWidGet->alto))
	{
	  Afectado = true;
	}
    }
  return Afectado;
}

// ----------------------------------------------
void Solar3DWidGetMensaje_MouseMove::elevaEvento(Solar3DWidGetBase* SolarWidGet)
{
  SolarWidGet->mouseMove(x-SolarWidGet->getIzqAbsoluto(), y-SolarWidGet->getArribaAbsoluto());
}



// ----------------------------------------------
// ----------------------------------------------
// ----------------------------------------------
Solar3DWidGetMensaje_MouseDragAndDrop::Solar3DWidGetMensaje_MouseDragAndDrop(unsigned int boton, float x, float y, float xorigen, float yorigen)
{
  Tipo = S3DWM_Tipo_MouseMove;
  this->boton = boton;
  this->x = x;
  this->y = y;
  this->xorigen = xorigen;
  this->yorigen = yorigen;
}

// ----------------------------------------------
bool Solar3DWidGetMensaje_MouseDragAndDrop::afecta(Solar3DWidGetBase* SolarWidGet)
{
  // ZG. Vetificamos si el evento afecta al WidGet.

  bool Afectado = false;
  if ((x > SolarWidGet->getIzqAbsoluto()) && (x < SolarWidGet->getIzqAbsoluto() + SolarWidGet->ancho))
    {
      if ((y > SolarWidGet->getArribaAbsoluto()) && (y < SolarWidGet->getArribaAbsoluto() + SolarWidGet->alto))
	{
	  Afectado = true;
	}
    }
  return Afectado;
}

// ----------------------------------------------
void  Solar3DWidGetMensaje_MouseDragAndDrop::elevaEvento(Solar3DWidGetBase* SolarWidGet)
{
  SolarWidGet->mouseDragAndDrop(boton, x-SolarWidGet->getIzqAbsoluto(), y-SolarWidGet->getArribaAbsoluto(), xorigen-SolarWidGet->getIzqAbsoluto(), yorigen-SolarWidGet->getArribaAbsoluto());
}




// ----------------------------------------------
// ----------------------------------------------
// ----------------------------------------------
Solar3DWidGetMensaje_KeyPress::Solar3DWidGetMensaje_KeyPress(const char key)
{
  Tipo = S3DWM_Tipo_KeyPress;
  this->key = key;
}

// ----------------------------------------------
bool Solar3DWidGetMensaje_KeyPress::afecta(Solar3DWidGetBase* SolarWidGet)
{
  // ZG. Vetificamos si el evento afecta al WidGet. // Siempre lo afecta.
  bool Afectado = true;
  return Afectado;
}

// ----------------------------------------------
void  Solar3DWidGetMensaje_KeyPress::elevaEvento(Solar3DWidGetBase* SolarWidGet)
{
  SolarWidGet->keyPress(key);
}
