// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.

// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource


#ifndef __Solar3DWidGetMensajes_h__
#define __Solar3DWidGetMensajes_h__

#include <iostream>
#include <string>
#include <fstream>

using namespace std;

#include <math.h>

class Solar3DWidGetMensaje;

#include "Solar3DWidGetBase.h"

// ---------------------------
class Solar3DWidGetMensaje
{
 private:
 public:
  int Tipo;

  virtual bool afecta(Solar3DWidGetBase* SolarWidGet) = 0;
  virtual void elevaEvento(Solar3DWidGetBase* SolarWidGet) = 0;
};

// ---------------------------
class Solar3DWidGetMensaje_MouseClic: public Solar3DWidGetMensaje
{
 private:
 public:
  int boton;
  float x;
  float y;

  Solar3DWidGetMensaje_MouseClic(unsigned int boton, float x, float y);

  bool afecta(Solar3DWidGetBase* SolarWidGet);
  void elevaEvento(Solar3DWidGetBase* SolarWidGet);
};

// ---------------------------
class Solar3DWidGetMensaje_MouseDobleClic: public Solar3DWidGetMensaje
{
 private:
 public:
  int boton;
  float x;
  float y;

  Solar3DWidGetMensaje_MouseDobleClic(unsigned int boton, float x, float y);

  bool afecta(Solar3DWidGetBase* SolarWidGet);
  void elevaEvento(Solar3DWidGetBase* SolarWidGet);
};

// ---------------------------
class Solar3DWidGetMensaje_MouseMove: public Solar3DWidGetMensaje
{
 private:
 public:
  float x;
  float y;

  Solar3DWidGetMensaje_MouseMove(float x, float y);

  bool afecta(Solar3DWidGetBase* SolarWidGet);
  void elevaEvento(Solar3DWidGetBase* SolarWidGet);
};

// ---------------------------
class Solar3DWidGetMensaje_MouseDragAndDrop: public Solar3DWidGetMensaje
{
 private:
 public:
  int boton;
  float x;
  float y;
  float xorigen;
  float yorigen;

  Solar3DWidGetMensaje_MouseDragAndDrop(unsigned int boton, float x, float y, float xorigen, float yorigen);

  bool afecta(Solar3DWidGetBase* SolarWidGet);
  void elevaEvento(Solar3DWidGetBase* SolarWidGet);
};


// ---------------------------
class Solar3DWidGetMensaje_KeyPress: public Solar3DWidGetMensaje
{
 private:
 public:
  char key;

  Solar3DWidGetMensaje_KeyPress(const char key);

  bool afecta(Solar3DWidGetBase* SolarWidGet);
  void elevaEvento(Solar3DWidGetBase* SolarWidGet);
};

#endif
