// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.

// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

#include "Solar3DWidGetScroll.h"


// -----------------------------------------
Solar3DWidGetScroll::Solar3DWidGetScroll()
  :Solar3DWidGetBase()
{
  Orientacion = S3DWM_OrientVertical;
  Posicion = 100;
}


// -----------------------------------------
Solar3DWidGetScroll::Solar3DWidGetScroll(string Nombre, float izq, float arriba, float ancho, float alto)
  :Solar3DWidGetBase(Nombre, izq, arriba, ancho, alto)
{
  Orientacion = S3DWM_OrientVertical;
  Posicion = 100;
}


// -----------------------------------------
void Solar3DWidGetScroll::renderFondo()
{
  
  float Ancho;
  float Alto;
  float vPosicion;
  float hPosicion;

  Solar3DWidGetBase::renderFondo();

  switch (Orientacion)
    {
    case S3DWM_OrientVertical:
      {
	Ancho = ancho;
	if (alto > ancho*1.33) Alto = ancho*1.33; else alto = Alto;
	vPosicion = (alto - Alto) * (Posicion / 100.0);
	hPosicion = 0;
	break;
      }
    case S3DWM_OrientHorizontal:
      {
	break;
      }
    }

 
  if (TexturaDeBoton.isInicializada)
    {
      // Si el Widget tiene textura la usamos.
      ColorDeFondo.usaColor();
      glEnable(GL_TEXTURE_2D);
      TexturaDeBoton.usaGLTextura(TextAltaCalidad);
    }
  else
    {
      // Si el Widget no tiene textura desabilitamos las texturas.
      glDisable(GL_TEXTURE_2D);
    }


  glPushMatrix();
  glTranslatef(izq, arriba, 0);

  glBegin (GL_QUADS);
  { 
    // Si el Widget tiene textura la usamos.
    if (!TexturaDeBoton.isInicializada) glColor4f(0.0, 0.0, 0.0, 0.9);

    if (TexturaDeBoton.isInicializada) glTexCoord2f(0,1);
    glVertex2f(00000 + hPosicion, 0000 + vPosicion);

    if (!TexturaDeBoton.isInicializada) glColor4f(1.0, 0.4, 0.4, 0.4);

    if (TexturaDeBoton.isInicializada) glTexCoord2f(1,1);
    glVertex2f(Ancho + hPosicion, 0000 + vPosicion); 

    if (TexturaDeBoton.isInicializada) glTexCoord2f(1,0);
    glVertex2f(Ancho + hPosicion, Alto + vPosicion);

    if (TexturaDeBoton.isInicializada) glTexCoord2f(0,0);
    glVertex2f(00000 + hPosicion, Alto + vPosicion); 
  }
  glEnd();
  glPopMatrix();


  glBegin (GL_LINE_LOOP);
  {
    glColor4f(0.0, 0.0, 0.0, 1.0);
    glVertex2f(izq + 00000, arriba + 0000);

    glColor4f(0.2, 0.2, 0.4, 1.0);
    glVertex2f(izq + ancho, arriba + 0000); 
    glVertex2f(izq + ancho, arriba + alto);
    glVertex2f(izq + 00000, arriba + alto); 
  }
  glEnd();
  

}

// -----------------------------------------
void Solar3DWidGetScroll::mouseDragAndDrop(unsigned int boton, float x, float y, float xorigen, float yorigen)
{
  Solar3DWidGetBase::mouseDragAndDrop(boton, x, y, xorigen, yorigen); //BASE

  if (boton == S3DWM_MouseBotonIzquierdo)
    {

      switch (Orientacion)
	{
	case S3DWM_OrientVertical:
	  {
	    float Alto; if (alto > ancho*1.33) Alto = ancho*1.33; else alto = Alto; // TODO!!
	    float vPosicion = (alto - Alto) * (Posicion / 100.0); // TODO!!

	    if ((yorigen > 0000 + vPosicion) && (yorigen < Alto + vPosicion))
	      {
	
		Posicion = (int)(100 * (y) / (alto - Alto)); 

		if (Posicion < 0) Posicion = 0;
		if (Posicion > 100) Posicion = 100;

		change();

		break;
	      }
	  }
	case S3DWM_OrientHorizontal:
	  {
	    break;
	  }
	}
    }
}

