// Hacele caso a tu sed
#include "Sprite.h"

/* GL_Sprite --> */
GL_Sprite::GL_Sprite()
{
	framesPerSecond=30;
}

GL_Sprite::GL_Sprite(const GL_Sprite &src)
{
	memcpy(this,&src,sizeof(GL_Sprite));
	pFrames=new Textura[numOfFrames];	memcpy(pFrames,src.pFrames,numOfFrames*sizeof(Textura));
}

void GuardarBMP(char *szArchivo,int w,int h,int bpp,uchar *data)
{
	FILE *file=fopen(szArchivo,"wb");
	BITMAPFILEHEADER bitmapFileHeader;
	BITMAPINFOHEADER bitmapInfoHeader;
	int imageIdx;
	uchar tempRGB;

	if(!file){	return;	}

	bitmapFileHeader.bfSize=sizeof(BITMAPFILEHEADER);
	bitmapFileHeader.bfType=0x4D42;
	bitmapFileHeader.bfReserved1=0;
	bitmapFileHeader.bfReserved2=0;
	bitmapFileHeader.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);
	
	bitmapInfoHeader.biSize=sizeof(BITMAPINFOHEADER);
	bitmapInfoHeader.biPlanes=1;
	bitmapInfoHeader.biBitCount=bpp;
	bitmapInfoHeader.biCompression=BI_RGB;
	bitmapInfoHeader.biSizeImage=abs(w)*abs(h)*bpp/8;
	bitmapInfoHeader.biXPelsPerMeter=0;
	bitmapInfoHeader.biYPelsPerMeter=0;
	bitmapInfoHeader.biClrUsed=0;
	bitmapInfoHeader.biClrImportant=0;
	bitmapInfoHeader.biWidth=w;
	bitmapInfoHeader.biHeight=h;

	for(imageIdx=0;imageIdx<(int)bitmapInfoHeader.biSizeImage;imageIdx+=3)
	{
		tempRGB=data[imageIdx];	data[imageIdx]=data[imageIdx+2];	data[imageIdx+2]=tempRGB;
	}

	fwrite(&bitmapFileHeader,1,sizeof(BITMAPFILEHEADER),file);
	fwrite(&bitmapInfoHeader,1,sizeof(BITMAPINFOHEADER),file);
	fwrite(data,1,bitmapInfoHeader.biSizeImage,file);
	if(file){	fclose(file);	}
}

void GL_Sprite::MakeFromModel(Model &model,float angulo)
{
	numOfFrames=model.getNumFrames();
	pFrames=new Textura[numOfFrames];
	
	uint *tSprite=new uint[numOfFrames];
	glGenTextures(numOfFrames,tSprite);

	uint frameWidth=256,frameHeight=256;

	uchar *tData=new uchar[frameWidth*frameHeight*3];
	memset(tData,0,frameWidth*frameHeight*3);
	for(ushort i=0;i<numOfFrames;i++)
	{
		glBindTexture(GL_TEXTURE_2D,tSprite[i]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
		glTexImage2D(GL_TEXTURE_2D,0,3,frameWidth,frameHeight,0,GL_RGB,GL_UNSIGNED_BYTE,tData);
	}
	if(tData){	delete[] tData;	tData=NULL;	}

	float wide=model.getRadio()*2;

	glMatrixMode(GL_PROJECTION_MATRIX);
	glPushMatrix();
	glLoadIdentity();
	glFrustum(-wide,wide,-model.getAlto(),model.getAlto(),0,0);

	glMatrixMode(GL_MODELVIEW_MATRIX);
	glPushMatrix();
	glLoadIdentity();

	uchar *data=new uchar[frameWidth*frameHeight*3];
	for(ushort l=0;l<numOfFrames;l++)
	{
		pFrames[l].Inicializa("",tSprite[l],tSprite[l]);

		int tViewport[4];	glGetIntegerv(GL_VIEWPORT,(int*)&tViewport);

		glClearColor(0,0,0,1);
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glViewport(0,0,frameWidth,frameHeight);

		model.dibujame(0,0,0,l,angulo,0);

		glColor4f(1,1,1,1);
		glPointSize(5);
		glBegin(GL_POINTS);
		glVertex3f(0,0,0);
		glEnd();

		glBindTexture(GL_TEXTURE_2D,tSprite[l]);
		glCopyTexImage2D(GL_TEXTURE_2D,0,GL_LUMINANCE,0,0,frameWidth,frameHeight,0);

		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glViewport(tViewport[0],tViewport[1],tViewport[2],tViewport[3]);

		glGetTexImage(GL_TEXTURE_2D,0,GL_RGB,GL_UNSIGNED_BYTE,data);

		GuardarBMP("pruebasprite.bmp",frameWidth,frameHeight,4,data);
	}

	glMatrixMode(GL_PROJECTION_MATRIX);
	glPopMatrix();

	glMatrixMode(GL_MODELVIEW_MATRIX);
	glPopMatrix();

	if(data){	delete[] data;	data=NULL;	}
}

void GL_Sprite::Animar(void)
{
	static int lastTime=glutGet(GLUT_ELAPSED_TIME);

	int currentTime=glutGet(GLUT_ELAPSED_TIME);
	
	float t=(currentTime-lastTime)*framesPerSecond;
	if(t>=1.0f)
	{
		currentFrame=(currentFrame+1>=numOfFrames) ? 0 : currentFrame++;
		lastTime=currentTime;
	}

	Draw(currentFrame);
}

void GL_Sprite::Draw(int nf)
{

z3DVector pa,pb,pc,pd,right,up;
  
  float mat[16];	glGetFloatv(GL_MODELVIEW_MATRIX,(float*)&mat);
  right.x=mat[0];	right.y=mat[4];	right.z=mat[8];
  up.x=mat[1];	up.y=mat[5];	up.z=mat[9];
	
  pa.x=Pos.x-(right.x+up.x)*Scale;
  pa.y=Pos.y-(right.y+up.y)*Scale;
  pa.z=Pos.z-(right.z+up.z)*Scale;

  pb.x=Pos.x+(right.x-up.x)*Scale;
  pb.y=Pos.y+(right.y-up.y)*Scale;
  pb.z=Pos.z+(right.z-up.z)*Scale;

  pc.x=Pos.x+(right.x+up.x)*Scale;
  pc.y=Pos.y+(right.y+up.y)*Scale;
  pc.z=Pos.z+(right.z+up.z)*Scale;

  pd.x=Pos.x-(right.x-up.x)*Scale;
  pd.y=Pos.y-(right.y-up.y)*Scale;
  pd.z=Pos.z-(right.z-up.z)*Scale;

	glPushMatrix();

	pFrames[nf].usaGLTextura(TextAltaCalidad);
	glBegin(GL_QUADS);
		glNormal3f(1.0f,1.0f,1.0f);
		glTexCoord2f(0.0f,0.0f);	glVertex3fv((float*)&pa);
		glTexCoord2f(1.0f,0.0f);	glVertex3fv((float*)&pb);
		glTexCoord2f(1.0f,1.0f);	glVertex3fv((float*)&pc);
		glTexCoord2f(0.0f,1.0f);	glVertex3fv((float*)&pd);
	glEnd();

	glPopMatrix();
}

GL_Sprite::~GL_Sprite()
{
	if(pFrames){	delete[] pFrames;	pFrames=NULL;	}
}
/* <-- GL_Sprite */
