//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

// La clase efectos, contiene unas serie de efectillo visuales medio warros.

#include "animaEscenario.h"

// ------------------------------
void animaEscenario::setAnimacionDefault()
{
  if (Tipo == "Arbol")
    {
      Estatico = Modelo->getFrames("viento_suave");
      return;
    }

  if (Tipo == "Roca")
    {
      Estatico.Nombre = "NULL";
      Estatico.Inicio = 0;
      Estatico.Fin = 0;
      return;
    }

  if (Tipo == "Edificio")
    {
      Estatico.Nombre = "NULL";
      Estatico.Inicio = 0;
      Estatico.Fin = 0;
      return;
    }

  cout << "No se pudo asignar una animacion por default al objeto de escenario" << endl;
}


// ------------------------------
void animaEscenario::setAnimacion(string Animacion)
{
  if (Tipo == "Arbol")
    {
      setAnimacionTipoARBOL(Animacion);
    }
  else if (Tipo == "Roca")
    {
      setAnimacionTipoROCA(Animacion);
    }
  else if (Tipo == "Edificio")
    {
      setAnimacionTipoEDIFICIO(Animacion);
    }
}

// ------------------------------
void animaEscenario::setAnimacionTipoARBOL(string Animacion)
{
 EstadoName = Animacion;
  if (Animacion == "vientosuave")
    {
      Actual = Modelo->getFrames("viento_suave");
      FRAME = Actual.Inicio;
      return;
    }

  Actual = Estatico;
  EstadoName = "NULL";
  
  cout << "[Warning] Este tipo de Objeto de Escenografia no tiene la animacion: " << Animacion << endl; 

}

// ------------------------------
void animaEscenario::setAnimacionTipoROCA(string Animacion)
{
  EstadoName = Animacion;
  
  Actual = Estatico;
  EstadoName = "NULL";
  
  cout << "[Warning] Este tipo de Objeto de Escenografia no tiene la animacion: " << Animacion << endl; 
  
}

// ------------------------------
void animaEscenario::setAnimacionTipoEDIFICIO(string Animacion)
{
  EstadoName = Animacion;
  
  Actual = Estatico;
  EstadoName = "NULL";
  
  cout << "[Warning] Este tipo de Objeto de Escenografia no tiene la animacion: " << Animacion << endl; 
}


// ------------------------------
// ------------------------------
// ------------------------------
void animaEscenario::AminacionFinalizada(string AnimacionActual, float Sobrante)
{
  if (Tipo == "Arbol")
    {
      AminacionFinalizadaARBOL(AnimacionActual, Sobrante);
    }
  else if (Tipo == "Roca")
    {
      AminacionFinalizadaROCA(AnimacionActual, Sobrante);
    }
  else if (Tipo == "Edificio")
    {
      AminacionFinalizadaEDIFICIO(AnimacionActual, Sobrante);
    }
}

// ------------------------------
void animaEscenario::AminacionFinalizadaARBOL(string AnimacionActual, float Sobrante)
{


  if (AnimacionActual == "viento_suave")
    {
      // Actual se conseva igual
      FRAME = Actual.Inicio + Sobrante;
      
      // EstadoName = "NULL"; // No nesesario aqui
      return;  
    }

 if (AnimacionActual == "NULL")
    {
      return;
    }

 cout << "Fin de animacion no considerado: " << AnimacionActual << endl;

  Actual.Reset(); // Borrar esta linea cuando este listo.
  EstadoName = "NULL";
}
// ------------------------------

void animaEscenario::AminacionFinalizadaROCA(string AnimacionActual, float Sobrante)
{

 if (AnimacionActual == "NULL")
    {
      return;
    }

 cout << "Fin de animacion no considerado: " << AnimacionActual << endl;

  Actual.Reset(); // Borrar esta linea cuando este listo.
  EstadoName = "NULL";
}

// ------------------------------
void animaEscenario::AminacionFinalizadaEDIFICIO(string AnimacionActual, float Sobrante)
{

 if (AnimacionActual == "NULL")
    {
      return;
    }

 cout << "Fin de animacion no considerado: " << AnimacionActual << endl;

  Actual.Reset(); // Borrar esta linea cuando este listo.
  EstadoName = "NULL";
}


