//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#ifndef __comandos_h__
#define __comandos_h__

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "constantes.h"



//////////////////////////////
class comComandoBASE
{
 protected:
  string strComando;
  void *Padre;
 public:
  comComandoBASE(string Comando, void* Padre);
  virtual ~comComandoBASE(){};
  bool Accion(string Comando);
 protected:
  virtual void onAccion(vector<string> ComandoParceado) = 0;
};


///////////// PI /////////////
class comComandoPOSINI : public comComandoBASE
{
 public:
  comComandoPOSINI(void *Padre):comComandoBASE("POSINI", Padre){};
  void onAccion (vector<string> ComandoParceado);
};


//////////// CH /////////////
class comComandoCHAT : public comComandoBASE
{
 public:
  comComandoCHAT(void *Padre):comComandoBASE("CHAT", Padre){};
  void onAccion (vector<string> ComandoParceado);
};


///////////// RO /////////////
class comComandoADMIN : public comComandoBASE
{
 public:
  comComandoADMIN(void *Padre):comComandoBASE("ADMIN", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// NJ /////////////
class comComandoENTRA : public comComandoBASE
{
 public:
  comComandoENTRA(void *Padre):comComandoBASE("ENTRA", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// LI /////////////
class comComandoLISTANICKS : public comComandoBASE
{
 public:
  comComandoLISTANICKS(void *Padre):comComandoBASE("LISTANICKS", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// AR /////////////
class comComandoSETARMY : public comComandoBASE
{
 public:
  comComandoSETARMY(void *Padre):comComandoBASE("SETARMY", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// NI /////////////
class comComandoNICK : public comComandoBASE
{
 public:
  comComandoNICK(void *Padre):comComandoBASE("NICK", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

/*
///////////// RD /////////////
class comComandoRD : public comComandoBASE
{
 public:
  comComandoRD(void *Padre):comComandoBASE("RD", Padre){};
  void onAccion (vector<string> ComandoParceado);
};
*/

///////////// CL /////////////
class comComandoCLIMA : public comComandoBASE
{
 public:
  comComandoCLIMA(void *Padre):comComandoBASE("CLIMA", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// ST /////////////
class comComandoINICIA : public comComandoBASE
{
 public:
  comComandoINICIA(void *Padre):comComandoBASE("INICIA", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// AE /////////////
class comComandoAGREGAEDIFICIO : public comComandoBASE
{
 public:
  comComandoAGREGAEDIFICIO(void *Padre):comComandoBASE("AGREGAEDIFICIO", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// AD /////////////
class comComandoAGREGASOLDADO : public comComandoBASE
{
 public:
  comComandoAGREGASOLDADO(void *Padre):comComandoBASE("AGREGASOLDADO", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// RE /////////////
class comComandoRECURSOS : public comComandoBASE
{
 public:
  comComandoRECURSOS(void *Padre):comComandoBASE("RECURSOS", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// MD /////////////
class comComandoMOD : public comComandoBASE
{
 public:
  comComandoMOD(void *Padre):comComandoBASE("MOD", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// SA /////////////
class comComandoSALIDA : public comComandoBASE
{
 public:
  comComandoSALIDA(void *Padre):comComandoBASE("SALIDA", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

#endif
