//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "configuracion.h"

#include "eventos.h"

string configuracion::Resolucion = "800x600";
bool configuracion::FullScreen = false;
bool configuracion::Musica = true;
bool configuracion::EfectosDeSonido = true;
bool configuracion::Debug = true;
bool configuracion::Niebla = true;
bool configuracion::War2D = false;
bool configuracion::AntiAlaising = true;
string configuracion::Server = "";

//-------------------------------------------
void configuracion::leerConfig (string Archivo)
{
  char	szLine[256];
  int i=0;


  string Valor;
  
  // Abrimos el archivo
  FILE *file = fopen (Archivo.c_str(), "rt");
  if (!file)
    {
      cout << "[ERR][Cofiguracion]: Al abrir el archivo de confuguracion " << Archivo << endl;
      return;
    }
  
  cout << "  [ *** ] Leyendo Archivo de configuracion" << endl;

  while (fgets (szLine, 256, file))
    {
      i++;
      if (szLine[0] == '#' || szLine[0] == '\0')
	{
	  //Esto es un comentario, o una linea vacia , lo ignoramos
	  
	}
      else
	{

	  if (LeerCampo(szLine, "Resolucion", Valor))
	    {
	      if(Valor == "1024x768")
		{
		  Resolucion = Valor;
		}
	      else if(Valor == "800x600")
		{
		  Resolucion = Valor;
		}
	      else if(Valor == "640x480")
		{
		  Resolucion = Valor;
		}
	      else
		{
		  Resolucion = "640x480";
		}
	    }
	  else if (LeerCampo(szLine, "FullScreen", Valor))
	    {
	      if (Valor == "on")
		{
		  FullScreen = true;
		}
	      else if (Valor == "off")
		{
		  FullScreen = false;
		}
	      else
		{
		  cout << "[ERR][Configuracion]: Valor no valido linea: " << i << endl;
		}
	    }
	  else if (LeerCampo(szLine, "Musica", Valor))
	    {
	      if (Valor == "on")
		{
		  Musica = true;
		}
	      else if (Valor == "off")
		{
		  Musica = false;
		}
	      else
		{
		  cout << "[ERR][Configuracion]: Valor no valido linea: " << i << endl;
		}
	    }
	  else if (LeerCampo(szLine, "EfectosDeSonido", Valor))
	    {
	      if (Valor == "on")
		{
		  EfectosDeSonido = true;
		}
	      else if (Valor == "off")
		{
		  EfectosDeSonido = false;
		}
	      else
		{
		  cout << "[ERR][Configuracion]: Valor no valido linea: " << i << endl;
		}
	    }
	  else if (LeerCampo(szLine, "Debug", Valor))
	    {
	      if (Valor == "on")
		{
		  Debug = true;
		}
	      else if (Valor == "off")
		{
		  Debug = false;
		}
	      else
		{
		  cout << "[ERR][Configuracion]: Valor no valido linea: " << i << endl;
		}
	    }
	  else if (LeerCampo(szLine, "Niebla", Valor))
	    {
	      if (Valor == "on")
		{
		  configuracion::Niebla = true;
		}
	      else if (Valor == "off")
		{
		  configuracion::Niebla = false;
		}
	      else
		{
		  cout << "[ERR][Configuracion]: Valor no valido linea: " << i << endl;
		}
	    }
	  else if (LeerCampo(szLine, "AntiAlaising", Valor))
	    {
	      if (Valor == "on")
		{
		  configuracion::AntiAlaising = true;
		}
	      else if (Valor == "off")
		{
		  configuracion::AntiAlaising = false;
		}
	      else
		{
		  cout << "[ERR][Configuracion]: Valor no valido linea: " << i << endl;
		}
	    }
	  else if (LeerCampo(szLine, "War2D", Valor))
	    {
	      if (Valor == "on")
		{
		  configuracion::War2D = true;
		}
	      else if (Valor == "off")
		{
		  configuracion::War2D = false;
		}
	      else
		{
		  cout << "[ERR][Configuracion]: Valor no valido linea: " << i << endl;
		}
	    }

	}
    }
  configuracion::SetConfig ();
}

void configuracion::SetConfig ()
{
  if (!configuracion::FullScreen)
    {
      if (configuracion::Resolucion == "640x480")
	{
	  glutInitWindowSize(640, 480);
	  Eventos::ME()->Resize(640, 480);
	}
      else if (configuracion::Resolucion == "800x600")
	{
	  glutInitWindowSize(800, 600);
	  Eventos::ME()->Resize(800, 600);
	}
      else if (configuracion::Resolucion == "1024x768")
	{
	  glutInitWindowSize(1024, 768);
	  Eventos::ME()->Resize(1024, 768);
	}

      if (configuracion::Server == "SERVER")
	{
	  glutInitWindowPosition(5,5);
	}
      else
	{
	  glutInitWindowPosition(320,220);
	}
     
    }
  
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);

  if (configuracion::FullScreen)
    {
      if (configuracion::Resolucion == "640x480")
	{
	  glutGameModeString("640x480:16@60");
	  Eventos::ME()->Resize(640, 480);
	}
      else if (configuracion::Resolucion == "800x600")
	{
	  glutGameModeString("800x600:16@60");
	  Eventos::ME()->Resize(800, 600);
	}
      else if (configuracion::Resolucion == "1024x768")
	{
	  glutGameModeString("1024x768:16@60");
	  Eventos::ME()->Resize(1024, 768);
	}
      glutEnterGameMode();
    }
  else
    {
      glutCreateWindow("WAR 3D");
    }

}


//----------------------------------------------
bool configuracion::LeerCampo(char *szLine, string Campo, string &Valor)
{
  char sValor[256];
  
  string Campo2 = Campo + ": %s"; 
  
  // Leemos el numero de unidaddes:
  if (sscanf (szLine, Campo2.c_str(), sValor) == 1)
    {
      Valor = sValor;
      cout << "    [Config]: " << Campo << ": |" << Valor << "|" << endl;
      return true;
    }
  else
    {
      //cout << " [[Army Error]] Error en el formato, Campo: " << Campo << endl;
      return false;
    }
}
