//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

// Propiedad intelentual de Solar OpenSource y sus miembros
// www.solar-opensource.org


#include "dianoche.h"


// --------------------------
void DiaNocheClima::setRetardo(float Retardo)
{
  
  Clock =  Clock + 1.0/Retardo;

  if (Clock > DiaNoche_Dia + DiaNoche_Noche)
    {
      Clock = 0;
      return;
    }

  if (Clock >= DiaNoche_Dia)
    {
      if (SolIntensidad > 0.0)
	{
	  SolIntensidad = SolIntensidad - 0.1/Retardo;
	  ActualizaLuces();
	}
      return;
    }

  if (Clock >= 0)
    {
      if (SolIntensidad < 1.0)
	{
	  SolIntensidad = SolIntensidad + 0.1/Retardo;
	  ActualizaLuces();
	}
      return;
    }
}

// --------------------------
string DiaNocheClima::getEstado ()
{
  string Estado;
  if (Clock < DiaNoche_Dia)
    {
      char str[20];
      sprintf(str,"Dia: %.0f",DiaNoche_Dia-Clock);
      Estado = str; 
    }
  else
    {
      char str[20];
      sprintf(str,"Noche: %.0f",(DiaNoche_Dia + DiaNoche_Noche)-Clock);
      Estado = str; 
    }

  return Estado;
}


// --------------------------
void DiaNocheClima::ActualizaLuces()
{
  
  if (SolIntensidad > 1.0)
    {
      SolIntensidad = 1.0;
    }

  GLfloat  ambientLight0[] = { 0.3f*SolIntensidad,
			       0.3f*SolIntensidad,
			       0.3f*SolIntensidad, 1.0f };

  GLfloat lightAngulo0 = 90.0 * ((SolIntensidad + 0.7) /1.7);
   
  // Define e inicia la luz 0
  
  
  glLightfv(GL_LIGHT0,GL_AMBIENT,ambientLight0);
  glLightfv(GL_LIGHT0,GL_SPOT_CUTOFF, &lightAngulo0);


  if (FOGOFWAR::SoporteDeExtensiones)
    {
      
      float fogColor[4]={0.20f * SolIntensidad + 0.3, 
			 0.20f * SolIntensidad  + 0.3, 
			 0.20f * SolIntensidad  + 0.3, 1.0f};
      glFogfv(GL_FOG_COLOR,fogColor);
      
      if(glGetError()!=0){	cout << "Panel Error OPENGL: " << glGetError() << endl;}

    }  

}


// --------------------------
void DiaNocheClima::setClima(string Clima, int duracion)
{
  if (Clima == "DIA")
    {
      Clock = 0;
      DiaNoche_Dia = duracion;
    }
  else if (Clima == "NOCHE")
    {
      Clock = DiaNoche_Dia;
      DiaNoche_Noche = duracion;
    }
  else
    {
      War3DWarning ("DIANOCHECLIMA" , "Clima no soportado por el cliente");
    }
}
