//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include  "ejercito.h"

#include "pantallaInicio.h"

//----------------------------------------------------------------

int Ejercito::NumeroDeEjercito = 1;

vector<Ejercito> Ejercito::TodosLosEjercitos;

oSoldado* Ejercito::BichoSeleccionado = (oSoldado*) NULL;
oSoldado* Ejercito::BichoEnemigoSeleccionado = (oSoldado*) NULL;
oEdificio* Ejercito::EdificioSelecionado = (oEdificio*) NULL;


//----------------------------------------------------------------
oSoldado *Ejercito::addSoldado(int tipo, float x, float y, int ID)
{

 
 if (Miejercito == true)
    {
      localBichoID++;
      ID = localBichoID;
    }
 
 oSoldado *SoldadoNuevo; 

 if (tipo == 1)
   {
     SoldadoNuevo = new oSoldadoConstructor (x, y, ID, internetID, Miejercito);
   }
 if (tipo > 1)
   {
     SoldadoNuevo = new oSoldado (x, y, ID, internetID, Miejercito);
   }
   
  if ((tipo > 0 ) && (tipo <= MiArmy->getNumUnidades()))
    {

      SoldadoNuevo->setArmy(&MiArmy->Unidades[tipo-1]);

    }
  else
    {
      cout << "[ERROR][EJERCITOS] El tipo: " << tipo << " de unidad no exite en estae army." << endl;
      return (oSoldado*)NULL;
    }


  if (Miejercito == true)
    {
      pantallaInicio::ME()->sendAGREGASOLDADO(tipo, x, y, ID); // Comando de RED
    }

  Soldados.push_back(SoldadoNuevo);

  return SoldadoNuevo;

}

//----------------------------------------------------------------
oEdificio *Ejercito::addEdificio (int tipo, float x, float y, int ID)
{
  if (Miejercito == true)
    {
      localEdificioID++;
      ID = localEdificioID;
    }
  
  oEdificio *EdificioNuevo;

  EdificioNuevo = new oEdificio(x, y, ID, internetID, Miejercito);
  
  if ((tipo > 0 ) && (tipo <= MiArmy->getNumConstrucciones()))
    {

      EdificioNuevo->setArmy(&MiArmy->Contrucciones[tipo-1]);
      EdificioNuevo->setEdificioContructor(Contruccion);

      AStar::ME()->putObjeto(EdificioNuevo->getModelo(), x, y);

    }
  else
    {
      cout << "[ERROR][EJERCITOS] El tipo: " << tipo << " de edificio no exite en estae army." << endl;
      return (oEdificio*)NULL;
    }


  if (Miejercito)
    {
      if (EdificioNuevo->getAlcance() == 0)
	{
	  Tierra::ME()->fow.ilumina(x,y,0.8,0);
	}
      else
	{
	  Tierra::ME()->fow.ilumina(x,y,EdificioNuevo->getAlcance()*1.2,0);
	}
    }

  
 if (Miejercito == true)
    {
      pantallaInicio::ME()->sendAGREGAEDIFICIO(tipo, x, y, ID); // Comando de RED
    }

  Edificios.push_back(EdificioNuevo);
  return EdificioNuevo;

}


//----------------------------------------------------------------
Ejercito::Ejercito  (int internetID, z2DVector BaseLocalizacion)
{ 

  Miejercito = false;
  ArmyListo = false;

  MisRecursos = new Recurso;

  this->internetID = internetID;
  
  this->BaseLocalizacion = BaseLocalizacion;

  MiArmy = new Army;

  //Empezamos a contar desde 100 las unidades de nuestro ejercito
  // y desde 1100 las del enemigo 1, y desde 2100 las unidades del enemigo 2

  localBichoID = 100 + (1000 * Ejercito::NumeroDeEjercito);
  localEdificioID = 900 + (1000 * Ejercito::NumeroDeEjercito);
  Ejercito::NumeroDeEjercito ++;

  MisRecursos->adquiereRecursos(300, 0);
  Poblacion = 0;

  Contruccion = NULL;

  Clock = 0.0;
  Clock2 = 0.0;
  Clock3 = 0.0;

}


//----------------------------------------------------------------
Ejercito::~Ejercito ()
{
}


void Ejercito::setArmy (string strArmy)
{
 this->strArmy = "Armys/" + strArmy + "/Army.army";

 if (Miejercito == true)
    {
      pantallaInicio::ME()->sendSETARMY(strArmy); // Comando de RED
    }

}

//----------------------------------------------------------------
void Ejercito::Inicia ()
{
  MiArmy->LeerArmy(strArmy);
  Contruccion = new oConstruye ();
  Contruccion->setArmy(MiArmy->EdificioConstructor);
  ArmyListo = true;
}


//----------------------------------------------------------------
void Ejercito::RecolectaRecursos()
{

  vector<oSoldado*>::iterator Ite;  
  for (Ite=Soldados.begin(); Ite != Soldados.end(); Ite++)
    {
      MisRecursos->adquiereRecursos(Recursos::ME()->Recolecta((*Ite)->getLocalizacion().x, 
							     (*Ite)->getLocalizacion().y, 
							     (*Ite)->getRadio()),
				    0);
    }
}


//----------------------------------------------------------------
void Ejercito::RecolectaElectricidad()
{
  vector<oEdificio*>::iterator EdificioMio;
  for (EdificioMio=Edificios.begin(); EdificioMio != Edificios.end(); EdificioMio++)
    {
      if ((*EdificioMio)->getTipo() == 1)
	{
	  MisRecursos->adquiereRecursos(0, 1);
	}
    }
}


//----------------------------------------------------------------
void Ejercito::setRetardo(float Retardo)
{
  this->Retardo = Retardo;

  vector<oSoldado*>::iterator Ite;  
  for (Ite=Soldados.begin(); Ite != Soldados.end(); Ite++)
    {
      (*Ite)->setRetardo(Retardo);
    }

  vector<oEdificio*>::iterator ItE;  
  for (ItE=Edificios.begin(); ItE != Edificios.end(); ItE++)
    {
      (*ItE)->setRetardo(Retardo);
    }


  Contruccion->setRetardo(Retardo);


  if (Clock > 2.0) { Clock = 0.0; EliminaBajas(); }
  else { Clock = Clock + 1.0/Retardo; }


  if (Clock2 > 0.3) {Clock2 = 0.0; RecolectaRecursos(); } 
  else { Clock2 = Clock2 + 1.0/Retardo; }

  if (Clock3 > 2.0) {Clock3 = 0.0; RecolectaElectricidad(); } 
  else { Clock3 = Clock3 + 1.0/Retardo; }

}


//----------------------------------------------------------------
int Ejercito::delSoldado(int ID, float x, float y)
{
  return 0;
}


// ---------------------------------------------------------------
void Ejercito::EliminaBajas()
{

  Poblacion = 0;
  vector<oEdificio*>::iterator EdificioMio;
  for (EdificioMio=Edificios.begin(); EdificioMio != Edificios.end(); EdificioMio++)
    {
      if ((*EdificioMio)->getTipo() == 2)
	{
	  Poblacion = Poblacion + 5;
	}
    }


  vector<oSoldado*>::iterator Ite;  
  for (Ite=Soldados.begin(); Ite != Soldados.end(); Ite++)
    {
      if ((*Ite)->Desapareceme()) 
	{
	  War3DAccion ("EJERCITOS", "Eliminando unidad.");
	  delete (*Ite)->Camino;
	  delete (*Ite);
	  Soldados.erase(Ite);
	  break;
	}
    }
	
  vector<oEdificio*>::iterator IteEdi;
  for (IteEdi=Edificios.begin(); IteEdi != Edificios.end(); IteEdi++)
    {
      if ((*IteEdi)->Desapareceme()) 
	{
	  War3DAccion ("EJERCITOS", "Eliminando edificio.");
	  delete (*IteEdi);
	  Edificios.erase(IteEdi);
	  break;
	}
    }

  Ejercito::TodosLosEjercitos.begin()->Update();

}


//----------------------------------------------------------------
void Ejercito::MouseInteraccion(float x, float y, int Boton, int estado)
{

}


//-------
void Ejercito::IADeCombate(vector<Ejercito>::iterator EjercitoEnemigo)
{


  vector<oSoldado*> *Enemigos = EjercitoEnemigo->getEjercito();

  vector<oSoldado*>::iterator BichoMio;
  vector<oEdificio*>::iterator EdificioMio;
  vector<oSoldado*>::iterator BichoEnemigo;

  vector<oEdificio*> *EdificiosEnemigos = EjercitoEnemigo->getEdificios();

  vector<oEdificio*>::iterator EdificioEnemigo;

  float DistanciaEntreBichos;

  float DistanciaBichoEdificio;





  for (BichoMio=Soldados.begin(); BichoMio != Soldados.end(); BichoMio++)
    { 

      if (((*BichoMio)->getEstado() != EstadoMuertoDestruido) &&
	  ((*BichoMio)->getEstado() != EstadoDisparando))
	{ 
	  //---
	  	  
	  if (((*BichoMio)->getModo() == ModoCazador) || ((*BichoMio)->getModo() == ModoVengativo))
	    { // VENGATIVO CAZADOR
	      
	      if ((*BichoMio)->getPresaOSeguir()->getEstado() != EstadoMuertoDestruido)
		{ // El bichin esta vivo, Vamos a ver si esta cerca
		  
		  if ((*BichoMio)->IntentaDisparo())
		    {
		      Reaccion(*BichoMio, (oSoldado*)(*BichoMio)->getPresaOSeguir());
		    }
		}
	      else
		{
		  (*BichoMio)->setModo(ModoNormal, 0.0, 0.0, 0, (*BichoMio)->getLocalizacion().x, (*BichoMio)->getLocalizacion().y);
		 
       		}
	    }
	  
	  //---
	  else if ((*BichoMio)->getModo() == ModoNormal)
	    { // NORMAL VENGATIVO
	      for (BichoEnemigo=Enemigos->begin(); BichoEnemigo != Enemigos->end(); BichoEnemigo++)
		{
		  if ((*BichoEnemigo)->getEstado() != EstadoMuertoDestruido)
		    {
		      DistanciaEntreBichos =  zDistancia((*BichoMio)->getLocalizacion().x, 
							 (*BichoMio)->getLocalizacion().y, 
							 (*BichoEnemigo)->getLocalizacion().x, 
							 (*BichoEnemigo)->getLocalizacion().y);
	
		      if (DistanciaEntreBichos < ((*BichoMio)->getAlcance()+0.5))
			{
		
			  (*BichoMio)->setModo(ModoVengativo, 0.0, 0.0, (*BichoEnemigo)->ID, (*BichoMio)->getLocalizacion().x, (*BichoMio)->getLocalizacion().y);
			
			  break;
			}
		    }
		}
	    }
	  //---
	  else if ((*BichoMio)->getModo() == ModoQuieto)
	    { // QUIETO
	        for (BichoEnemigo=Enemigos->begin(); BichoEnemigo != Enemigos->end(); BichoEnemigo++)
		{
		  if ((*BichoEnemigo)->getEstado() != EstadoMuertoDestruido)
		    {
		      DistanciaEntreBichos =  zDistancia((*BichoMio)->getLocalizacion().x, 
							 (*BichoMio)->getLocalizacion().y, 
							 (*BichoEnemigo)->getLocalizacion().x, 
							 (*BichoEnemigo)->getLocalizacion().y);
		      
		      if (DistanciaEntreBichos < ((*BichoMio)->getAlcance()))
			{
			  (*BichoMio)->Dispara(*BichoEnemigo);
			  Reaccion(*BichoMio, *BichoEnemigo);
			  break;
			}
		    }
		}
	    }
	  //---
	  else if ((*BichoMio)->getModo() == ModoAgresivo || (*BichoMio)->getModo() == ModoGuardia)
	    {
	      for (BichoEnemigo=Enemigos->begin(); BichoEnemigo != Enemigos->end(); BichoEnemigo++)
		{
		  if ((*BichoEnemigo)->getEstado() != EstadoMuertoDestruido)
		    {
		      DistanciaEntreBichos =  zDistancia((*BichoMio)->getLocalizacion().x, 
							 (*BichoMio)->getLocalizacion().y, 
							 (*BichoEnemigo)->getLocalizacion().x, 
							 (*BichoEnemigo)->getLocalizacion().y);
		      
		      if (DistanciaEntreBichos < ((*BichoMio)->getAlcance()))
			{
			  (*BichoMio)->Dispara(*BichoEnemigo);
			  Reaccion(*BichoMio, *BichoEnemigo);
			  break;
			}
		    }
		}
	    }
	  //---
	  else if ((*BichoMio)->getModo() == ModoGuardaEspaldas)
	    {
	      
	    }
	}


      if (((*BichoMio)->getEstado() != EstadoMuertoDestruido) &&
	  ((*BichoMio)->getEstado() != EstadoDisparando))
	{ 
	  if ((*BichoMio)->getModo() == ModoNormal || (*BichoMio)->getModo() == ModoAgresivo || (*BichoMio)->getModo() == ModoGuardia)
	    {
	      for (EdificioEnemigo=EdificiosEnemigos->begin(); EdificioEnemigo != EdificiosEnemigos->end(); EdificioEnemigo++)
		{
		  if ((*EdificioEnemigo)->getEstado() != EstadoMuertoDestruido)
		    {
		      DistanciaBichoEdificio = zDistancia((*BichoMio)->getLocalizacion().x, 
							  (*BichoMio)->getLocalizacion().y, 
							  (*EdificioEnemigo)->getLocalizacion().x, 
							  (*EdificioEnemigo)->getLocalizacion().y);
		      
		      if (DistanciaBichoEdificio < ((*BichoMio)->getAlcance()))
			{
			  (*BichoMio)->Dispara(*EdificioEnemigo);
			}
		    }
		}
	    }
	  
	  else if ((*BichoMio)->getModo() == ModoDestruyeEdificio)
	    {
	      if ((*BichoMio)->getPresaOSeguir()->getEstado() != EstadoMuertoDestruido)
		{ // El bichin esta vivo, Vamos a ver si esta cerca
		  if ((*BichoMio)->IntentaDisparo())
		    {
		      	
		    }
		}
	      else
		{
		  (*BichoMio)->setModo(ModoNormal, 0.0, 0.0, 0, (*BichoMio)->getLocalizacion().x, (*BichoMio)->getLocalizacion().y);
		}    
	    }
	}
    }


  vector<oSoldado*>::iterator BichoEnemigoMasCercano;
  float DistanciaMenor = 99999;
  
  
  for (EdificioMio=Edificios.begin(); EdificioMio != Edificios.end(); EdificioMio++)
    {
      if (((*EdificioMio)->getEstado() != EstadoMuertoDestruido) &&
	  ((*EdificioMio)->getEstado() != EstadoDisparando))
	{
	  for (BichoEnemigo=Enemigos->begin(); BichoEnemigo != Enemigos->end(); BichoEnemigo++)
	    {
	      if ((*BichoEnemigo)->getEstado() != EstadoMuertoDestruido)
		{
		  DistanciaEntreBichos =  zDistancia((*EdificioMio)->getLocalizacion().x, 
						     (*EdificioMio)->getLocalizacion().y, 
						     (*BichoEnemigo)->getLocalizacion().x, 
						     (*BichoEnemigo)->getLocalizacion().y);


		  if (DistanciaEntreBichos < DistanciaMenor)
		    {
		      DistanciaMenor = DistanciaEntreBichos;
		      BichoEnemigoMasCercano = BichoEnemigo;
		    }

		}
	    }
	  if (DistanciaMenor < ((*EdificioMio)->getAlcance()))
	    {
	      (*EdificioMio)->Dispara(*BichoEnemigoMasCercano);
	      Reaccion(*EdificioMio, *BichoEnemigoMasCercano);
	    }
	}
    }
  

}


//-------
void Ejercito::Reaccion(oObjetos* BichoMio, oSoldado* BichoEnemigo)
{

  // Esta funcion le dice al bicho como debe reaccionar despues de que recibe un disparo.
  // Por ejemplo, en Modo Quito, no debe reaccionar, en modo Cazador tambien debe ignorar al atacante 
  // y concentrarse en la presa, en modo Normal debe responder al disparo y colocarse en modo Vengativo.

  switch(BichoEnemigo->getModo())
    {
    case ModoNormal:
      { // ---------- MODO NORMAL -------------
	if (BichoEnemigo->getEstado() != EstadoCorriendo && BichoEnemigo->getEstado() != EstadoHerido)	       
	  {
	    BichoEnemigo->setModo(ModoVengativo, 0.0, 0.0, BichoMio->ID, BichoEnemigo->getLocalizacion().x, BichoEnemigo->getLocalizacion().y); // Me disparaste!!, Voy por ti Maldito.
	  }
	break;
      }	    
    case ModoCaminoFijo:
      { // ---------- MODO CAMINOFIJO -------------
	
	// Ignoramos cualquier cosa.
	break;
      }
    case ModoVengativo:
      { // ---------- MODO VENGATIVO -------------
	break;
      }	 
    case ModoCazador:
      { // ---------- MODO CAZADOR  -------------
	break;
      }	 
    case ModoQuieto:
      { // ---------- MODO QUIETO  -------------
	break;
      }
    case ModoGuardia:
      {
	break;
      }
    case ModoAgresivo:
      {
	break;
      }
    case ModoDestruyeEdificio:
      {
	break;
      }
    case ModoGuardaEspaldas:
      { // ---------- MODO GARDAESPALDAS  -------------

	break;
      }
    default:  
      { // ---------- OTROS MODOS -------------
	// Codigo
	cout << "EJERCITOS MODO no considerado para reaccion: " << BichoEnemigo->getModo() << endl;
     }
    }

}


void Ejercito::BibujaBandera(float x, float y, float z)
{

  static float Frame = 2;
  static bool sentido = true;

  glColor3f (1.0, 1.0, 1.0);


  if (sentido)
    {
      Frame = Frame + (4.0 / Retardo);
    }
  else
    {
      Frame = Frame - (4.0 / Retardo);
    }

  if (Frame > 17.0)
    {
      sentido = false;
    }

  if (Frame < 2)
  {
	  sentido = true;
  }

  MiArmy->LaBandera->Modelo->dibujame(x, y+0.1, z, Frame, 25, 0.0);
}



// ---------------------

oSoldado* Ejercito::getBichoReferencia (int ID)
{

  vector<Ejercito>::iterator Ejers;
  
  vector<oSoldado*> *EjeX;
  vector<oSoldado*>::iterator Ite;
  
  for (Ejers=Ejercito::TodosLosEjercitos.begin(); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    { 
      
      EjeX = Ejers->getEjercito();
      
      for (Ite=EjeX->begin(); Ite != EjeX->end(); Ite++)
	{
	  
	  if ((*Ite)->ID == ID)
	    {
	      return (*Ite);
	    }
	}
    }
  
  /*
  static int Muchos = 0; Muchos ++;
  cout << "Muchos: " << Muchos << endl;
  */

  return (oSoldado*)NULL;
}


// ---------------------
void Ejercito::Update ()
{

  vector<oSoldado*>::iterator Bicho;

  Ejercito::BichoSeleccionado = (oSoldado*)NULL;	

  for (Bicho=Soldados.begin(); Bicho != Soldados.end(); Bicho++)
    {
      if ((*Bicho)->Seleccionado == true)
	{
	  if ((*Bicho)->getEstado() != EstadoMuertoDestruido)
	    { 
	      if (Ejercito::BichoSeleccionado == (oSoldado*)NULL)
		{
		  Ejercito::BichoSeleccionado = (*Bicho);	
		}
	      
	      if ((*Bicho)->getCosto() > Ejercito::BichoSeleccionado->getCosto())
		{
		  Ejercito::BichoSeleccionado = (*Bicho);
		}
	    }
	}
    }

  if (Ejercito::BichoEnemigoSeleccionado != (oSoldado*)NULL)
    {
      if (Ejercito::BichoEnemigoSeleccionado->getEstado() == EstadoMuertoDestruido)
	{
	  Ejercito::BichoEnemigoSeleccionado = (oSoldado*)NULL;
	}
    }
}


// ---------------------
oEdificio* Ejercito::getEdificioReferencia (int ID)
{

  vector<Ejercito>::iterator Ejers; 
  
  vector<oEdificio*> *EdiX;
  vector<oEdificio*>::iterator Ite;
  
  
  for (Ejers=Ejercito::TodosLosEjercitos.begin(); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    { 
      
      EdiX = Ejers->getEdificios();
      
      for (Ite=EdiX->begin(); Ite != EdiX->end(); Ite++)
	{
	  
	  if ((*Ite)->ID == ID)
	    {
	      return (*Ite);
	    }
	}
    }
  
  return (oEdificio*)NULL;
}


// -----------------------------------------------------------
oObjetos* Ejercito::GetBichoInet(int InternetID, int ID)
{
  // -- BICHO DE INTERES -- Vamos a buscar el bicho que realiza la accion.
  oObjetos* BichoOEdificio  = (oObjetos*) NULL;
  
  // -----------------------------------------------------------
  // [EJERCITO] De que ejercito es el Bicho?
  vector<Ejercito>::iterator UnEjercito =  (vector<Ejercito>::iterator) NULL;
  vector<Ejercito>::iterator IteEjercito;
  
  for (IteEjercito=(Ejercito::TodosLosEjercitos.begin()); IteEjercito != Ejercito::TodosLosEjercitos.end(); IteEjercito++)
    {
      // Miramos de que ejercito es el bicho.
      if (IteEjercito->getinternetID() == InternetID)
	{  
	  UnEjercito = IteEjercito;
	  break;
	}
    }
  if (UnEjercito == (vector<Ejercito>::iterator) NULL)
    {
      // Si no fue de ninguno hay un error
      cout << "Dessincronizacion ALTA  " << "InetID: " << InternetID << "  ID: " << ID << endl;
      return (oObjetos*) NULL;
    }

  // -----------------------------------------------------------
  // [BichoOEdificio] De que bicho o edificio estamos hablando?
  vector<oSoldado*> *Bichos = UnEjercito->getEjercito();
  vector<oEdificio*> *Edificios = UnEjercito->getEdificios();
  vector<oSoldado*>::iterator ElBicho;
  vector<oEdificio*>::iterator ElEdificio;
  for (ElBicho = Bichos->begin() ; ElBicho != Bichos->end() ; ElBicho++)
    {
      if (((*ElBicho)->ID % 1000) == ID)
	{
	  BichoOEdificio = *ElBicho;
	  break;
	}
    }
  if (BichoOEdificio == (oObjetos*) NULL)
    {
      for (ElEdificio = Edificios->begin() ; ElEdificio != Edificios->end() ; ElEdificio++)
	{
	  if(((*ElEdificio)->ID % 1000) == ID)
	  {
	     BichoOEdificio = *ElEdificio;
	     break;
	  }
	}
    }
  if (BichoOEdificio == (oObjetos*) NULL)
    {
      cout << "Dessincronizacion MEDIA  " << "InetID: " << InternetID << "  ID: " << ID << endl;
      return (oObjetos*) NULL;
    }
  
  return BichoOEdificio;
}

