//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "escribe.h"


//----------------------------------
//------Escribe Objeto -------------
//----------------------------------


Textura Texto::texFuente1;
Textura Texto::texFuente2;

bool Texto::F1Inicializado = false;
bool Texto::F2Inicializado = false;


void Texto::Inicia()
{


  War3DAccion("ESCRIBE", "Inicualizando texturas");

  if (!F1Inicializado)
    {
      texFuente1 = ServidorDeTexturas::ME()->Nueva("Interface/Fuentes/Cursor.tga");
      texFuente2 = ServidorDeTexturas::ME()->Nueva("Interface/Fuentes/Cursor2.tga");
      
      Texto::F1Inicializado = true;
      Texto::F2Inicializado = true;  
    }
  else
    {
      War3DWarning("ESCRIBE", "El objeto ya estaba inicializado.");
    }
}



void Texto::Escribe (float Cadena, float x, float y, int size, int fuente)
{

  char str[20];
  sprintf(str,"%.2f",Cadena);
  Escribe(str, x, y, size, fuente, 1.0, 1.0, 1.0, 1.0);

}

void Texto::Escribe (string Cadena, float x, float y, int size, int fuente)
{
  Escribe(Cadena, x, y, size, fuente, 1.0, 1.0, 1.0, 1.0);
}


void Texto::Escribe (string Cadena, float x, float y, int size, int fuente, 
		     float R, float G, float B, float alpha)
{

  glPushMatrix();

  glColor4f(R, G, B, alpha);

  unsigned int Contador;

  miVistaGL.setVista(VistaGL_Ortogonal);

  switch (fuente)
    {
    case 1:
      {
	if (!F1Inicializado)
	  {
	    War3DError("Escribe", "La fuente no esta inicializada");
	    return;
	  }
	texFuente1.usaGLTextura(TextAltaCalidad);
	break;
      }
    case 2:
      {
	if (!F2Inicializado)
	  {
	    War3DError("Escribe", "La fuente no esta inicializada");
	    return;
	  }
	texFuente2.usaGLTextura(TextAltaCalidad);
	break;
      }
    default:
      {
	War3DError("Escribe", "La fuente no esta disponible");
	return;
      }
    }
 
  for (Contador = 0; Contador<Cadena.size() ; Contador++)
    {
      EscribeCaracter(Cadena.c_str()[Contador], x+(Contador*(0.05*size/20.0)), y, 0, size/20.0);
    }
 glPopMatrix();

}


void Texto::EscribeCaracter (char Caracter, float x, float y, float z, float size)
{

  float texX;
  float texY;

  int X;
  int Y;

  X = (Caracter-32)%16;
  Y = (Caracter-32)/16; 

  texX = X / 16.0;
  texY = 1.0 - Y / 6.0;

  glBegin (GL_QUADS);
  {
   
    glTexCoord2f(texX+        0.020,       texY-0.040);
    glVertex2f(0.0+x, 0.0+y);

    glTexCoord2f(texX+1/16.0- 0.020, texY-      0.040);
    glVertex2f((0.050*size)+x, 0.0+y);

    glTexCoord2f(texX+1/16.0- 0.020, texY-1/6.0+0.030);
    glVertex2f((0.050*size)+x, (0.080*size)+y);

    glTexCoord2f(texX+        0.020,texY-1/6.0 +0.030);
    glVertex2f(0.0+x, (0.080*size)+y);
    
  }
  glEnd();

}




// ------------------------------------------------
//-------------------------------------------------


TextoTemporal::TextoTemporal()
{

  x = 0; 
  y = 0;
  
  vida = 0;

}

// --------------------------------------------
TextoTemporal::~TextoTemporal()
{
  
}

// --------------------------------------------
void TextoTemporal::Escribe(float x , float y, string Cadena, int size)
{
  this->x = x;
  this->y = y;  // En cordenadas realies es Z

  this->Cadena = Cadena;
  this->size = size;

  tiempoAnterior = glutGet(GLUT_ELAPSED_TIME);
  vida = 10000;
}

// --------------------------------------------
z2DVector TextoTemporal::getPosicion()
{
  z2DVector Pos;
  Pos.x = x;
  Pos.y = y;
  return Pos;

}

// --------------------------------------------
void TextoTemporal::Dibujame()
{


  if (vida > 0)
    {

      int GluTiempo = glutGet(GLUT_ELAPSED_TIME);   
      TextServer.Escribe (Cadena, x, y, size, 1, 1.0, 1.0, 1.0, 2.0-2.0*fabs((vida-5000)/5000.0));

      vida = vida - (GluTiempo - tiempoAnterior);
      tiempoAnterior = GluTiempo;
    }
      
}


// --------------------------------------------
// --------------------------------------------
// --------------------------------------------


// --------------------------------------------
TextoTemporal2::TextoTemporal2()
{
  x = 0; 
  y = 0;
  vida = 0;
}

// --------------------------------------------
TextoTemporal2::~TextoTemporal2()
{
  
}

// --------------------------------------------
void TextoTemporal2::Escribe(float x , float y, string Cadena, int size)
{
  this->x = x;
  this->y = y;  // En cordenadas realies es Z

  this->Cadena = Cadena;
  this->size = size;

  tiempoAnterior = glutGet(GLUT_ELAPSED_TIME);
  vida = 2000;
}

// --------------------------------------------
z2DVector TextoTemporal2::getPosicion()
{
  z2DVector Pos;
  Pos.x = x;
  Pos.y = y;
  return Pos;

}

// --------------------------------------------
void TextoTemporal2::Dibujame()
{


  if (vida > 0)
    {

      int GluTiempo = glutGet(GLUT_ELAPSED_TIME);   
      TextServer.Escribe (Cadena, x, y, size, 2, 1.0, 1.0, 1.0, 3.0-3.0*fabs((vida-1000)/1000.0));

      vida = vida - (GluTiempo - tiempoAnterior);
      tiempoAnterior = GluTiempo;
    }
      
}
