//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*

//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para                                                                                        distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

// Propiedad intelentual de Solar OpenSource y sus miembros
// www.solar-opensource.org


#include "eventos.h"

#include "Mouse.h"
#include "Teclado.h"

#include "minimap.h"
#include "tierra.h"
#include "navegacion.h"
#include "Recursos.h"
#include "dianoche.h"

#include "Seleccion.h"


#include "Solar3DWidGets/Solar3DWidGetEntorno.h"
#include "pantallaMenuPrincipal.h"
#include "pantallaMultiplayerIRC.h"
#include "pantallaInicio.h"
#include "pantallaNuevaPartida.h"
#include "pantallaClienteP2P.h"

// ---------------------------------------------
// ---------------------------------------------
// --------- Funciones de Incicializacion ------
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------
//Eventos *Eventos::Me = NULL;


Eventos::Eventos ()
{

  SetRenderModo(pModoNulo); 
  pModoAnterior = pModoNulo;
  
  Zoom = 1.0;
  ZoomZ = Zoom;
  Lejania = 2.5;

  Selecionador = new FX_Seleccion();
  Barra = new FX_BarraEnergia();
  ClicEnTerrenoFX = new FX_ClicEnTerreno(20);
  ClicEnEnemigoFX = new FX_ClicEnEnemigo(20);

  Anuncios01 = new TextoTemporal;
  Anuncios02 = new TextoTemporal;  

  altura = 0.2;

  Retardo=10;
  DiosAltura = 50.0;

  fps = 10;

  PanelActivo = 0;

  SoyAdmin = false;

  timeOld=glutGet(GLUT_ELAPSED_TIME);

}


// -------------------------
Eventos::~Eventos()
{
  delete (Selecionador);
  delete (Barra);
  delete (ClicEnTerrenoFX);
}


//--------------------------
void Eventos::Inicia()
{
     
  Texto TextServer;
  TextServer.Inicia();

  Solar3DWidGetEntorno::ME()->ContenedorPrimario->agregarHijo(pantallaMenuPrincipal::ME());
  Solar3DWidGetEntorno::ME()->ContenedorPrimario->agregarHijo(pantallaMultiplayerIRC::ME());
  Solar3DWidGetEntorno::ME()->ContenedorPrimario->agregarHijo(pantallaInicio::ME());
  Solar3DWidGetEntorno::ME()->ContenedorPrimario->agregarHijo(pantallaNuevaPartida::ME());
  Solar3DWidGetEntorno::ME()->ContenedorPrimario->agregarHijo(pantallaClienteP2P::ME());

  SetRenderModo(pModoInicio);

	
  MouseCorsor.inicia();
  Explosion.Inicia();

  Model::Mallado = configuracion::Debug;

  ElPanelDeComandos.Inicia (0.85, 0.45, 0.125, 0.25, IDPanelDeControl);
  ElPanelDeComandos.setTextura("Hud/Yens/PanelDeComandos.tga", 0.0, 0.25);
  ElPanelDeComandos.setFijar ("Hud/Yens/fijar.tga", 0.125 - 16*Pixel_H, 2*Pixel_V , 14*Pixel_H, 14*Pixel_V);

  ElPanelDeMiniFotos.Inicia (0.75, 0.70, 0.25 ,0.25, IDPanelDeMiniFotos);
  ElPanelDeMiniFotos.setTextura("Hud/Yens/PanelDeMiniFotos.tga", 0.0, 0.25);
  ElPanelDeMiniFotos.setFijar ("Hud/Yens/fijar.tga", 0.25 - 16*Pixel_H, 2*Pixel_V , 14*Pixel_H, 14*Pixel_V);

  ElPanelDeEstado.Inicia (0.25, 0.00, 0.50 ,0.08333, IDPanelDeEstado);
  ElPanelDeEstado.setTextura("Hud/Yens/PanelDeEstado.tga", 0.0, 0.0);
  ElPanelDeEstado.setFijar ("Hud/Yens/fijar.tga", 0.50 - 16*Pixel_H, 2*Pixel_V , 14*Pixel_H, 14*Pixel_V);

  ElPanelDeMiniMapa.Inicia (0.00, 0.00, 0.1875 ,0.29166, IDPanelDeMiniMapa);
  ElPanelDeMiniMapa.setTextura("Hud/Yens/PanelDeMiniMapa.png", 0.25, 0.125);
  ElPanelDeMiniMapa.setFijar ("Hud/Yens/fijar.tga",  0.1875 - 16*Pixel_H, 2*Pixel_V , 14*Pixel_H, 14*Pixel_V);

  // this would be a good place to put a menu


  SetRenderModo(pModoMenu);
  
  SoundServer::ME()->PlayOgg(12.4, 0.0 ,9.0,"Musica/music1.ogg");	
  SoundServer::ME()->YoEstoyEn(12.4,9.0,0.0,0.0);

}


// ---------------------------------------------
// ---------------------------------------------
// -------------Funciones de Render-------------
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------

void Eventos::Render()
{

  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); // Borramos la escena
     
  miVistaGL.setVista(VistaGL_Dios);

  Draw(false, false);

  glutSwapBuffers();

  if(glGetError()!=0){	cout << "Error OPENGL: " << glGetError() << endl;}

}
 


//------------------------------
void Eventos::Draw(bool selecciontierra, bool seleccionbichos)
{

  strLocalizacion Localizacion = Navegacion::ME()->getLocalizacion();

  gluLookAt( Localizacion.TierraX + zsin(Localizacion.AngVista + Localizacion.Giro)*2.0*ZoomZ,
	     (DiosAltura + 1.9)*ZoomZ,
	     Localizacion.TierraY + zcos(Localizacion.AngVista + Localizacion.Giro)*2.0*ZoomZ,    // Desde donde miramos
	     Localizacion.TierraX, DiosAltura + -0.2, Localizacion.TierraY,   	     // Hacia donde
	     0.0, 1.0, 0.0);   // Que eje es el que esta hacia arriba


  // Le informamos al modulo tierra donde esta la camara.
  Tierra::ME()->setCamara(Localizacion.TierraX, Localizacion.TierraY, Localizacion.AngVista + Localizacion.Giro);


  if (!selecciontierra && !seleccionbichos) //REnder Normal.
    {
      // Actualizamos la localizacion del Oyente.
      SoundServer::ME()->YoEstoyEn(Localizacion.TierraX,Localizacion.TierraY,DiosAltura, Localizacion.AngVista);

      // Luces
      DibujaLuces();

      // Dibuja tierra
      Tierra::ME()->dibujame ( );

      // Rendereamos el ejercito
      DibujaEjercitos(true);     

      // Dibujamos los recursos
      Recursos::ME()->Dibujame();

      // Dibujamos los objetos en la tierra
      Tierra::ME()->dibujaObjetos ( );
   
      // Efectos
      ClicEnTerrenoFX->Dibujame(Tierra::ME()->getAltura(ClicEnTerrenoFX->getPosicion().x, 
						     ClicEnTerrenoFX->getPosicion().y));
      
      ClicEnEnemigoFX->Dibujame(Tierra::ME()->getAltura(ClicEnEnemigoFX->getPosicion().x, 
						     ClicEnEnemigoFX->getPosicion().y));
      // Servidor de disparos
      ServidorDeDisparos::ME()->Dibujame();

      // Cuadro de seleccion
      CuadroDeMultiSeleccion(Mouse::ME()->getMouseState().x, Mouse::ME()->getMouseState().y,
			     Mouse::ME()->getMouseState().x_down, Mouse::ME()->getMouseState().y_down);
      
      // Efectos de explosiones
      Explosion.Dibujame(Localizacion.AngVista + Localizacion.Giro);


      // Paneles
      ElPanelDeComandos.Dibujame();
      ElPanelDeMiniFotos.Dibujame();
      ElPanelDeEstado.Dibujame();
      ElPanelDeMiniMapa.Dibujame();

      // Anuncios
      Anuncios01->Dibujame();
      Anuncios02->Dibujame();
      
      // Cursor de Mouse
      DubujaMouse();

      // Chat
      ConsolaChat::ME()->Dibujame();

    }

  if (selecciontierra) // Renderear solo el terreno sin texturas
    {
      Tierra::ME()->dibujameSelect ( );
    }

  if (seleccionbichos) // Renderear solo bichos
    {
      DibujaEjercitos(false);
    }

  glFlush();
  glFinish();

  // we do the menu checking here in the draw function, go figure
}

// -----------------------------------------
void Eventos::DubujaMouse()
{
  float X = (float)Mouse::ME()->getMouseState().x / Mouse::ME()->getPantalla().x;
  float Y = (float)Mouse::ME()->getMouseState().y / Mouse::ME()->getPantalla().y;

  if (ElPanelDeComandos.BotonAgresivo)
    {
      MouseCorsor.Dibujame(oCursorCursorAgresivo, X, Y);
    }
  else if (ElPanelDeComandos.BotonGuardia)
    {
      MouseCorsor.Dibujame(oCursorCursorGuardia, X, Y);
    }
  else if (ElPanelDeComandos.BotonBandera)
    {
      MouseCorsor.Dibujame(oCursorCursorBandera, X, Y);
    }
}

//--------------------------
void Eventos::DibujaLuces()
{

  strLocalizacion Localizacion = Navegacion::ME()->getLocalizacion();
  
  
  GLfloat lightPos0[] = { Localizacion.TierraX-0.1, 1.5 , Localizacion.TierraY-0.1, 1.0};
  glLightfv(GL_LIGHT0,GL_POSITION,lightPos0);
  
  GLfloat lightDir0[] = { 0.0, -1.0, 0.0};
  glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,lightDir0);
  
  
  GLfloat lightPos1[] = { Localizacion.TierraX, 1.5 , Localizacion.TierraY, 1.0};
  glLightfv(GL_LIGHT1,GL_POSITION,lightPos1);
  
  GLfloat lightDir1[] = { 0.0, -1.0, 0.0};
  glLightfv(GL_LIGHT1,GL_SPOT_DIRECTION,lightDir1);
  

}


// -----------------------------------------
void Eventos::DibujaEjercitos( bool seleccion)
{

  vector<Ejercito>::iterator MiEjers = Ejercito::TodosLosEjercitos.begin();


  // Pedimos el vector que contiene los soldados de nuestro ejercito.
  vector<oSoldado*> *EjeX = MiEjers->getEjercito();
  vector<oSoldado*>::iterator Ite;

  vector<oEdificio*> *EdiX = MiEjers->getEdificios();
  vector<oEdificio*>::iterator EdiIte;
     
  float X,Y,A;
     
  int Actual_X;
  int Actual_Y;



     
  strLocalizacion Localizacion = Navegacion::ME()->getLocalizacion();
     
  for (EdiIte=EdiX->begin(); EdiIte != EdiX->end(); EdiIte++)
    {
      
      X = (*EdiIte)->getLocalizacion().x;
      Y = (*EdiIte)->getLocalizacion().y;
      A = (*EdiIte)->Altura;
      
      if  (Tierra::ME()->getFrustumCulling (X, Y))
	{
	  A = Tierra::ME()->getAltura(X, Y);
	  glColor3f(1.0 , 1.0 , 1.0); 

	  (*EdiIte)->dibujame(A , Tierra::ME()->getNormal(X, Y), seleccion);  
	  
	}

      if (seleccion)
	{
	  if ((*EdiIte)->Seleccionado == true)
	    {
	      glColor4f(1.0, 1.0, 1.0, 1.0);
	      Barra->Dibujame(X,A+0.2,Y,(*EdiIte)->getSangre()*0.3, (*EdiIte)->getSangreTotal()*0.3, Localizacion.AngVista + Localizacion.Giro);


	      MiEjers->BibujaBandera((*EdiIte)->getBichoLocalizacion().x,
				     Tierra::ME()->getAltura((*EdiIte)->getBichoLocalizacion().x, 
							  (*EdiIte)->getBichoLocalizacion().y),
				     (*EdiIte)->getBichoLocalizacion().y);
	    }
	}
    }


  for (Ite=EjeX->begin(); Ite != EjeX->end(); Ite++)
    {
      
      X = (*Ite)->getLocalizacion().x;
      Y = (*Ite)->getLocalizacion().y;
      A = (*Ite)->Altura;
	 
      if  (Tierra::ME()->getFrustumCulling (X, Y))
	{
	  A = Tierra::ME()->getAltura(X, Y);
	  glColor3f(1.0 , 1.0 , 1.0); 
	  (*Ite)->dibujame(A , Tierra::ME()->getNormal(X, Y), seleccion);
	  
	  if (seleccion)
	    {
	      Actual_X =  (int)(Densidad * X);
	      Actual_Y =  (int)(Densidad * Y);
	      
	      //Tierra::ME()->fow.ilumina(X,Y,(*Ite)->getAlcance()*2.0 ,0);
	      
	      if ((*Ite)->Seleccionado == true)
		{
		  
		  glColor4f(1.0, 1.0, 1.0, 1.0);
		  Barra->Dibujame(X,A,Y,(*Ite)->getSangre(), (*Ite)->getSangreTotal(), Localizacion.AngVista + Localizacion.Giro);
		  
		  
		  if (Seleccionados == 1)
		    {
		      if ((*Ite)->getEstado() == EstadoCorriendo)
			{
			  
			  // Le ponemos el caminito desvanecido :P
			  glColor4f (1.0, 1.0, 1.0, 0.6);
			  
			  glDisable(GL_LIGHTING);
			  glDisable(GL_TEXTURE_2D);
			  
			  glPointSize( 3.0 );
			  glBegin(GL_POINTS);
			  {

			    for (int j=(*Ite)->getPaso(); j<= (*Ite)->Camino->Pasos ; j++)
			      {
				
				glVertex3f((*Ite)->Camino->path[j].x,
					   Tierra::ME()->getAltura((*Ite)->Camino->path[j].x, 
								   (*Ite)->Camino->path[j].y)+0.01,
					   (*Ite)->Camino->path[j].y);	
			      }
			  }
			  glEnd();
			}
		    }
		}  
	    } 
	  
	} 
    }
  
  

  // ** Ejercitos Enemigos **

  glEnable(GL_FOG);
  vector<Ejercito>::iterator Ejers;

  for (Ejers=Ejercito::TodosLosEjercitos.begin()+1; Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {


      EdiX = Ejers->getEdificios();
      for (EdiIte=EdiX->begin(); EdiIte != EdiX->end(); EdiIte++)
	{
	  
	  X = (*EdiIte)->getLocalizacion().x;
	  Y = (*EdiIte)->getLocalizacion().y;
	  A = (*EdiIte)->Altura;
	  if  (Tierra::ME()->getFrustumCulling (X, Y))
	    {
	      A = Tierra::ME()->getAltura(X, Y);
	      glColor3f(1.0 , 1.0 , 1.0); 
	      Tierra::ME()->fow.SetFogCoord((int)(Densidad *X), (int)(Densidad *Y));
	      (*EdiIte)->dibujame(A , Tierra::ME()->getNormal(X, Y), seleccion);
	    }
	}
      

      // Pedimos el vector que contiene los soldados de nuestro ejercito.
      vector<oSoldado*> *EjeX = Ejers->getEjercito();
      vector<oSoldado*>::iterator Ite;
     
      float X,Y,A;
          
      for (Ite=EjeX->begin(); Ite != EjeX->end(); Ite++)
	{
	 
	  X = (*Ite)->getLocalizacion().x;
	  Y = (*Ite)->getLocalizacion().y;
	  A = (*Ite)->Altura;
	  if  (Tierra::ME()->getFrustumCulling (X, Y))
	    {
	      if (Tierra::ME()->fow.getVisible((int)(Densidad *X),(int)(Densidad *Y)))
		{
		  A = Tierra::ME()->getAltura(X, Y);
		  glColor3f(1.0 , 1.0 , 1.0); 
		  Tierra::ME()->fow.SetFogCoord((int)(Densidad *X), (int)(Densidad *Y));
		  (*Ite)->dibujame(A , Tierra::ME()->getNormal(X, Y), seleccion);

		  if (seleccion)
		    {
		      if ((*Ite)->getEstado() != EstadoMuertoDestruido)
			{
			  glColor4f (1.0, 0.2, 0.2, 0.9);
			  Selecionador->Dibujame(X, A, Y, (*Ite)->getRadio());
			}				
		    } 
		
		}
	    } 
	} 
    }
  glDisable(GL_FOG);
} 


// -------------------------
void Eventos::SetRenderModo(int Modo)
{

  timeOld=glutGet(GLUT_ELAPSED_TIME);


  if (Modo == MODO) 
    {
      War3DWarning("Eventos::SetREnderModo" , " ModoRepetido");
    }


  if ((MODO != pModoNuevaPartida) && (MODO != pModoClienteP2P)) // Pantallas intermedias TODO!!
    {
      pModoAnterior = MODO;
    }

  switch (Modo)
    {
    case pModoNulo:
      {
	War3DWarning("EVENTOS","Modo render nulo");
	break;
      }
    case pModoInicio:
      {
	break;
      }
    case pModoPartida:
      {
	pantallaMenuPrincipal::ME()->Visible = false;
	pantallaMultiplayerIRC::ME()->Visible = false;
	pantallaInicio::ME()->Visible = true;
	pantallaNuevaPartida::ME()->Visible = false;
	pantallaClienteP2P::ME()->Visible = false;


	pantallaInicio::ME()->Reset();

	break;
      }
    case pModoMenu:
      {
	pantallaMenuPrincipal::ME()->Visible = true;
	pantallaMultiplayerIRC::ME()->Visible = false;
	pantallaInicio::ME()->Visible = false;
	pantallaNuevaPartida::ME()->Visible = false;
	pantallaClienteP2P::ME()->Visible = false;
	break;
      }
    case pModoMultiplayer:
      {
	pantallaMenuPrincipal::ME()->Visible = false;
	pantallaMultiplayerIRC::ME()->Visible = true;
	pantallaInicio::ME()->Visible = false;
	pantallaNuevaPartida::ME()->Visible = false;
	pantallaClienteP2P::ME()->Visible = false;
	cout << "pModoMultiplayer" << endl;
	break;
      }
    case pModoNuevaPartida:
      {
	pantallaMenuPrincipal::ME()->Visible = false;
	pantallaMultiplayerIRC::ME()->Visible = false;
	pantallaInicio::ME()->Visible = false;
	pantallaNuevaPartida::ME()->Visible = true;
	pantallaClienteP2P::ME()->Visible = false;
	cout << "pModoNuevaPartida" << endl;
	break;
      }
    case pModoClienteP2P:
      {
	pantallaMenuPrincipal::ME()->Visible = false;
	pantallaMultiplayerIRC::ME()->Visible = false;
	pantallaInicio::ME()->Visible = false;
	pantallaNuevaPartida::ME()->Visible = false;
	pantallaClienteP2P::ME()->Visible = true;
	cout << "pModoClienteP2P" << endl;
	break;
      }
    case pModoJuego:
      {
	pantallaMenuPrincipal::ME()->Visible = false;
	pantallaMultiplayerIRC::ME()->Visible = false;
	pantallaInicio::ME()->Visible = false;
	pantallaNuevaPartida::ME()->Visible = false;
	pantallaClienteP2P::ME()->Visible = false;
	cout << "pModoJuego" << endl;
	break;
      }
    default:
      {
	War3DError("EVENTOS", "Modo Render no valido");
	break;
      }
    }

  MODO = Modo;
  cout << "MODO: " << Modo << endl;
}


// -------------------------
void Eventos::CuadroDeMultiSeleccion(float x1, float y1, float x2, float y2)
{

  float xtmp;
  float ytmp;

  if (PanelActivo == 0)
    {      
      if (Mouse::ME()->getMouseState().estado == 0)
	{
	  if (Mouse::ME()->getMouseState().boton == 0)
	    {
	     
	      if (x2 > x1)
		{
		  // X2 siempre debe ser mayor que X1, si no es asi
		  // basta con intercambiarlos
		  xtmp=x1;
		  x1=x2;
		  x2=xtmp;
		}
	      
	      if (y2 > y1)
		{
		  // X2 siempre debe ser mayor que X1, si no es asi
		  // basta con intercambiarlos
		  ytmp=y1;
		  y1=y2;
		  y2=ytmp;
		}
	      
	      miVistaGL.setVista(VistaGL_Ortogonal);

	      glDisable(GL_TEXTURE_2D);
	      
	      glColor4f(1.0,1.0,0.0,0.2);
	      
	      glBegin(GL_QUADS);
	      {
		glVertex2f(x1/Mouse::ME()->getPantalla().x,y1/Mouse::ME()->getPantalla().y);
		glVertex2f(x2/Mouse::ME()->getPantalla().x,y1/Mouse::ME()->getPantalla().y);
		glVertex2f(x2/Mouse::ME()->getPantalla().x,y2/Mouse::ME()->getPantalla().y);
		glVertex2f(x1/Mouse::ME()->getPantalla().x,y2/Mouse::ME()->getPantalla().y);
		
	      }
	      glEnd();
	    }
	}
    }
}



// -----------------------------------------
void Eventos::Resize(int x, int y)
{
  glViewport(0, 0, x, y); // Se va a usar toda la ventana para mostrar graficos
}



// ---------------------------------------------
// ---------------------------------------------
// ---- Funciones de Inactivida y Retardos  ----
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------



//--------------------------------
void Eventos::Inactivo()
{

  static int frame = 0;
  static int timebase = glutGet(GLUT_ELAPSED_TIME); 
	
  //strMouseEvento MouseReal = getMouse(zTipoReal);
  float fpsTMP;
  strLocalizacion Localizacion = Navegacion::ME()->getLocalizacion();
  
  if (Mouse::ME()->getMouseState().estado == 1)
    {
      Navegacion::ME()->Avanzo((int)Mouse::ME()->getMouseState().x, (int)Mouse::ME()->getMouseState().y, 
			  (int)Mouse::ME()->getPantalla().x, (int)Mouse::ME()->getPantalla().y, 
			  Tierra::ME()->getAncho()/Densidad, Tierra::ME()->getAlto()/Densidad);
    }
  


  frame++;
  int time=glutGet(GLUT_ELAPSED_TIME);
  if (time - timebase > 1000) 
    {

      // cout << fps << endl;

      fpsTMP = frame*1000.0/(time-timebase);
      fps = (fps*5 + fpsTMP)/6.0;
      timebase = time;		
      frame = 0;
      
  
      Minimapa::ME()->Refresaca();


      if (configuracion::Server == "SINGLEPLAYER")
	{
	  // RETARDO del Bot.
	  SinglePlayerBot.setRetardo();
	}

    }
  if (time-timeOld > 0)
    {
      Retardo = 1.0/((time-timeOld)/1000.0);
    }

  timeOld = time;

  ZoomZ = LineaSuave(ZoomZ, Zoom, int(Retardo/2.0));

  Minimapa::ME()->PutDios(Localizacion.TierraX, Localizacion.TierraY);

  // Enviamos los retardos.
  SetRetardos();


  Disparos();
  PathFinder();
  

  DiosAltura = LineaSuave(DiosAltura, 
			  altura + Tierra::ME()->getAltura(Localizacion.TierraX ,Localizacion.TierraY), 
			  int(Retardo));
  
  Render();

  /*
  RecibeComandos();
  */
}


//--------------------------------
void Eventos::SetRetardos()
{
  // Enviamos el retardo a todos los modulos, para sincrinizar y mantener la misma velocidad
  // en maquinas con diferentes velocidades.
  
  Navegacion::ME()->setRetardo(Retardo);
  Tierra::ME()->setRetardo(Retardo);

  vector<Ejercito>::iterator Ejers;
  for (Ejers=Ejercito::TodosLosEjercitos.begin(); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      Ejers->setRetardo(Retardo);
    }

  DiaNocheClima::ME()->setRetardo(Retardo);
  ElPanelDeComandos.setRetardo(Retardo);
  ElPanelDeMiniFotos.setRetardo(Retardo);
  ElPanelDeEstado.setRetardo(Retardo);
  ElPanelDeMiniMapa.setRetardo(Retardo);
  ServidorDeDisparos::ME()->setRetardo(Retardo);

}




// ---------------------------------------------
// ---------------------------------------------
// ------------ Funciones de Mouse  ------------
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------


// ---------------------------------------------------------
int Eventos::Mouse_move (float x, float y)
{

  ElPanelDeComandos.Mouse_move (x, y);
  ElPanelDeMiniFotos.Mouse_move (x, y);
  ElPanelDeEstado.Mouse_move (x, y);
  ElPanelDeMiniMapa.Mouse_move (x, y);

  return 0;
}


// ---------------------------------------------------------
int Eventos::Mouse_clic(float x, float y, int boton)
{
 
  // ZG Lo comento porque em mouse hacia cosas raras, supondo que CheckClick, 
  // modifica de alguna forma las matrices de proyeccion.

  // ElMapa->CheckClick(x,y);

  if (boton == 3) 
    {
      if (Zoom > 0.5)
	{
	  Zoom = Zoom - 0.10;
	}
      return 0;
    }
  if (boton == 4)
    {
      if (Zoom < 1.0)
	{
	  Zoom = Zoom + 0.10;
	}
      return 0;
    }
  

  int X = (int)(x * Mouse::ME()->getPantalla().x);
  int Y = (int)(y * Mouse::ME()->getPantalla().y);


  int max = 0;
  int tmp;

  tmp = ElPanelDeComandos.Mouse_clic (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeMiniFotos.Mouse_clic (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeEstado.Mouse_clic (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeMiniMapa.Mouse_clic (x, y, boton);
  if (tmp > max) max = tmp;

  if (PanelActivo == 0)
    {
      Seleccion(X, Y, X, Y, boton); // Seleccion por clic
    }

  return 0;

}

// ---------------------------------------------------------
int Eventos::Mouse_dragNdrop (float x, float y, float x2, float y2, int boton)
{

  // Esta funcion se ejecuta al soltar el boton. Mouse UP
  // x, y son las coordenadas del mouse al soltar el boton.
  // x2, y2 son las coordenadas delmouse cuanto estubo presionado.

  if (boton == 3) 
    {
      if (Zoom > 0.5)
	{
	  Zoom = Zoom - 0.10;
	}
      return 0;
    }
  if (boton == 4)
    {
      if (Zoom < 1.0)
	{
	  Zoom = Zoom + 0.10;
	}
      return 0;
    }
  

  int X = (int)(x * Mouse::ME()->getPantalla().x);
  int Y = (int)(y * Mouse::ME()->getPantalla().y);
  int X2 = (int)(x2 * Mouse::ME()->getPantalla().x);
  int Y2 = (int)(y2 * Mouse::ME()->getPantalla().y);


  if (PanelActivo == 0)
    {
      Seleccion(X, Y, X2, Y2, boton);  // Seleccion por arrastre de mouse
    }
 
  return 0;
}

// ---------------------------------------------------------
int Eventos::Mouse_dobleClic (float x, float y, int boton)
{
  /*
  int X = (int)(x * Mouse::ME()->getPantalla().x);
  int Y = (int)(y * Mouse::ME()->getPantalla().y);
  
  SeleccionTipo(X, Y, boton);
  */
  return 0;
}


// ---------------------------------------------------------
int Eventos::Mouse_down (float x, float y, int boton)
{

  int max = 0;
  int tmp;

  tmp = ElPanelDeComandos.Mouse_down (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeMiniFotos.Mouse_down (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeEstado.Mouse_down (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeMiniMapa.Mouse_down (x, y, boton);
  if (tmp > max) max = tmp;
 
  PanelActivo = 0;

  if (max == IDPanelDeControl)
    {
      PanelActivo = IDPanelDeControl;
    }
  
  if (max == IDPanelDeMiniFotos)
    {
      PanelActivo = IDPanelDeControl;
    }

  if (max == IDPanelDeEstado)
    {
      PanelActivo = IDPanelDeControl;
    }

  if (max == IDPanelDeMiniMapa)
    {
      PanelActivo = IDPanelDeControl;
    }

  return max;

}


// ---------------------------------------------------------
int Eventos::Mouse_up (float x, float y, int boton)
{

  int max = 0;
  int tmp;

  tmp = ElPanelDeComandos.Mouse_up (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeMiniFotos.Mouse_up (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeEstado.Mouse_up (x, y, boton);
  if (tmp > max) max = tmp;

  tmp = ElPanelDeMiniMapa.Mouse_up (x, y, boton);
  if (tmp > max) max = tmp;

  return max;
}



// ---------------------------------------------
// ---------------------------------------------
// ------ Funciones de Seleccion y Modos  ------
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------
// ---------------------------------------------



// ------------------------------------
void Eventos::Seleccion(int xPos, int yPos, int x2Pos, int y2Pos, int boton)
{
		
  int Ancho = abs(xPos-x2Pos);
  int Alto = abs(yPos-y2Pos);

  if (Ancho == 0) Ancho = 1;
  if (Alto == 0) Alto = 1;

  // Obtenemos el centro de la seleccion;
  int X = xPos;
  int Y = yPos;
  if (xPos > x2Pos) {X = x2Pos;}
  if (yPos > y2Pos) {Y = y2Pos;}
  X = X + Ancho/2;
  Y = Y + Alto/2;
  
  // cout << Ancho << " - " << Alto << endl;

  GLint viewport[4];
  GLuint selectBuf[256];
  
  
  glSelectBuffer(256, selectBuf);
  glRenderMode(GL_SELECT);
  
  
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();

  glInitNames();
    
  glLoadIdentity();
  
  glGetIntegerv(GL_VIEWPORT, viewport);
  
  gluPickMatrix(X, viewport[3]-Y,
		Ancho+1, Alto+1, viewport);
  
  
  gluPerspective( 45 ,         // Angulo de vision
		  800.0/800.0, // Razon entre el largo y el ancho, para calcular la perspectiva
		  0.01,           // Cuan cerca se puede ver
		  7.0);  

  glMatrixMode(GL_MODELVIEW);


  glInitNames();
 
  
  if ((Ancho + Alto) > 10)
    {
      Draw(false, true); 
    }
  else
    {
      Draw(true, true); 
    }


  // returning to normal rendering mode
  int hits = glRenderMode(GL_RENDER);
 
  
  // restoring the original projection matrix
  glMatrixMode(GL_PROJECTION);

  glPopMatrix();

  glMatrixMode(GL_MODELVIEW);

  // cout << "HITS: " << hits-1 << endl;

  if (hits >= 0)
    {
      Seleccion::ME()->Seleccionar(selectBuf, hits, boton,
				   ElPanelDeComandos.BotonAgresivo, 
				   ElPanelDeComandos.BotonBandera,
				   ElPanelDeComandos.BotonGuardia,
				   ElPanelDeComandos.BotonNuevoEdificio-PanelClicNuevoEdificio + 1);
    }
  int glERR = glGetError();
  if(glERR!=0){	cout << "Error OPENGL: " << glERR << endl;}

 }



// -------------------------------------------
// -------------------------------------------
// ---- Mivilizar Coliciones Disparos ETC ----
// -------------------------------------------
// -------------------------------------------
// -------------------------------------------

// ----------------------------------------
void Eventos::Moviliza(float x, float y)
{
  vector<oSoldado*>::iterator Bicho;
  vector<oSoldado*> *EjeX = Ejercito::TodosLosEjercitos.begin()->getEjercito();


  ClicEnTerrenoFX->SetPosicion(x,y);

  float CenX=0;
  float CenY=0;

  // Obtenemos el centroide
  int Cont = 0;
  for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
    {
      if ((*Bicho)->Seleccionado == true)
	{
	  CenX = CenX + (*Bicho)->getLocalizacion().x;
	  CenY = CenY + (*Bicho)->getLocalizacion().y;
	  Cont++;
	}
    }

  if (Cont == 0) return; // Ningun Bicho seleccionado.

  CenX = CenX/Cont;
  CenY = CenY/Cont;
  

  Ejercito::BichoSeleccionado->PlayOk();

  if (zDistancia( CenX, CenY, x, y) > 0.30)
    {
      
      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
	{
	  if ((*Bicho)->Seleccionado == true)
	    {
	      if (ElPanelDeComandos.BotonAgresivo) 
		{
		  // El boton de modo agresivo esta seleccionado.
		  (*Bicho)->setModo(ModoAgresivo, 
				    x + ((*Bicho)->getLocalizacion().x - CenX),
				    y + ((*Bicho)->getLocalizacion().y - CenY),
				    0, 
				    (*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y);
		}
	      else if (ElPanelDeComandos.BotonGuardia) 
		{
		  if ((fabs((*Bicho)->getLocalizacion().x - x) > (1.0/Densidad)) ||
		      (fabs((*Bicho)->getLocalizacion().y - y) > (1.0/Densidad)))
		    {
		      (*Bicho)->setModo(ModoGuardia, 
					x + ((*Bicho)->getLocalizacion().x - CenX),
					y + ((*Bicho)->getLocalizacion().y - CenY),
					0, 
					(*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y);
		    }
		}
	      else
		{
		  (*Bicho)->setModo(ModoCaminoFijo, 
				    x + ((*Bicho)->getLocalizacion().x - CenX),
				    y + ((*Bicho)->getLocalizacion().y - CenY),
				    0, 
				    (*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y);
		}		
	    }
	}
    }
  else
    {
      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
	{
	  if ((*Bicho)->Seleccionado == true)
	    {
	      if (ElPanelDeComandos.BotonAgresivo) 
		{
		  // El boton de modo agresivo esta seleccionado.
		  (*Bicho)->setModo(ModoAgresivo, 
				    x,
				    y,
				    0, 
				    (*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y);
		}
	      else if (ElPanelDeComandos.BotonGuardia) 
		{
		  if ((fabs((*Bicho)->getLocalizacion().x - x) > (1.0/Densidad)) ||
		      (fabs((*Bicho)->getLocalizacion().y - y) > (1.0/Densidad)))
		    {
		      (*Bicho)->setModo(ModoGuardia, 
					x,
					y,
					0, 
					(*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y);
		    }
		}
	      else
		{
		  (*Bicho)->setModo(ModoCaminoFijo, 
				    x,
				    y,
				    0, 
				    (*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y);
		}
	    }
	}		
    }

}



// -----------------------------------
void Eventos::PathFinder()
{

  vector<Ejercito>::iterator Ejers;
  vector<oSoldado*> *EjeX;
  vector<oSoldado*>::iterator Bicho;
  int AnguloDeIntento = 0;
  float Antes_X, Antes_Y;
  bool Encontrado;

  for (Ejers=Ejercito::TodosLosEjercitos.begin(); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {

      EjeX = Ejers->getEjercito();
      
      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
	{
  
	  if (Colision((*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y, (*Bicho)->getRadio()+0.01, *Bicho))
	    {
	      (*Bicho)->IntentaMovimiento (AnguloDeIntento);
	    }
	  else
	    {
	      
	      // El bicho ya se movio. Hay que comprobar que no choco.
	      for (AnguloDeIntento = 0; AnguloDeIntento < 360; AnguloDeIntento=AnguloDeIntento+16)
		{
		  
		  Antes_X = (*Bicho)->getLocalizacion().x;
		  Antes_Y = (*Bicho)->getLocalizacion().y;
		  
		  (*Bicho)->IntentaMovimiento (AnguloDeIntento);
		  
		  if (!Colision((*Bicho)->getLocalizacion().x, (*Bicho)->getLocalizacion().y, (*Bicho)->getRadio()+0.01, *Bicho))
		    { 
		      // No choco todo OK
		      Encontrado = true;
		      // Salimos del for, porque ya no es nesesario seguir buscando.  
		      
		      break;  
		    } 
		  else
		    {
		      // Si chocamos con algo, hay que regresar al bicho a donde estaba.
		      (*Bicho)->setLocalizacion(Antes_X, Antes_Y);
		      // No salimos del for, para intentar de nuevo.
		    }  
		}
	    }
	  
	  //El bicho quedo encerrado no hay a donde ir. 
	  if (Encontrado == false) 
	    {
	      // cout << "No hay a donde ir" << endl;
	      //(*Bicho)->setEstado(EstadoQuieto);
	    }
	}
    }    
}




// -----------------------------------
void Eventos::Disparos()
{
 
  // Con esto buscamos a quien disparar :P

  vector<Ejercito>::iterator Ejers;
  vector<Ejercito>::iterator EjersATAC;

  for (EjersATAC=(Ejercito::TodosLosEjercitos.begin()); EjersATAC != Ejercito::TodosLosEjercitos.end(); EjersATAC++)
    {
      
      for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
	{
      
	  if (Ejers != EjersATAC) // Para que no se ataque a si mismos :)
	    {
	      EjersATAC->IADeCombate(Ejers); 
	    }	     
	}
    } 
}
  
// ---------------------------------------
bool Eventos::Colision(float x, float y, float r, oSoldado* Yo)
{
  vector<oSoldado*> *EjeX;
  vector<oSoldado*>::iterator Ite;
  vector<Ejercito>::iterator Ejers;
      
  for (Ejers=Ejercito::TodosLosEjercitos.begin(); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      
      EjeX = Ejers->getEjercito();
         
      
      float X,Y;
      float delta;
      float sum_radios;
  
      int TMP = 60 * (rand() % 6);
      float MueveX = zcos(TMP);
      float MueveY = zsin(TMP);
  
      for (Ite=EjeX->begin(); Ite != EjeX->end(); Ite++)
	{
	  

	  if ((Yo->getTipomovimiento() == (*Ite)->getTipomovimiento()) ||
	      (Yo->getTipomovimiento() == "VEHICULO" && (*Ite)->getTipomovimiento() == "CAMINAR") ||
	      (Yo->getTipomovimiento() == "CAMINAR" && (*Ite)->getTipomovimiento() == "VEHICULO"))
	    {
	      
	      if (Yo != (*Ite) && (*Ite)->getEstado() != EstadoMuertoDestruido)
		{
		  X = (*Ite)->getLocalizacion().x;
		  Y = (*Ite)->getLocalizacion().y;
		  sum_radios = r + (*Ite)->getRadio();
		  
		  if ((fabs(X-x)<0.5) && (fabs(Y-y)<0.5))
		    {
		      delta = zDistancia(x, y, X, Y);
		      if (delta <= sum_radios )
			{   
			  
			  if ((*Ite)->getModo() == ModoNormal)
			    {
			      
			      (*Ite)->setModo(ModoAgresivo, 
					      (*Ite)->getLocalizacion().x + MueveX * (Yo->getRadio() + 0.12),
					      (*Ite)->getLocalizacion().y + MueveY * (Yo->getRadio() + 0.12),
					      0, 
					      (*Ite)->getLocalizacion().x, (*Ite)->getLocalizacion().y);
			      /*
			      (*Ite)->Dispersar((*Ite)->getLocalizacion().x + MueveX * (Yo->getRadio() + 0.12),
						(*Ite)->getLocalizacion().y + MueveY * (Yo->getRadio() + 0.12));
			      */
			    }
			  
			  
			  return true;
			}
		    }
		}
	    }
	}
      
    }
  return false;
}



// -------------------------------------------
// -------------------------------------------
// ------------- Eventos de Red --------------
// -------------------------------------------
// -------------------------------------------
// -------------------------------------------




// -------------------------------------------
// -------------------------------------------
// --------- Eventos de Teclado --------------
// -------------------------------------------
// -------------------------------------------

void Eventos::Teclado(unsigned char key, int x, int y) 
{
  switch( key )
    {
    case 127:
      Navegacion::ME()->setAngulo(-2);
      break;
    case 27:
      zSleep(500); // Le damos 500 Milisegundos para cerrar Hilos abiertos
      exit(0);
      break;
    case '-':
      Zoom = 1.0;
      break;
    case '+':
      Zoom = 0.6;
      break;  
    }


  if (key == 13) // ENTER BUTTON
    {
      switch (Eventos::ME()->MODO)
	{  
	case(pModoPartida):
	  {
	    //((pPartida*)pPantallas::PantallaActiva)->Chat("You",CadenaDeTeclado);
	    break;
	  } 
	case(pModoJuego):
	  {
	    break;
	  }
	}
      
      if (Eventos::ME()->MODO == pModoJuego)
	{
	
	}
      if (Eventos::ME()->MODO == pModoMenu)
	{
	  // menu stuff here
	}
    }
  else if (key == 8)
    {
      /*
      ChatSoFar.substr(0,ChatSoFar.size()-1);
      CadenaDeTeclado = CadenaDeTeclado.substr(0,CadenaDeTeclado.size()-1);
      ChatSoFar = CadenaDeTeclado + "|";
      ((pPartida*)pPantallas::PantallaActiva)->ChatSoFar = ChatSoFar;
      */
    }
  else if (key >= 32 && key < 127)
    {
      /*
      ChatSoFar.substr(0,ChatSoFar.size()-1);
      CadenaDeTeclado = CadenaDeTeclado + (char)key;
      ChatSoFar = CadenaDeTeclado + "|";
      ((pPartida*)pPantallas::PantallaActiva)->ChatSoFar = ChatSoFar;
      */	  
    }
}


//---------------------------------
void Eventos::TecladoS( int key, int x, int y ) {
  switch( key )
    {
    case 102:
      {
	Navegacion::ME()->setAngulo(2);
	break;
      }
    case 100:
      {
        Navegacion::ME()->setAngulo(-2);
	break;
      }

    case 103:
      Zoom = 1.0;
      break;
    case 101:
      Zoom = 0.6;
      break;  
    }
}







///////////////////////////////////////////////////////
//-----------------------------------------------------
//----------------- Eventos  GLuT ---------------------
//-----------------------------------------------------
///////////////////////////////////////////////////////


//---------------------------------
void zGlutMouseFunc(int button, int state, int x, int y)
{
  Mouse::ME()->MouseEventos (x, y, button, state);
}


//-----------------------------------
void zGlutMotionFunc(int x, int y)
{
  Mouse::ME()->MouseEventos (x, y, -1, -1); 
}


//-----------------------------------
void zGlutPassiveMotionFunc(int x, int y)
{
  Mouse::ME()->MouseEventos (x, y, -1, -1);
}


//-----------------------------------
void zGlutIdleFunc()
{ 

  switch (Eventos::ME()->getRenderModo())
    { 
    case(pModoJuego):
      {
	Eventos::ME()->Inactivo();
	break;
      }
    default:
      {
            	  
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	Solar3DWidGetEntorno::ME()->render();
	glutSwapBuffers();
	
	break;
      }
    }
  
  pantallaInicio::ME()->getEventos();

}

//-----------------------------------
void zGlutDisplayFunc()
{

  switch (Eventos::ME()->getRenderModo())
    {
    case(pModoNulo):
      {
	Eventos::ME()->Inicia();
	break;
      }
    case (pModoJuego):
      {
	Eventos::ME()->Render();
	break;
      }
    default:
      {	
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	Solar3DWidGetEntorno::ME()->render();
	glutSwapBuffers();
	break;
      }      
    }
}

//-----------------------------------
void zGlutReshapeFunc(int x, int y)
{
  Mouse::ME()->setPantalla(x, y);
  Eventos::ME()->Resize(x,y);
  Solar3DWidGetEntorno::ME()->resize(x, y);
}

//-----------------------------------
void zGlutKeyboardFunc(unsigned char key, int x, int y)
{
  Teclado::ME()->TecladoEventos(key,x,y);
}

//------------------------------------
void GlutKeyboardFuncS(int key, int x, int y)
{
  Teclado::ME()->TecladoEventos(key,x,y,true);
}




