#include "oCursor.h"


bool oCursor::Inicializada = false;
Textura oCursor::CursorAgresivo;
Textura oCursor::CursorGuardia;
Textura oCursor::CursorBandera;

// ---------------------
void oCursor::inicia ()
{

  if (!oCursor::Inicializada)
    {
      oCursor::CursorAgresivo = ServidorDeTexturas::ME()->Nueva("Interface/Punteros/agresivo.tga");
      oCursor::CursorGuardia = ServidorDeTexturas::ME()->Nueva("Interface/Punteros/guardia.tga");
      oCursor::CursorBandera = ServidorDeTexturas::ME()->Nueva("Interface/Punteros/bandera.tga");

      oCursor::Inicializada = true;
    }
  else
    {
      War3DWarning ("OCURSOR", "El objeto ya estaba inicializado");
    }
}


// ---------------------
void oCursor::Dibujame(int Tipo, float x, float y)
{

  miVistaGL.setVista(VistaGL_Ortogonal);

  float I = 0.04;


  if (oCursor::Inicializada)
    {

      glColor4f(1.0, 1.0, 1.0, 0.8);
      
      switch (Tipo)
	{
	case oCursorCursorAgresivo:
	  {
	    oCursor::CursorAgresivo.usaGLTextura(TextAltaCalidad);
	    break;
	  }
	case oCursorCursorGuardia:
	  {
	    oCursor::CursorGuardia.usaGLTextura(TextAltaCalidad);
	    break;
	  }
	case oCursorCursorBandera:
	  {
	    oCursor::CursorBandera.usaGLTextura(TextAltaCalidad);
	    break;
	  }
	}
      
      if (Tipo != oCursorCursorNinguno)
	{
	  glBegin (GL_QUADS);
	  { 

	    glTexCoord2f(0, 1);
	    glVertex2f(x+0 +0.010, y-I*1.1 +0.005);

	    glTexCoord2f(1, 1);
	    glVertex2f(x+I +0.010, y-I*1.1 +0.005);  

	    glTexCoord2f(1, 0);
	    glVertex2f(x+I +0.010, y-0     +0.005);

	    glTexCoord2f(0, 0);
	    glVertex2f(x+0 +0.010, y-0     +0.005);
    
	  }
	  glEnd();
	}
    }

  else
    {
      War3DWarning("OCURSOR", "No esta inicializado");
    }
 
}


