//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "oEdificio.h"
#include "ejercito.h"


// --------------------------
// Constructores y destructor
// --------------------------

// ---------------------------------------------
// Iniciamos
oEdificio::oEdificio (float x, float y, int ID, int internetID, bool Mio)
  :oObjetos(x, y, ID, internetID, Mio)
{
 
  setEstado (ConsModoNormal);
  
  // Inicializamos las variables de localizacion y destino del bicho

  setLocalizacion(x, y);

  setBichoLocalizacion(x, y - 0.5);

  // Para que la unidades voladoras comienzen en 0.5 del suelo. 
  // Despues poso a poco tomaran la altura que deben.
  
  Altura = 0.5;

  // Colocacmos al bicho en modo normal
  setModo(ConsModoNormal, 0.0, 0.0, 0, 0.0, 0.0);

  // Al morir el bicho, esta variable comienza a incrementarse
  // al llegar a cierto numero la unidad es borrada del ejercito.
  DesaparecerMuerto = -0.02;

  // La unidad no esta selecionada.
  Seleccionado = false;

  ContruccionAvance = 0;
  
  BichoTerminado = 0.0;
  
  // Variables de suavizado
  AnguloDeDisparoDib = AnguloDeDisparo;

}

// ---------------------------------------------
oEdificio::~oEdificio()
{
 
}


// --------------------------
// Render
// --------------------------

// --------------------------------------------
void oEdificio::dibujame (float Altura, z3DVector N, bool Seleccion)  // No requiere X y Y.
{

  AnguloDeDisparoDib = GiroSuave(AnguloDeDisparoDib, AnguloDeDisparo, int(Retardo/5.0));

  glEnable(GL_LIGHTING);
  
  glPushName(ID);

  if (DesaparecerMuerto > 0.0)
    {
      this->Altura = Altura - DesaparecerMuerto;
    }
  else
    {
      this->Altura = Altura;  
    }


  if (Seleccion)
    {

      if (ContruccionAvance >= MyArmy->sangre)
	{
	  MyArmy->Modelo->dibujame(getLocalizacion().x, this->Altura, getLocalizacion().y, Anima, Angulo, AnguloDeDisparoDib);
	}
      else
	{
	
	  MyArmy->Modelo->dibujame(getLocalizacion().x, this->Altura-0.3*(1.0-((float)ContruccionAvance/MyArmy->sangre)), getLocalizacion().y, Anima, Angulo, AnguloDeDisparoDib);
	  Construccion->dibujame(getLocalizacion().x, getLocalizacion().y, this->Altura);

	}
    }
  else
    {
      MyArmy->Modelo->dibujameSelect(getLocalizacion().x, this->Altura, getLocalizacion().y, Anima, Angulo);
    }
  
  glPopName();

}


// --------------------------
// Army
// --------------------------

// ---------------------------------------------
void oEdificio::onSetArmy()
{
  AnimPlayer = new animaEdificio(MyArmy->Modelo, "Normal");
  AnimPlayer->setAnimacion("estatico");
}

// --------------------------
// Tiempo y retardos
// --------------------------


// ---------------------------------------------
void oEdificio::onRetardo()
{

  if (ContruccionAvance <= MyArmy->sangre)
    {
      ContruccionAvance = ContruccionAvance + 40.0/Retardo;
    }

  vector<Ejercito>::iterator Ejers = Ejercito::TodosLosEjercitos.begin();

  if (Ejers->getEjercito()->size()+1 <= Ejers->getPoblacion())
    {
      if (ListaDeEspera.size() > 0 && getEstado() != EstadoMuertoDestruido)
	{
	  
	  if (BichoTerminado >= 1.0)
	    {
	      
	      oSoldado *Bicho;

	      for (int Num = 0; Num < 4 ; Num++)
		{
		  
		  Bicho = Ejers->addSoldado(*ListaDeEspera.begin(),
					    getLocalizacion().x, 
					    getLocalizacion().y, 0);
		  
		  Bicho->setModo(ModoAgresivo, 
				 getBichoLocalizacion().x,
				 getBichoLocalizacion().y,
				 0, 
				 Bicho->getLocalizacion().x, Bicho->getLocalizacion().y);
		  
		}

	      Bicho->PlayTerminado();      
	  
	      BichoTerminado = 0.0;
	      ListaDeEspera.erase(ListaDeEspera.begin());
	      
	    }
	  else
	    {
	      int costo = 0;
	      
	      for (int i=0 ; i<getNumUnidades() ; i++)
		{
		  // Vamos a ver si este edificio puede producir el tipo de unidad solicitada
		  if (((ConstruArmy*)MyArmy)->Unidades[i]->ID == *ListaDeEspera.begin())
		    {
		      costo = ((ConstruArmy*)MyArmy)->Unidades[i]->costo - 10;
		      break;
		    }
		}
	    
	  
	  
	      if (costo <= 0)
		{
		  War3DWarning("OEDIFICIO", "Intentando crear unidad de tipo no valido, consulta con Zeru");
		  return;
		}
	      
	      BichoTerminado = BichoTerminado + ((2.0/costo)/Retardo);
	    }
	}
    }
}

// --------------------------
// Modo y estado
// --------------------------

// -----------------------------------------
void oEdificio::setEstado(int Estado)
{

  if (getEstado() == Estado) return;

  switch(Estado)
    {
     case EstadoQuieto:
	  {
	    AnimPlayer->setAnimacion("estatico");
	    break;
	  }
    case EstadoDisparando:
      {
	if (getArmaLista())
	  { // Ya paso el tiempo de retardo entre un disparo y otro
	    //DisparoRetardo = 0;
	    AnimPlayer->setAnimacion("dispara");
	  }
	else
	  {
	    Estado = getEstado();
	  }
	break;
      }
    case  EstadoEdificioEsperandoADisparar:
      {
	AnimPlayer->setAnimacion("estatico");
	break;
      }
    }

 oObjetos::Estado = Estado;
}

// --------------------------
// Animaciones
// --------------------------

// ----------------------------------------
void oEdificio::playAnimacion()
{
  //Anima = AnimPlayer->getEstadoFrame();

  string Sonido;

  switch (getEstado())
    {


  case EstadoQuieto:
	{
	   Anima = AnimPlayer->getEstadoFrame();
	   break;
	}

    case EstadoDisparando:
      { // DISPARANDO
	

	if (ContruccionAvance < MyArmy->sangre)
	  { // Miramos si ya terminamos de construir el edificio.
	    setEstado(EstadoQuieto);
	    return;
	  }

	oObjetos* Victima = getPresaOSeguir();
	AnguloDeDisparo = 210 + zangulo(Victima->getLocalizacion().x-getLocalizacion().x, 
					Victima->getLocalizacion().y-getLocalizacion().y);
	
	Anima = AnimPlayer->getEstadoFrame(); 

	if (!getArmaLista()) return;
	
	if(PresaOSeguirID == 0)
	  {
	    setEstado(EstadoQuieto);
	    break;
	    
	  }
	else
	  {
	    
	    if (AnimPlayer->getEstadoName() != "dispara")
	      {
		
	
		if (ReproduciendoSonido == false)
		  {

		    // Lanimacion Dispara termino muy rapidadmente, la pc es algo lenta.
		    //War3DWarning ("OSOLDADO" , "Animacion Dispara, PC muy lenta o animacion nuy corta");
	    
		    Sonido = "Edificios/" + ((UnidadArmy*)MyArmy)->tipo + "/Sonidos/Misil/Disparo.wav";
		    SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura, Sonido);	 
			
			// Indicamos que el servidor de sonidos ya esta ocupado
		    ReproduciendoSonido = true;	
	
		    // Verificamos si aun esta al alcanze.
		    if (IntentaDisparo())
		      {	    
	
		
			// Hacemos el dao, aunque la animacion no se realizara.
			getPresaOSeguir()->setDanio(getPoder());

			z3DVector Inicio; 
			Inicio.x = getLocalizacion().x;
			Inicio.y = Altura+0.2;
			Inicio.z = getLocalizacion().y;
			
			z3DVector Fin;
			Fin.x = getPresaOSeguir()->getLocalizacion().x;
			Fin.y = getPresaOSeguir()->Altura+0.08;
			Fin.z = getPresaOSeguir()->getLocalizacion().y;

			ServidorDeDisparos::ME()->Nuevo(Inicio, Fin, ProyectilTipoBolaDeFuego);

			// La animacion Dispara termino
			
			setEstado(EstadoEdificioEsperandoADisparar);
			DisparoRetardo = 0;
	       			    
		      }
		  }

		ReproduciendoSonido = false;
	      }
	    else
	      {

		if (AnimPlayer->getEstadoPorciento() > 50)
		  {

		    if (ReproduciendoSonido==false)
		      {
			// Estamos a la mitad de la animacion Disparo

			// Reproducimos el sonido disparo
			Sonido = "Edificios/" + ((UnidadArmy*)MyArmy)->tipo + "/Sonidos/Misil.wav";
			SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura, Sonido);	    
			
			// Indicamos que el servidor de sonidos ya esta ocupado
			ReproduciendoSonido = true;	
		      }	
		
		    // Verificamos si aun esta al alcanze.

		    if (IntentaDisparo())
		      {   

			// Hacemos el dao
			
			getPresaOSeguir()->setDanio(getPoder());
			
			z3DVector Inicio; 
			Inicio.x = getLocalizacion().x;
			Inicio.y = Altura+0.2;
			Inicio.z = getLocalizacion().y;
			
			z3DVector Fin;
			Fin.x = getPresaOSeguir()->getLocalizacion().x;
			Fin.y = getPresaOSeguir()->Altura+0.08;
			Fin.z = getPresaOSeguir()->getLocalizacion().y;

			ServidorDeDisparos::ME()->Nuevo(Inicio, Fin, ProyectilTipoBolaDeFuego);

			setEstado(EstadoEsperandoADisparar);
			DisparoRetardo = 0;
		      }
			
		  }
	      }
	  }
	break;
      }

    case  EstadoEdificioEsperandoADisparar:
      {
	if (getArmaLista())
	  {

	    if(PresaOSeguirID == 0)
	      {
		setEstado(EstadoQuieto);
		break;
	      }

	    if (getPresaOSeguir()->getEstado() == EstadoMuertoDestruido)
	      {
		this->PresaOSeguirID = 0;
		DisparoRetardo = 0;
	      }
	    else
	      {	
		setEstado(EstadoDisparando);
	      }  
	  }
	break;
      }
    }

}



// --------------------------
// Disparos
// --------------------------

// ---------------------------------------------
void oEdificio::onSetDanio(int Danio)
{

 if (getEstado() == EstadoMuertoDestruido)
    {

      Explosion.Nueva(getLocalizacion().x, Altura, getLocalizacion().y, 0, getRadio());

    }
  else
    {
  
    }
}

// ---------------------------------------------
void oEdificio::onIntentaDisparo(bool Alcanzado)
{
 if (Alcanzado)
    {
      if (!getMio()) Tierra::ME()->fow.ilumina(getLocalizacion().x,  getLocalizacion().y, 0.3 , 0);

      if (getArmaLista())
	{
	 
	}
    } 
 else
   {
     setEstado(EstadoQuieto);
   }
}

// --------------------------
// Sonidos
// --------------------------

// ---------------------------------------------
void oEdificio::PlayTerminado()
{

}

// ----------------------------------------
void oEdificio::PlaySeleccionado()
{

  // FALTA PONER BIEN EL SONIDO QUE ES

  string Sonido;
  Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/sonido01.wav";
  SoundServer::ME()->PlayWav(getLocalizacion().x, getLocalizacion().y, Altura, Sonido);
}

// ---------------------------------------------
void oEdificio::PlayMuerto()
{

  // FALTA PONER BIEN EL SONIDO QUE ES

  // Reproducimos el sonido de muerte de esta unidad, espesificado por el army
  string Sonido;

  Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/sonido02.wav";
  SoundServer::ME()->PlayWav(getLocalizacion().x, getLocalizacion().y,Altura, Sonido);
  
}


// --------------------------
// Army
// --------------------------

//---------------------------------------------
int oEdificio::getCostoUnidad(int UnidadTipo)
{
  int Costo = 0;
  for (int i=0 ; i<getNumUnidades() ; i++)
    {
      // Vamos a ver si este edificio puede producir el tipo de unidad solicitada
      if (((ConstruArmy*)MyArmy)->Unidades[i]->ID == UnidadTipo)
	{
	  Costo = ((ConstruArmy*)MyArmy)->Unidades[i]->costo;
	  break;
	}
    }
  return Costo;
}

// --------------------------
// Constructor
// --------------------------

//---------------------------------------------
void oEdificio::setEdificioContructor(oConstruye *Construccion)
{
  this->Construccion = Construccion;
}


// --------------------------
// Nuevos Bichos
// --------------------------

// ----------------------------------------
int oEdificio::nuevoBicho (int Tipo)
{

  if (ContruccionAvance >= MyArmy->sangre)
    {
      // El edificio ya esta terminado
      
      // Vamos a crear un nuevo Bichito, lo ponemos en la lista de espera.
      if (ListaDeEspera.size() < 6)
	{

	  int costo = getCostoUnidad(Tipo);

	  cout << "Costo: " << costo << endl;
	 
	  if (costo == 0)
	    {
	      War3DWarning("OEDIFICIO", "Intentando crear unidad de tipo no valido, consulta con Zeru");
	      return  NuevoBichoError_BichoNoValido;
	    }

	  vector<Ejercito>::iterator Ejers = Ejercito::TodosLosEjercitos.begin();

	  if (Ejers->getEjercito()->size()+1 <= Ejers->getPoblacion())
	    {
	      
	      if (Ejers->getRecursos()->gastaRecursos(costo, 0))
		{
		  ListaDeEspera.push_back(Tipo);
		}
	      else
		{
		  return NuevoBichoError_NoHayRecursos;
		}
	    }
	  else
	    {
	      return NuevoBichoError_LimiteDePoblacion;
	    }

	}
      else
	{
	  cout << "Mensaje de error: Demaciados bichos en espera" << endl;
	  return NuevoBichoError_MuchoEnCola;
	}
    }
  else
    {
      cout << "Mensaje de error: Edificion aun no terminado" << endl;
      return NuevoBichoError_EdificioNoTerminado;
    }

  return NuevoBichoError_TodoOK;
}


// -----------------------
void oEdificio::cancelaBicho (unsigned int Index)
{

  vector<int>::iterator Ite;
  if (Index >= 0 && Index < ListaDeEspera.size())
    {
      unsigned int Contador = 0;
      for (Ite = ListaDeEspera.begin(); Ite != ListaDeEspera.end(); Ite++)
	{
	  if (Contador == Index)
	    {

	      if (Index == 0)
		{
		  BichoTerminado = 0.0;
		}

	      int costo = 0;
	      for (int i=0 ; i<getNumUnidades() ; i++)
		{
		  // Vamos a ver si este edificio puede producir el tipo de unidad solicitada
		  if (((ConstruArmy*)MyArmy)->Unidades[i]->ID == *Ite)
		    {
		      costo = ((ConstruArmy*)MyArmy)->Unidades[i]->costo;
		      
		      cout << "Costo: " << costo << endl;
		      break;
		    }
		}


	      Ejercito::TodosLosEjercitos.begin()->getRecursos()->adquiereRecursos(costo, 0);

	      cout << "Devuelto: " << costo << endl;
	      cout << "ID: " << Index  << endl;

	      ListaDeEspera.erase(Ite);
	      return;
	    }
	  Contador ++;
	}
    }
  else
    {
      War3DWarning("OEDIFICIO", "El bicho no eiste, no se puede cancelar");
    }
}
