//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "oSoldado.h"

#include "ejercito.h"

#include "pantallaInicio.h"

// --------------------------
// Constructores y destructor
// --------------------------

// ---------------------------------------------
// Iniciamos
oSoldado::oSoldado (float x, float y, int ID, int internetID, bool Mio)
  :oObjetos(x, y, ID, internetID, Mio)
{
   
  Camino = new IACamino;
  
  // Inicializamos las variables de localizacion y destino del bicho

  setLocalizacion(x, y); 
  destino.x = x;
  destino.y = y;
  semiDestino.x = destino.x;
  semiDestino.y = destino.y;


  if (Mio)
    {
      Tierra::ME()->fow.ilumina(getLocalizacion().x, getLocalizacion().y, 1.0 , 0);
    }

  // Para que la unidades voladoras comienzen en 0.5 del suelo. 
  // Despues poso a poco tomaran la altura que deben.
  
  Altura = 0.5;
  AlturaDeVuelo = 0.6;

  // Colocacmos al bicho en modo normal  
  Modo = ModoNormal;
  Estado = EstadoQuieto;
  PresaOSeguirID = 0;

  // Inicializamos
  Camino->Pasos = 0;
  DisparoRetardo = 0;
  guardiaMeta = true;

  // Al morir el bicho, esta variable comienza a incrementarse
  // al llegar a cierto numero la unidad es borrada del ejercito.
  DesaparecerMuerto = -0.30;

  Experiencia = 0;

  // Variables de suavizado
  AnguloDib = 0.0;
  NormalDib.x = 0.0; NormalDib.y = 0.0; NormalDib.z = 0.0;
  AlturaDeVueloDib = 0.0;


}

//  ---------------------------------------------
oSoldado::~oSoldado()
{

  // cout << "Sol: " << (int)Camino->path << endl;   
  // Esta parte esta danod problemas por eso esta comentada

}


// --------------------------
// Render
// --------------------------

// --------------------------------------------
void oSoldado::dibujame (float Altura, z3DVector N, bool Seleccion)  // No requiere X y Y.
{

  AnguloDib = GiroSuave(AnguloDib, Angulo, int(Retardo/4.0));
  NormalDib = VectorSuave(NormalDib, N, int(Retardo/4.0));
  AlturaDeVueloDib = LineaSuave(AlturaDeVueloDib, AlturaDeVuelo, int(Retardo/2.0));

  glEnable(GL_LIGHTING);
  
  if (DesaparecerMuerto > MinimoDesaparece)
    {
      return;
    }

  glPushName(ID);


  if (DesaparecerMuerto > 0.0)
    {
      this->Altura = Altura - DesaparecerMuerto;
    }
  else
    {
      if (((UnidadArmy*)MyArmy)->tipomovimiento == "VOLAR")
	{
	  this->Altura = Altura + AlturaDeVueloDib;  
	}
      else
	{
	  this->Altura = Altura;  
	}
    }


  if (Seleccion)
    {
      if (((UnidadArmy*)MyArmy)->tipomovimiento == "VEHICULO") 
	{
	  MyArmy->Modelo->dibujame(getLocalizacion().x, this->Altura, getLocalizacion().y, Anima, AnguloDib, NormalDib, AnguloDib);
	}
      else if (((UnidadArmy*)MyArmy)->tipomovimiento == "VOLAR")
	{
	   MyArmy->Modelo->dibujame(getLocalizacion().x, this->Altura, getLocalizacion().y, Anima, AnguloDib, AnguloDib);
	}
      else
	{
	  MyArmy->Modelo->dibujame(getLocalizacion().x, this->Altura, getLocalizacion().y, Anima, AnguloDib, AnguloDib);
	}
    }
  else
    {
      MyArmy->Modelo->dibujameSelect(getLocalizacion().x, this->Altura, getLocalizacion().y, Anima, Angulo);
    }
  
  glPopName();

  onDibujame();
  
}


// --------------------------------------------
float oSoldado::getAngulo()
{ 

  // Hacia donde esta mirando el bicho ?
  // El path finder usa esta informacion para optimizar la busqueda,
  // si el bicho esta mirando hacia 37 lo mas probable es que seguir 
  // caminando hacia 37 sea lo mejor.
  
  if ((destino.x != getLocalizacion().x) || (destino.y != getLocalizacion().y))
    {
      //float ang = zangulo((destino.y - localizacion.y),(destino.x - localizacion.x)) ;
      float ang = zangulo(Camino->path[Camino->p+1].x - Camino->path[Camino->p].x, Camino->path[Camino->p+1].y - Camino->path[Camino->p].y);
      
      return ang;
      
    }
    
  // Si no estamos caminado, mejor ni calculamos nada.

  return Angulo;
}



// --------------------------
// Army
// --------------------------

void oSoldado::onSetArmy()
{
  AnimPlayer = new animaSoldado(MyArmy->Modelo, ((UnidadArmy*)MyArmy)->tipomovimiento);
  AnimPlayer->setVelocidadCorrer(((UnidadArmy*)MyArmy)->velocidad);
  AnimPlayer->setAnimacion("alto");
}


// --------------------------
// Timepo y retardos
// --------------------------

// --------------------------------------------
void oSoldado::onRetardo()
{

}


// --------------------------------------------
void oSoldado::onClock_1_00Sec()
{
  DebugueadorXP = 3001;

  if ((Camino->Pasos - getPaso()) < 4 )  /// ZG. Este Bloque no deberia estar aqui.Tengo que reorganizar algunas cosas
    {
      ContinuarCamino(); 
    }
}



// --------------------------
// Modo y estado
// --------------------------

/// ---------------------------------------
void oSoldado::setModo(int Modo, float x, float y, int Extra, float NetX, float NetY)
{

  // NOTA, los parametros NetX y NetY, son dedundantes, sin embargo nesesarios para
  // poder sincronizar los War3D conectados entre si.
  // NetX y NetY contienen la posicion del bicho, desde el punto de vista de cada usuario
  // es decir NetX = getLocalizacion().x  y  NetY = getLocalizacion().y sin embargo puede que no coincidan
  // esactamente, debido a la des-sincronizacion.

  oObjetos *PresaOSeguir = Ejercito::getBichoReferencia(Extra);
  if (PresaOSeguir == (oObjetos*)NULL)
    {
      PresaOSeguir = Ejercito::getEdificioReferencia(Extra);
    }

  DebugueadorXP = 12;

  oObjetos::Modo = Modo;
    
  float DisActual;
  float DisNuevo;

  if(Modo == ModoCazador)

    {
      //cout << "Tengo que Cazar a esta unidad: " << PresaOSeguir->ID << endl;

      this->PresaOSeguirID = Extra;

      setDestino(0, 0, NetX, NetY);


      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, 
				 PresaOSeguir->ID, PresaOSeguir->internetID);
	}
      return;
    }

  if (Modo == ModoVengativo)
    {


      // ZG Un nuevo bicho esta disparando a esta unidad
      // Vamos a verificar si es combeniente ir a por ella o contituar defendiendonos de las otras que nos disparan.
      // De todas las que nos disparan atacaremos a la que esta mas cerca.


      if (PresaOSeguir != (oSoldado*)NULL)
	{
	  // ZG Medimos la distancia entre nosotros y la unidad NUEVA que nos dispara.
	  DisNuevo = fabs(getLocalizacion().x - PresaOSeguir->getLocalizacion().x) +
	    fabs(getLocalizacion().y - PresaOSeguir->getLocalizacion().y);
	}
      else
	{
	  // ZG Esta condicion de deberia ocurrir nunca, pero la debugueamos por si las dudas.
	  War3DWarning ("oSOLDADO", "Modo Vengativo con unidad nula");
	  cout << "Referencia: " << Extra << "   ID: " << ID << endl; 
	  DisNuevo = 999999;
	}
      

      if (this->PresaOSeguirID != 0)
	{
	  // ZG MEdimos las distancia entre el vicho al cual estamos atacando
	  DisActual =  fabs(getLocalizacion().x - getPresaOSeguir()->getLocalizacion().x) +
	    fabs(getLocalizacion().y - getPresaOSeguir()->getLocalizacion().y);
	}
      else
	{
	  // ZG Si no estabamos atacando a nadie hacemos que la distancia sea infinita.
	  DisActual = 999999;
	}


      if (DisActual < DisNuevo)
	{
	  // Comparamos las distancias , si la distancia actual es menor, seguimos atacando al mismo bicho
	  return;
	}
      else
	{
	  // Si la distancia del nuevo atacante es menor, cambiamos a atacarlo a el.
	  this->PresaOSeguirID = Extra;
	}
		 
    
      //cout << "Tengo que Cazar a esta unidad: " << PresaOSeguir->ID << endl;
      setDestino(0, 0, NetX, NetY);
      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, 
				 PresaOSeguir->ID, PresaOSeguir->internetID);
	}
      return;
    }
 


  this->PresaOSeguirID = 0;

 
  if(Modo == ModoGuardaEspaldas)
    {
      this->PresaOSeguirID = Extra;
      setDestino(PresaOSeguir->getLocalizacion().x, PresaOSeguir->getLocalizacion().y, NetX, NetY);
      //cout << "Tengo que Cuidar a esta unidad: " << PresaOSeguir->ID << endl;
      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, 
				 PresaOSeguir->ID, PresaOSeguir->internetID);
	}
      return;
    }

  


  if (Modo == ModoGuardia)
    {
      destinoGuardia[0].x = NetX;
      destinoGuardia[0].y = NetY;
      destinoGuardia[1].x= x;
      destinoGuardia[1].y= y;
      setDestino(x, y, NetX, NetY);
      guardiaMeta = true;
      
      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, -1, -1);
	}
      return;
    }
 
  if(Modo == ModoNormal)
    {
      setEstado(EstadoQuieto);
        if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, -1, -1);
	}
      return;
    }

  if(Modo == ModoQuieto)
    {
      setEstado(EstadoQuieto);
      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, -1, -1);
	}
      return;
    }

  if(Modo == ModoCaminoFijo)
    {
      setDestino(x, y, NetX, NetY);
      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, -1, -1);
	}
        setEstado(EstadoCorriendo);
      return;
    }

  if(Modo == ModoAgresivo)
    {
      setDestino(x, y, NetX, NetY);
      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, -1, -1);
	}
      return;
    }


  if (Modo == ModoDestruyeEdificio)
    {
      cout << "Destruye edificio: " << Extra << endl;

      oEdificio *EdificioEnemigo = Ejercito::getEdificioReferencia(Extra);

      PresaOSeguirID = Extra;

      setDestino(EdificioEnemigo->getLocalizacion().x, EdificioEnemigo->getLocalizacion().y, NetX, NetY);
      //cout << "Tengo que Cuidar a esta unidad: " << PresaOSeguir->ID << endl;
      if (getMio())
	{
	  pantallaInicio::ME()->sendMOD(Modo, ID, x, y, getLocalizacion().x, getLocalizacion().y, 
				 PresaOSeguir->ID, PresaOSeguir->internetID);
	}

      return;
    }


  
  War3DWarning("OSOLDADO","El metodo setModo esta usandose inapropiadamente");
  cout << "Modo: " << Modo << endl;
}


// -----------------------------------------
void oSoldado::setEstado(int Estado)
{

DebugueadorXP = 9;

  if (getEstado() == Estado) return;

  switch(Estado)
    {
    case EstadoQuieto:
      {
	Camino->Pasos = 0;
	Camino->p = 0;
	AnimPlayer->setAnimacion("alto");
	break;
      }
    case EstadoHerido:
      {
	if (getEstado() == EstadoDisparando) return;
	EstadoAnterior = getEstado();
	AnimPlayer->setAnimacion("herido");

	break;
      }
    case EstadoDisparando:
      {
	if (getArmaLista())
	  { // Ya paso el tiempo de retardo entre un disparo y otro
	    //DisparoRetardo = 0;
	    AnimPlayer->setAnimacion("dispara");
	  }
	else
	  {
	    Estado = getEstado();
	  }
	break;
      }
    case EstadoCorriendo:
      {
	AnimPlayer->setAnimacion("camina");
	break;
      }
    case EstadoEsperandoADisparar:
      {
	break;
      }
      
    case EstadoMuertoDestruido:
      {
	AnimPlayer->setAnimacion("muerto");
	break;
      }

    default:
      {
	AnimPlayer->setAnimacion("alto");
	cout << "[Error] Estado no contemplado: " << Estado << endl;
      }
    }

  oObjetos::Estado = Estado;
}



// --------------------------
// Animaciones
// --------------------------

// ----------------------------------------
void oSoldado::playAnimacion()
{
 
DebugueadorXP = 10;


  string Sonido;

  switch (getEstado())
    {
    case EstadoQuieto:
      { // QUIETO
	
	Anima = AnimPlayer->getEstadoFrame();  

	if (ContadorAzar > (150 + Azar/10)) 
	  {
	    AnimPlayer->setAnimacion("ocioso");
	    ContadorAzar = 0;
	  }
	else 
	  {
	    ContadorAzar += 10.0/Retardo;
	  }

	
	if (AnimPlayer->getEstadoName() != "ocioso")
	  {

	    ReproduciendoSonido = false;
	  }
	else
	  {
	    if (AnimPlayer->getEstadoPorciento() > 50 && ReproduciendoSonido==false)
	      {

		// Estamos a la mitad de la animacion Ocioso

		SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura,"UnidadesDeCombate/Humaniode/Arma/Basuca/Sonido01.wav");

		// Indicamos que el servidor de sonidos ya esta ocupado
		ReproduciendoSonido = true;
	      }
	  }
	break;
      }
  

    case EstadoHerido:
      { // HERIDO

	Anima = AnimPlayer->getEstadoFrame();      
	if (AnimPlayer->getEstadoName() != "herido")
	  {
	    // Se cabao la animacion Herido
	    setEstado(EstadoAnterior);
	  }

	break;
      }
  

    case EstadoDisparando:
      { // DISPARANDO
	

        if (getModo() == ModoGuardaEspaldas)
	  {
	    setEstado(EstadoCorriendo);
	  }

	Anima = AnimPlayer->getEstadoFrame();    


	if (!getArmaLista()) return;


	if(PresaOSeguirID == 0)
	  {
	    setEstado(EstadoCorriendo);
	    break;
	    
	  }
	else
	  {
	    if (AnimPlayer->getEstadoName() != "dispara")
	      {
		
		if (ReproduciendoSonido == false)
		  {

		    // Lanimacion Dispara termino muy rapidadmente, la pc es algo lenta.
		    //War3DWarning ("OSOLDADO" , "Animacion Dispara, PC muy lenta o animacion nuy corta");
	    
		    Sonido = "UnidadesDeCombate/" + ((UnidadArmy*)MyArmy)->tipo + "/Arma/" + ((UnidadArmy*)MyArmy)->arma + "/Sonido02.wav";	

	
		    // Verificamos si aun esta al alcanze.
		    if (IntentaDisparo())
		      {	    
	
		
			// Hacemos el dao, aunque la animacion no se realizara.
			getPresaOSeguir()->setDanio(getPoder());

			z3DVector Inicio; 
			Inicio.x = getLocalizacion().x;
			Inicio.y = Altura+0.1;
			Inicio.z = getLocalizacion().y;
						
			z3DVector Fin;
			Fin.x = getPresaOSeguir()->getLocalizacion().x;
			Fin.y = getPresaOSeguir()->Altura+0.1;
			Fin.z = getPresaOSeguir()->getLocalizacion().y;

			ServidorDeDisparos::ME()->Nuevo(Inicio, Fin, ProyectilTipoBala);
			    
			Experiencia = Experiencia + getPoder();

			// La animacion Dispara termino
			
			setEstado(EstadoEsperandoADisparar);
			DisparoRetardo = 0;

		      }
		  }

		ReproduciendoSonido = false;
	      }
	    else
	      {

		if (AnimPlayer->getEstadoPorciento() > 50)
		  {

		    if (ReproduciendoSonido == false)
		      {		  

			// Estamos a la mitad de la animacion Disparo
			
			// Reproducimos el sonido disparo
			Sonido = "UnidadesDeCombate/" + ((UnidadArmy*)MyArmy)->tipo + "/Arma/" + ((UnidadArmy*)MyArmy)->arma + "/Sonido02.wav";
			SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura, Sonido);	    
			
			// Indicamos que el servidor de sonidos ya esta ocupado
			ReproduciendoSonido = true;		
		      }		

		    // Verificamos si aun esta al alcanze.

		    if (IntentaDisparo())
		      {
		    
			// Hacemos el dao
			getPresaOSeguir()->setDanio(getPoder());

			z3DVector Inicio; 
			Inicio.x = getLocalizacion().x;
			Inicio.y = Altura+0.1;
			Inicio.z = getLocalizacion().y;
			
			z3DVector Fin;
			Fin.x = getPresaOSeguir()->getLocalizacion().x;
			Fin.y = getPresaOSeguir()->Altura+0.1;
			Fin.z = getPresaOSeguir()->getLocalizacion().y;

			ServidorDeDisparos::ME()->Nuevo(Inicio, Fin, ProyectilTipoBala);
						
			Experiencia = Experiencia + getPoder();

			setEstado(EstadoEsperandoADisparar);
			DisparoRetardo = 0;

		      }
		  }
	      }
	  }

	break;

      }

    case EstadoEsperandoADisparar:
      {
	if (getArmaLista())
	  {

	    if(PresaOSeguirID == 0)
	      {
		setEstado(EstadoCorriendo);
		break;
	      }

	    if (getPresaOSeguir()->getEstado() == EstadoMuertoDestruido)
	      {
		this->PresaOSeguirID = 0;
		if(getModo() == ModoAgresivo)
		  {
		    setEstado(EstadoCorriendo);
		  }
		else
		  {
		    setModo(ModoNormal, 0.0, 0.0, 0, getLocalizacion().x, getLocalizacion().y);
		  }
		DisparoRetardo = 0;
	      }
	    else
	      {	
		if (getModo() == ModoCaminoFijo)
		  {
		    setEstado(EstadoCorriendo);
		  }
		else
		  {
		    setEstado(EstadoDisparando);
		  }
	      }  
	  }
	break;
      }
    

    case EstadoCorriendo:
      { // CORRIENDO
	Anima = AnimPlayer->getEstadoFrame();
	break;

      }

      
    case EstadoMuertoDestruido:
      { // MUERIENDO

	Anima = AnimPlayer->getEstadoFrame();

	if (AlturaDeVuelo > 0.00)
	  {
	    AlturaDeVuelo = AlturaDeVuelo - 0.20/Retardo;
	  }

	break;
      }
    }
}


// --------------------------
// Disparos
// --------------------------

// ---------------------------------------------
void oSoldado::onSetDanio(int Danio)
{

  if (getEstado() == EstadoMuertoDestruido)
    {

      // BORRAME NOTA, PUEDE SER que se esten activando mas de Una Explosion, CORREGIR

      if (((UnidadArmy*)MyArmy)->tipomovimiento == "VEHICULO") 
	{
	  DesaparecerMuerto = 0.01;
	}

      if(((UnidadArmy*)MyArmy)->tiposer == "ORGANICO")
	{
	  Explosion.Nueva(getLocalizacion().x, Altura, getLocalizacion().y, 1, getRadio());
	}
      else if (((UnidadArmy*)MyArmy)->tiposer == "MECANICO")
	{
	  Explosion.Nueva(getLocalizacion().x, Altura, getLocalizacion().y, 0, getRadio());
	}
    }
  else
    {

      // Aun no se muere, la ponemos en estado herido, para que se reproducsca la animacion de herido.
      setEstado(EstadoHerido);
    }
}

// --------------------------
// Sonidos
// --------------------------

// ----------------------------------------
void oSoldado::PlayTerminado()
{
  string Sonido;

  Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/ready1.wav";    
  SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura, Sonido);   
}


// ----------------------------------------
void oSoldado::PlaySeleccionado()
{
  string Sonido;

  int SonidoAlAzar = rand() % 3;
 
  switch (SonidoAlAzar)
    {
    case 0: Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/ready2.wav";
      break;
    case 1: Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/ready3.wav";
      break;
    case 2: Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/ready4.wav";
      break;
    }

  SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura, Sonido);   
}

// ----------------------------------------
void oSoldado::PlayMuerto()
{
  string Sonido;

  int SonidoAlAzar = rand() % 2;
 
  switch (SonidoAlAzar)
    {
    case 0: Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/muerte01.wav";
      break;
    case 1: Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/muerte02.wav";
      break;
    }

  SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura, Sonido);   
}




// ----------------------------------------
void oSoldado::PlayOk()
{
  string Sonido;

  int SonidoAlAzar = rand() % 2;
 
  switch (SonidoAlAzar)
    {
    case 0: Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/ok1.wav";
      break;
    case 1: Sonido = "UnidadesDeCombate/" + MyArmy->tipo + "/Sonidos/" + MyArmy->sonidos + "/ok2.wav";
      break;
    }

  SoundServer::ME()->PlayWav(getLocalizacion().x,getLocalizacion().y,Altura, Sonido);   
}

// --------------------------
// Disparos
// --------------------------

// ---------------------------------------------
void oSoldado::onIntentaDisparo(bool Alcanzado)
{
  if (Alcanzado)
    {
      if (!getMio()) Tierra::ME()->fow.ilumina(getLocalizacion().x,  getLocalizacion().y, 0.3 , 0);

      if (getArmaLista())
	{
	  oObjetos* Victima = getPresaOSeguir();
	  Angulo = zangulo(Victima->getLocalizacion().x-getLocalizacion().x, 
			   Victima->getLocalizacion().y-getLocalizacion().y);
	}
    } 
  else
    {
      setEstado(EstadoCorriendo); 
    }
}


// --------------------------
// Caminar
// --------------------------

// ---------------------------------------------
void oSoldado::IntentaMovimiento(int angulo)
{


DebugueadorXP = 4001;

  // Este metodo se encarga de mover al bicho a la siguente posicion.
  // este metodo es llamado varias veces en pathfinder de eventos, la funcion mueve el bicho 
  // un pacito, si al dar el paso chocamos con algo, se desace el movimiento e eintentamos 
  // en otra direccion.

  // La variable Retardo nos dice que tan rapido debemos vomer las cosa, y hacer las animaciones
  // para que todo se vea igual en maquinas lentas o rapidas.

  if (!(getEstado() == EstadoCorriendo || getEstado() == EstadoQuieto))
    {
      // Si el bicho no esta corriendo o esta Quieto (hay otros estados), 
      // no es nesesario que calculemos lo demas.
      return;
    }

DebugueadorXP = 4002;

  if (getModo() == ModoGuardia && Camino->Pasos == 0)
    {
      // Si el bicho esta en modo guardia
      float MiRadio;
      if (((UnidadArmy*)MyArmy)->tipomovimiento == "VOLAR")
	{
	  MiRadio = 0;
	}
      else
	{
	  MiRadio = getRadio();
	}

      AStar::ME()->getPath(getLocalizacion().x, 
			   getLocalizacion().y,
			   getDestino().x,
			   getDestino().y,
			   Camino,
			   MiRadio);
      return;
    }

DebugueadorXP = 4003;
  if (getModo()== ModoGuardaEspaldas) 
    {

      
      oSoldado *BichoEnemigo = (oSoldado*)getPresaOSeguir();
      
      if (BichoEnemigo->getEstado() == EstadoMuertoDestruido)
	{

	  setModo(ModoAgresivo, 		  
		  BichoEnemigo->getLocalizacion().x,
		  BichoEnemigo->getLocalizacion().y,
		  0, 
		  getLocalizacion().x, 
		  getLocalizacion().y);
	  return;

	}

      // Si el bicho esta en modo guarda espalda, es decir siguiendo a otro bicho
      // calculamos la distancia a la que se encuantra del otro bicho
      float DistanciaEntreBichos;
      DistanciaEntreBichos =  zDistancia(getLocalizacion().x, 
					 getLocalizacion().y, 
					 BichoEnemigo->getLocalizacion().x, 
					 BichoEnemigo->getLocalizacion().y);

      
      // Si ya esta muy cercas, lo detenemos, para que no quede demaciado cercas.
      if (DistanciaEntreBichos < SeguirADistancia/Densidad)
	{
	  // Lo detenemos
	  setEstado(EstadoQuieto);
	  return;
	}
    }
     
DebugueadorXP = 4004;
  if (Camino->Pasos == 0)
    {
      //en cualquier otro modo, si ya compretamos el camino, ponemos al bicho en modo quieto
      setEstado(EstadoQuieto);
      return;
    }
  

  if (Camino->Pasos != 1)
    {
      DebugueadorXP = 4005;
      
      // Vamos a mirar si es posible que el paso que dimos fue demaciado grande
      // en tal caso hay tal vez tengamos que incrementar paso mas de una vez.
      // Si el paso fue demaciado pequeo, entonces no no imcrementamos paso.
      // En teoria se puede confiar en que el bucle se rompera en algun momento
      // pero la teoria me falla ultimamente :), por eso solo lo intentamos 7 veces.
      // en una PC extremadamente lenta se requeririan a lo mas 4.
      for(int j=0; j<7 ; j++)
	{
	  if (zDistancia(Camino->path[Camino->p].x, Camino->path[Camino->p].y, getLocalizacion().x, getLocalizacion().y) > 
	      zDistancia(Camino->path[Camino->p+1].x, Camino->path[Camino->p+1].y, getLocalizacion().x, getLocalizacion().y))
	    {
	      Camino->p++;

	       if (getMio())
		 {
		   Tierra::ME()->fow.ilumina(getLocalizacion().x, getLocalizacion().y, getAlcance()*2.0 , 0);
		 }
	      
	      if (Camino->p >= Camino->Pasos)
		{

		  if (getModo() == ModoGuardia)
		    {
		      int i;      
		      if (guardiaMeta){i=0;}else{i=1;}
		      guardiaMeta = !guardiaMeta;
		      setDestino(destinoGuardia[i].x, destinoGuardia[i].y, getLocalizacion().x, getLocalizacion().y);
		      setEstado(EstadoQuieto);
		      return;
		    }

		  if (getModo()!= ModoGuardaEspaldas) 
		    {
		      setModo(ModoNormal, 0.0, 0.0, 0, getLocalizacion().x, getLocalizacion().y);
		      return;
		    }
		}
	      if (j >= 4) cout << "[[PC Lento]]: " << j << endl;
	    }
	  else
	    {
	      break;
	    }
	}
      semiDestino.x = Camino->path[Camino->p+1].x;
      semiDestino.y = Camino->path[Camino->p+1].y;
    }
  else
    {
DebugueadorXP = 4006;

      semiDestino.x = Camino->path[0].x;
      semiDestino.y = Camino->path[0].y;
      if (getModo()!= ModoGuardaEspaldas && getModo() != ModoGuardia) 
	{
	  setModo(ModoNormal, 0.0, 0.0, 0, getLocalizacion().x, getLocalizacion().y);
	}
    }
  
DebugueadorXP = 4007;
  setEstado(EstadoCorriendo); 
  
  float distx;
  float disty;
  float TMPang;
  
  distx = (semiDestino.x - getLocalizacion().x);
  disty = (semiDestino.y - getLocalizacion().y);
  
DebugueadorXP = 4008;
  
  TMPang = zangulo(distx, disty);
  //  cout << "Ant Ang: " << TMPang;
  
  angulo = angulo + (int)TMPang;
  
  distx = zsin(angulo);
  disty = zcos(angulo);
  
  //TMPang = zangulo(distx, disty);
  //cout << "    Desp Ang: " << TMPang << endl;
  
  double Magnitud;

DebugueadorXP = 4009;	
  
  Magnitud = zDistancia (0,0,distx,disty);
  // Se normalisa el movimiento, para que se avanse en x,y una distancia constante
  distx = distx / (float)Magnitud;				
  disty = disty / (float)Magnitud;
  
  // Se calcula la velocidad, tomando en cuenta el retardo y la velocidad asignada
  // al bicho ya que hay algunos mas rapidos que otros.
  float LaVelocidad = (0.12/Retardo)*((UnidadArmy*)MyArmy)->velocidad;
     
  float VelocidadPonderada = Tierra::ME()->getVelocidadPonderada(getLocalizacion().x, getLocalizacion().y, Angulo);

  if (((UnidadArmy*)MyArmy)->tipomovimiento == "VOLAR")
    {
      VelocidadPonderada = 1.0;
    }

  // Hacemos el incremento en X y Y
  setLocalizacion(getLocalizacion().x + (distx * LaVelocidad) * VelocidadPonderada,
		  getLocalizacion().y + (disty * LaVelocidad) * VelocidadPonderada);

DebugueadorXP = 4010;
  
  // Calculamos el angulo hacia el cual mira el bicho.
  if ((semiDestino.x != getLocalizacion().x) || (semiDestino.y != getLocalizacion().y))
    {
      Angulo = zangulo(distx, disty);
    }
   
}


// ---------------------------------------------
void oSoldado::ContinuarCamino()
{
  

DebugueadorXP = 11; 


  if ((getModo() == ModoVengativo) || (getModo() == ModoCazador))
    {
	  if (PresaOSeguirID == 0) 
	  {
		  DebugueadorXP = 11001; 
		  setModo(ModoNormal, 0.0, 0.0, 0, getLocalizacion().x, getLocalizacion().y); 
	  }
	  else
	  {
	    DebugueadorXP = 11002;
	    oSoldado* BichoEnemigo = (oSoldado*)getPresaOSeguir();
	    if (PresaOSeguirID == 0) 
	      {
		DebugueadorXP = 11001; 
		setModo(ModoNormal, 0.0, 0.0, 0, getLocalizacion().x, getLocalizacion().y); 
	      }
	    else
	      {
		setModo( getModo(), BichoEnemigo->getLocalizacion().x,  BichoEnemigo->getLocalizacion().y , PresaOSeguirID, getLocalizacion().x, getLocalizacion().y);
	      }
	  }
    }

  if (getModo() == ModoGuardaEspaldas)
    {

      if (PresaOSeguirID != 0) 
	{

	  DebugueadorXP = 11003;

	  oSoldado* BichoEnemigo = (oSoldado*)getPresaOSeguir();

	  if ((fabs(BichoEnemigo->getLocalizacion().x - getLocalizacion().x) > ((SeguirADistancia*1.6)/Densidad)) ||
	      (fabs(BichoEnemigo->getLocalizacion().y - getLocalizacion().y) > ((SeguirADistancia*1.6)/Densidad)))
	    
	    {
	      float MiRadio;
	      if (((UnidadArmy*)MyArmy)->tipomovimiento == "VOLAR")
		{
		  MiRadio = 0;
		}
	      else
		{
		  MiRadio = getRadio();
		}
	      
	      AStar::ME()->getPath(getLocalizacion().x,
				   getLocalizacion().y,
				   BichoEnemigo->getLocalizacion().x,
				   BichoEnemigo->getLocalizacion().y,
				   Camino,
				   MiRadio);
	    }
	  
	  DebugueadorXP = 11004;

	  if (BichoEnemigo->getEstado() == EstadoMuertoDestruido) 
	    {
	      setModo(ModoNormal, 0.0, 0.0, 0, getLocalizacion().x, getLocalizacion().y);
	    } 
	}
    }

  if (Camino->TodoCalculado == false )
    {
      if ((fabs(getDestino().x - getLocalizacion().x) > (1.0/Densidad)) ||
	  (fabs(getDestino().y - getLocalizacion().y) > (1.0/Densidad)))
	{
	  float MiRadio;
	  if (((UnidadArmy*)MyArmy)->tipomovimiento == "VOLAR")
	    {
	      MiRadio = 0;
	    }
	  else
	    {
	      MiRadio = getRadio();
	    }
	  
	  AStar::ME()->getPath(getLocalizacion().x, 
			       getLocalizacion().y,
			       getDestino().x,
			       getDestino().y,
			       Camino,
			       MiRadio);
	}
    }

}

// ---------------------------------------------
void oSoldado::Dispersar(float x, float y)
{

  oObjetos::Modo = ModoCaminoFijo;
  setDestino(x, y, getLocalizacion().x, getLocalizacion().y);
  setEstado(EstadoCorriendo);
  return;

}


// ---------------------------------------------
void oSoldado::setDestino(float x, float y, float NetX, float NetY)
{

  DebugueadorXP = 13;

  if (x == destino.x  && y == destino.y)
    {
      return;
    }

  // Le indicamos al bicho cual es su destino, ademas hay que hacer otras cosas
  // dependiendo del modo en el cual este. Por ejemplo, en modo agresivo si destino es la preza.
  
  switch (getModo())
    {
    case(ModoNormal):
      {
	//destino.x = x;
	//destino.y = y;
	break;
      }
    case (ModoCaminoFijo):
      {
	destino.x = x;
	destino.y = y;
	break;
      }
    case (ModoGuardaEspaldas):
      {
	destino.x = x;
	destino.y = y;
	break;
      }
    case(ModoCazador):  case(ModoVengativo):
      {

	if (getPresaOSeguir()->getLocalizacion().x == destino.x  && getPresaOSeguir()->getLocalizacion().y == destino.y)
	  {
	    return;
	  }

	destino.x  = getPresaOSeguir()->getLocalizacion().x;
	destino.y  = getPresaOSeguir()->getLocalizacion().y;
	break;
      }
    case (ModoAgresivo):
      {
	destino.x = x;
	destino.y = y;
	break;
      }
    case (ModoGuardia):
      {
	destino.x = x;
	destino.y = y;
	break;
      }
    case (ModoDestruyeEdificio):
      {
	destino.x = x;
	destino.y = y;
	break;
      }
    default:
      {
	destino.x = x;
	destino.y = y;
	// El modo que se invoco no estaba contemplado en este switch.
	cout << "Modo ERROR: " << getModo() << endl;
      }
    }


  // Informamos a los otros jugadores que el bicho tiene un nuevo destino.
  
  
  float MiRadio;
  if (((UnidadArmy*)MyArmy)->tipomovimiento == "VOLAR")
    {
      MiRadio = 0;
    }
  else
    {
      MiRadio = getRadio();
    }
  
  AStar::ME()->getPath(NetX, //getLocalizacion().x,
		       NetY, //getLocalizacion().y,
		       destino.x,
		       destino.y,
		       Camino,
		       MiRadio);
}


//----------------------------
//----------------------------
//----------------------------


