//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#ifndef __oSoldado_h__

#define __oSoldado_h__

#define EstadoIndefinido -1
#define EstadoAtencion 0
#define EstadoCorriendo 1
#define EstadoPreparandoDisparo 2
#define EstadoEsperandoADisparar 3
#define EstadoTerminadoDisparo  4
#define EstadoHerido 5

#define ModoNormal 0
#define ModoCaminoFijo 1
#define ModoCazador 2
#define ModoAgresivo 3
#define ModoGuardaEspaldas 4
#define ModoGuardia 5
#define ModoVengativo 6
#define ModoQuieto 7
#define ModoDestruyeEdificio 8

#define SeguirADistancia 0.9

#include <iostream>
#include <string>
#include <fstream>

using namespace std;

#include "constantes.h"

#include "oObjetos.h"


#include "army.h"
#include "animaSoldado.h"
#include "oEdificio.h"
#include "astar_v1.h"

// -----------------------------------------
class oSoldado : public oObjetos
{

 private:
  // BORRAME -- Variable para Debuguear --
  int DebugueadorXP;

  // -- Altura de las unidades voladores --
 private:
  float AlturaDeVuelo;

  // -- Variables de suavizado --
 private:
  float AnguloDib;
  z3DVector NormalDib;
  float AlturaDeVueloDib;

  // -- Punto para hacer guardia --
 private:
  z2DVector destinoGuardia[2];
  bool guardiaMeta;

  // --------------------------
  // Constructores y destructor
  // --------------------------
 public:
  oSoldado(float x, float y, 
	   int ID, int internetID, bool Mio);
  ~oSoldado();


  // --------------------------
  // Render
  // --------------------------
 public:
  void dibujame(float Altura, z3DVector N, bool Seleccion); 
  virtual void onDibujame() {};   
  float getAngulo();

  // --------------------------
  // Army
  // --------------------------
 public:
  void onSetArmy();


  // --------------------------
  // Tiempo y retardos
  // --------------------------
 private:
  void onRetardo();
 protected:
  virtual void onClock_1_00Sec();


  // --------------------------
  // Modo y estado
  // --------------------------
 public:
  void setModo (int Modo, float x, float y, int Extra, float NetX, float NetY);
  void setEstado(int Estado);


  // --------------------------
  // Animaciones
  // --------------------------
 public:
  void playAnimacion ();


  // --------------------------
  // Disparos
  // --------------------------
 private:
  void onSetDanio(int Danio);


  // --------------------------
  // Sonidos
  // --------------------------
 public:
  void PlaySeleccionado();
  void PlayMuerto();
  void PlayTerminado();


  //////////////
  /// EXTRAS ///
  //////////////

  // --------------------------
  // Army
  // --------------------------
 public:
  inline Textura getMinifoto() {return ((UnidadArmy*)MyArmy)->MiniFoto;};
  inline string getTipomovimiento() {return ((UnidadArmy*)MyArmy)->tipomovimiento;};
  

  // --------------------------
  // Sonidos
  // --------------------------
 public:
  void PlayOk();

  // --------------------------
  // Disparos
  // --------------------------
 private:
  void onIntentaDisparo(bool Alcanzado);


  // --------------------------
  // Experiencia
  // --------------------------
 private:
  int Experiencia;
 public:
  inline int getExperiencia(){return Experiencia;};


  // --------------------------
  // Caminar
  // --------------------------
 public:

  IACamino *Camino;
  z2DVector destino;
  z2DVector semiDestino;
  inline int getPaso() {return Camino->p;};
  void IntentaMovimiento(int angulo);
  void ContinuarCamino();
  void Dispersar(float x, float y);
 private:
  void setDestino(float x, float y, float NetX, float NetY);
  inline z2DVector getDestino() {return destino;};




  // ----------------------------
  // DISPAROS
  // ----------------------------

  z3DVector proyFIN;
  z3DVector proyPOS;

  /*
  void proyectilInicia ();
  void proyectilGO (float inix, float iniy, float finx, float finy);
  void proyectilDibuja ();
  */

};


#endif
