//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "oSoldado.h"

#include "ejercito.h"
#include "tierra.h"


// --------------------------
// Constructores y destructor
// --------------------------

// ---------------------------------------------
// Iniciamos
oSoldadoConstructor::oSoldadoConstructor (float x, float y, int ID, int internetID, bool Mio)
  :oSoldado (x, y, ID, internetID, Mio)
{
  EdificioEnEspera = 0;
  EdificioEnConstruccion = (oEdificio*)NULL;
}
   

//  ---------------------------------------------
oSoldadoConstructor::~oSoldadoConstructor()
{

}

// --------------------------
// Render
// --------------------------

// ---------------------------------------------
void oSoldadoConstructor::onDibujame() 
{
  if (EdificioEnEspera != 0)
    {
   	          
      for (int X = 0 ; X < Ejercito::TodosLosEjercitos.begin()->getArmy()->getNumConstrucciones(); X++)
	      {
		if (Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].ID == EdificioEnEspera)  
		  {
		    glColor4f(0.0, 0.0, 0.0, 0.2);
		    Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].Modelo->dibujame(localizacionNuevoEdificio.x, 
												      localizacionNuevoEdificio.y,
												      localizacionNuevoEdificio.z,
												      1, 0, 0);
		  }
	      }
	  }
}
   

// --------------------------
// Tiempo y retardos
// --------------------------

// ---------------------------------------------
void oSoldadoConstructor::onClock_1_00Sec()
{

  oSoldado::onClock_1_00Sec();

  if (EdificioEnEspera != 0)
    {
      if (fabs(getLocalizacion().x - localizacionNuevoEdificio.x) < 0.2)
	if (fabs(getLocalizacion().y - localizacionNuevoEdificio.z) < 0.2)
	  {
	    EdificioEnConstruccion = Ejercito::TodosLosEjercitos.begin()->addEdificio (EdificioEnEspera, 
							      localizacionNuevoEdificio.x, 
							      localizacionNuevoEdificio.z, 0);

	    int costo = 0;

	    for (int X = 0 ; X < Ejercito::TodosLosEjercitos.begin()->getArmy()->getNumConstrucciones(); X++)
		{
		  if (Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].ID == EdificioEnEspera)  
		    {
		      costo = Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[X].costo;
		      cout << "Costo: " << costo << endl;

		      vector<Ejercito>::iterator Ejers = Ejercito::TodosLosEjercitos.begin();
		      Ejers->getRecursos()->gastaRecursos(costo, 0);

		      break;    
		    }	
		}
	    EdificioEnEspera = 0;
	  }
    }
}


// --------------------------
// NuevoEdificio
// --------------------------

// ---------------------------------------------
void oSoldadoConstructor::nuevoEdificio (int Tipo, float x, float y)
{
  cout << " *** NuevoEdificio *** " << Tipo << endl;

  EdificioEnEspera = Tipo;
  localizacionNuevoEdificio.x = x;
  localizacionNuevoEdificio.y = Tierra::ME()->getAltura(x, y);
  localizacionNuevoEdificio.z = y;
  
  setModo(ModoCaminoFijo, x, y, 0, getLocalizacion().x, getLocalizacion().y);  
}
