//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "pPantallas.h"

// ----------------------------
Barra pPantallas::BarraDeCarga;
pPantallas * pPantallas::PantallaActiva = NULL;
vector<pPantallas*> pPantallas::Pantallas;

// ----------------------------
void pPantallas::Resize(int x, int y)
{
  glViewport(0, 0, x, y); 
}

// ----------------------------
void pPantallas::Dibujafondo()
{
  miVistaGL.setVista(VistaGL_Ortogonal);

  texCargando.usaGLTextura(TextAltaCalidad);
  glColor3f(1.0,1.0,1.0);
  
  glBegin (GL_QUADS);
  {   
    glTexCoord2f(0,1);
    glVertex2f(0.0, 0.0);
    glTexCoord2f(1,1);
    glVertex2f(1.0, 0.0);
    glTexCoord2f(1,0);
    glVertex2f(1.0, 1.0);
    glTexCoord2f(0,0);
    glVertex2f(0.0, 1.0);						
  }
  glEnd();
}

// ----------------------------
void pPantallas::DibujaBarra()
{
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);

  glColor4f(0.4, 0.4, 1.0, 0.7);
  
  glBegin (GL_QUADS);
  { 
    glTexCoord2f(0,1);
    glVertex2f(146.0/512, 116.0/512);
    glTexCoord2f(1,1);
    glVertex2f(146.0/512 + (200.0/512)*(BarraDeCarga.Avance/100.0), 116.0/512);
    glTexCoord2f(1,0);
    glVertex2f(146.0/512 + (200.0/512)*(BarraDeCarga.Avance/100.0), 138.0/512);
    glTexCoord2f(0,0);
    glVertex2f(146.0/512, 138.0/512);  
  }
  glEnd();
  
  glColor4f(1.0, 1.0, 1.0, 1.0);
  
  TextServer.Escribe(BarraDeCarga.Avance, 0.47, 116.0/512 + 0.01 , 6, 1);
  TextServer.Escribe(BarraDeCarga.Cadena, 0.30, 116.0/512 + 0.1 , 7, 1, 0 ,0 ,0 ,1);
}


// ----------------------------
void pPantallas::DibujameBotones()
{
  miVistaGL.setVista(VistaGL_Ortogonal);

  glPushMatrix();

  vector<Boton>::iterator Bot;
  for (Bot = Botones.begin(); Bot != Botones.end(); Bot++)
    {
      if (Bot->Activo)
	{
	  Bot->Dibujame(0.9);
	}
    }
  glPopMatrix();
}

// -----------------------------------------
int pPantallas::Mouse_dragNdrop (float x, float y, float x2, float y2, int boton)
{
  return 0;
}

// -----------------------------------------
int pPantallas::Mouse_dobleClic (float x, float y, int boton)
{
  return 0;
}

// -----------------------------------------
int pPantallas::Mouse_clic (float x, float y, int boton)
{
 
  vector<Boton>::iterator Bot;
  
  if (boton == 0)
    {
      for (Bot = Botones.begin(); Bot != Botones.end(); Bot++)
	{
	  if (y > Bot->PosicionDelBoton.y && y < Bot->PosicionDelBoton.y+Bot->AnchoYAltoBoton.y)
	    {
	      if (x > Bot->PosicionDelBoton.x && x < Bot->PosicionDelBoton.x+Bot->AnchoYAltoBoton.x)
		{
		  if (Bot->Activo)
		    {
		      Bot->Pres = 1.0;
		      return Bot->ID;
		    }
		}
	    }
	}
    }
  return 0;  
}


// -----------------------------------------
int pPantallas::Mouse_move (float x, float y)
{

  pMouse.x = x;
  pMouse.y = y;

  vector<Boton>::iterator Bot;
  for (Bot = Botones.begin(); Bot != Botones.end(); Bot++)
    {
      
      Bot->DebajoDelMouse = false;
      
      if (y > Bot->PosicionDelBoton.y && y < Bot->PosicionDelBoton.y+Bot->AnchoYAltoBoton.y)
	{
	  if (x > Bot->PosicionDelBoton.x && x < Bot->PosicionDelBoton.x+Bot->AnchoYAltoBoton.x)
	    {
	      if (Bot->Activo)
		{
		  Bot->DebajoDelMouse = true;
		}
	    }
	}
    }
  return 0;
}


// -----------------------------------------
int pPantallas::Mouse_down (float x, float y, int boton)
{
  
  if (boton == 0)
    {
      vector<Boton>::iterator Bot;
      for (Bot = Botones.begin(); Bot != Botones.end(); Bot++)
	{
	  if (y > Bot->PosicionDelBoton.y && y < Bot->PosicionDelBoton.y+Bot->AnchoYAltoBoton.y)
	    {
	      if (x > Bot->PosicionDelBoton.x && x < Bot->PosicionDelBoton.x+Bot->AnchoYAltoBoton.x)
		{
		  if (Bot->Activo)
		    {
		      return Bot->ID;
		    }
		}
	    }
	}
      
    }
  return 0; 
}
 

// -----------------------------------------
int pPantallas::Mouse_up (float x, float y, int boton)
{
  return 0; 
}


// -----------------------------------------
void pPantallas::AddBoton (string Textura, int ID, float Left, float Top, float Width, float Heigh)
{
  Boton NuevoBoton(Textura, Left, Top, Width, Heigh, ID);
  Botones.push_back(NuevoBoton);
}



