//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#ifndef __pantallaInicio_h__
#define __pantallaInicio_h__

#include "singleton.h"

#include "comunicaciones.h"

#include "Solar3DWidGets/Solar3DWidGetPanel.h"

#include "Solar3DWidGets/Solar3DWidGetTextBox.h"
#include "Solar3DWidGets/Solar3DWidGetText.h"
#include "Solar3DWidGets/Solar3DWidGetBoton.h"

#define pantallaNuevaPartidaRollServer 100
#define pantallaNuevaPartidaRollCliente 101

class pantallaInicio;

class pantallaInicio: public singleton<pantallaInicio>, public Solar3DWidGetPanel, public comunicaciones
{
 public:
  pantallaInicio();

  void AddText(string text);
  void Reset();
  void RefreshNicks();


 private:
  int Roll;

 public:
  int timebase;

 public:
  void setRoll(int Roll);


 private:
  Solar3DWidGetTextBox * TextoChat;
  Solar3DWidGetText    * TextoDeSalidaChat;
  Solar3DWidGetTextBox * NickChat;


 private:
  Solar3DWidGetBoton *BotonIniciar;

 private:

  static void onTextoDeSalidaChat_keyPress(const char key, Solar3DWidGetBase* This);
  static void BotonIniciarPartida(unsigned int boton, float x, float y, Solar3DWidGetBase* This);
  static void BotonCancelarPartida(unsigned int boton, float x, float y, Solar3DWidGetBase* This);


 private:

  string nombreDePartida;
  string mapaDePartida;

 private:

  void enviarDatosDePartida();

 public:

  void pantallaInicio::datosDePartida(string nombre, string mapa);

 private: 

  static void pantallaInicio::Render(Solar3DWidGetBase* This);

 private:

  // Eventos de RED.

  void onPOSINI(int InternetID, float x, float y);
  void onCHAT(int InternetID, string strMensaje);
  void onADMIN( ); 
  void onENTRA(int InternetID);
  void onLISTANICKS(int InternetID, string strNick, string strArmy);
  void onSETARMY(int InternetID, string strArmy); 
  void onNICK(int InternetID, string strNick);
  void onCLIMA(string Condicion, int Duracion); 
  void onINICIA( );                   
  void onAGREGAEDIFICIO(int InternetID, int tipo, float x, float y, int ID);
  void onAGREGASOLDADO(int InternetID, int tipo, float x, float y, int ID);
  void onRECURSOS(float x, float y);
  void onMOD(int MiInternetID, int Modo, int MiBichoID, 
		    float x, float y, float xRedundante, float yRedundante,
		    int EnemigoID, int EnemigoInternetID);               
  void onSALIDA(int InternetID);  
};


#endif
