//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "pantallaMultiplayerIRC.h"

#include "Solar3DWidGets/Solar3DWidGetPanel.h"

#include "pantallaInicio.h"

#include "eventos.h"



// ----------------------------------------
interfaceDePartidas::interfaceDePartidas (pantallaMultiplayerIRC* padre, float desplazamiento)
{
  cmd_BotonDeSeleccion = new Solar3DWidGetBoton("BotonPartida_01", 0.34, 0.74 + desplazamiento, 0.64, 0.016, "");
  //NuevoBoton->setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/BotonServerP2P.tga");
  padre->agregarHijo(cmd_BotonDeSeleccion);
  cmd_BotonDeSeleccion->onMouseDobleClic = padre->PartidaMouseDobleClic;
 
  lbl_NombreDeLaPartida = new Solar3DWidGetLabel ("lblPartida_01", 0.35, 0.74 + desplazamiento, 0.1, 0.1, "Nombre de partida");
  lbl_NombreDeLaPartida->FontColor.setColor(0.7, 0.7 ,1.0, 1.0);
  lbl_NombreDeLaPartida->SetFontSize(4);
  padre->agregarHijo(lbl_NombreDeLaPartida);
      
  lbl_Mapa = new Solar3DWidGetLabel ("lblMapa_01", 0.55, 0.74 + desplazamiento, 0.1, 0.1, "Tipo de mapa:");
  lbl_Mapa->FontColor.setColor(0.7, 0.7 ,1.0, 1.0);
  lbl_Mapa->SetFontSize(4);
  padre->agregarHijo(lbl_Mapa);
      
  lbl_SlotsLibres = new Solar3DWidGetLabel ("lblSlots_01", 0.80, 0.74 + desplazamiento, 0.1, 0.1, "8");
  lbl_SlotsLibres->FontColor.setColor(0.7, 0.7 ,1.0, 1.0);
  lbl_SlotsLibres->SetFontSize(4);
  padre->agregarHijo(lbl_SlotsLibres);
      
  lbl_Nick = new Solar3DWidGetLabel ("lblCreador_01", 0.87, 0.74 + desplazamiento, 0.1, 0.1, "Nick");
  lbl_Nick->FontColor.setColor(0.7, 0.7 ,1.0, 1.0);
  lbl_Nick->SetFontSize(4);
  padre->agregarHijo(lbl_Nick);
}


// ---------------------------------------
void interfaceDePartidas::setBackCall(IRCParida* PartidaAsociada)
{
  cmd_BotonDeSeleccion->Etiqueta = (void*) PartidaAsociada;
}


// ---------------------------------------
void interfaceDePartidas::setValores(string Nick, string Nombre, int Slots, string Mapa)
{
  lbl_NombreDeLaPartida->Caption = Nombre;
  lbl_Mapa->Caption = Mapa;
  lbl_SlotsLibres->Caption = zitoa(Slots);
  lbl_Nick->Caption = Nick;
}


// ----------------------------------------
void interfaceDePartidas::setVisible(bool Value)
{
   cmd_BotonDeSeleccion->Visible = Value;
   lbl_NombreDeLaPartida->Visible = Value;
   lbl_Mapa->Visible = Value;
   lbl_SlotsLibres->Visible = Value;
   lbl_Nick->Visible = Value;
}


// ---------------------------------------
pantallaMultiplayerIRC::pantallaMultiplayerIRC()
{
  // Singleton     ZG: ODIO Windows y VC++
  //zMacro_SingletonHack;

  Conectado = false;

  Nombre = "pantallaMultiplayerIRC";
  setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/MenuPrincipalFondo.png");
  izq = 0.0;
  alto = 0.0;
  ancho = 1.0;
  alto = 1.0;


  // ZG. ---------------
  Solar3DWidGetPanel * NuevoPanel;
  Solar3DWidGetLabel * NuevoLabel;



  TextoChat = new Solar3DWidGetTextBox ("Charla", 0.01, 0.01, 0.69, 0.65);
  TextoChat->SetFontSize(5);

  agregarHijo(TextoChat);
  
  // ZG. ---------------
  NickChat = new Solar3DWidGetTextBox ("Nicks", 0.71, 0.01*0.75, 0.28, 0.69);
  NickChat->SetFontSize(5);

  agregarHijo(NickChat);


  // ZG Creamos un nuevo boton
  NuevoBotonNueva = new Solar3DWidGetBoton("Nueva partida", 0.01, 0.82, 0.3, 0.07, "Crear partida");
  NuevoBotonNueva->onMouseClic = BotonNuevaPartida;
  NuevoBotonNueva->Enable = Conectado;
  agregarHijo(NuevoBotonNueva);

  // ZG Creamos un nuevo boton
  NuevoBotonSalir = new Solar3DWidGetBoton("Salir", 0.01, 0.92, 0.3, 0.07, "Salir");
  NuevoBotonSalir->onMouseClic = BotonSalir;
  agregarHijo(NuevoBotonSalir);

  NuevoPanel = new Solar3DWidGetPanel("Panel01", 0.33, 0.72, 0.66, 0.27);
  agregarHijo(NuevoPanel);

  NuevoLabel = new Solar3DWidGetLabel ("LabelTest", 0.35, 0.73, 0.1, 0.1, "Partida:");
  NuevoLabel->FontColor.setColor(1.0, 1.0 ,1.0, 1.0);
  NuevoLabel->SetFontSize(5);
  agregarHijo(NuevoLabel);

  NuevoLabel = new Solar3DWidGetLabel ("LabelTest", 0.55, 0.73, 0.1, 0.1, "Mapa:");
  NuevoLabel->FontColor.setColor(1.0, 1.0 ,1.0, 1.0);
  NuevoLabel->SetFontSize(5);
  agregarHijo(NuevoLabel);

  NuevoLabel = new Solar3DWidGetLabel ("LabelTest", 0.80, 0.73, 0.1, 0.1, "Slots");
  NuevoLabel->FontColor.setColor(1.0, 1.0 ,1.0, 1.0);
  NuevoLabel->SetFontSize(5);
  agregarHijo(NuevoLabel);

  NuevoLabel = new Solar3DWidGetLabel ("LabelTest", 0.87, 0.73, 0.1, 0.1, "Creador:");
  NuevoLabel->FontColor.setColor(1.0, 1.0 ,1.0, 1.0);
  NuevoLabel->SetFontSize(5);
  agregarHijo(NuevoLabel);


  float desplazamiento = 0.00;

  
  for (int i = 0 ; i<10 ; i++)
    {
      desplazamiento = desplazamiento + 0.023;
      interfacePartidas.push_back(new interfaceDePartidas(this, desplazamiento));
    }
  
  TextoDeSalidaChat = new Solar3DWidGetText("Texto_01", 0.01, 0.67, 0.69, 0.04);
  TextoDeSalidaChat->SetFontSize(7);
  TextoDeSalidaChat->FontColor.setColor(0.0, 0.0 ,0.5, 1.0);
  TextoDeSalidaChat->onKeyPress = onTextoDeSalidaChat_keyPress;

  agregarHijo(TextoDeSalidaChat);

  // Intenta conectarte.


  ActualizaPartidas();

  // Evento render para controlar el tiempo.
  onRender = Render;

}

// ------------------------------
void pantallaMultiplayerIRC::ActualizaPartidas()
{

  vector<interfaceDePartidas*>::iterator IteInterfaceDePartidas;
  for (IteInterfaceDePartidas = interfacePartidas.begin(); 
       IteInterfaceDePartidas != interfacePartidas.end(); 
       IteInterfaceDePartidas++)
    { // Limpiamos
      (*IteInterfaceDePartidas)->setVisible(false);
    }
  
  vector<IRCParida>::iterator ItePartidas;
  for (ItePartidas = Partidas.begin(), IteInterfaceDePartidas = interfacePartidas.begin();
       ItePartidas != Partidas.end() and IteInterfaceDePartidas != interfacePartidas.end();
       ItePartidas++, IteInterfaceDePartidas++)
    {
      (*IteInterfaceDePartidas)->setVisible(true);
      (*IteInterfaceDePartidas)->setBackCall(ItePartidas.base());
      (*IteInterfaceDePartidas)->setValores(ItePartidas->getNick(), ItePartidas->getNombre(), ItePartidas->getSlots(), ItePartidas->getMapa());
    }
}


// ------------------------------
void pantallaMultiplayerIRC::AddText(string text)
{
  TextoChat->SetTexto(TextoChat->GetTexto() + text + "\n ");
}


// ------------------------------
void pantallaMultiplayerIRC::onNUEVAPARTIDA(string Nick, string Nombre, string IP, string IP2, int Slots, string Mapa)
{

   IRCParida NuevaPartida(Nick, Nombre, IP, Slots, Mapa);

   IRCParida *PartidaExistente = NULL;

   for (vector<IRCParida>::iterator Ite = Partidas.begin(); Ite != Partidas.end(); Ite++)
     {
       if ((*Ite) == NuevaPartida)
	 {
	   PartidaExistente = Ite.base();
	 }
     }

   if (PartidaExistente != NULL)
     {
       PartidaExistente->Renueva();
     }
   else
     {
       AddText(Nick + " a creado una nueva partida: " + Nombre);
       Partidas.push_back(NuevaPartida);
     }
   
   ActualizaPartidas();

}

// ------------------------------
void pantallaMultiplayerIRC::onPING(string Numero)
{
  cout << "[[PING]] " << "Numero: " << Numero << endl;
  
  sendPONG(Numero);
}


// ------------------------------
void pantallaMultiplayerIRC::on001(string MensajeDeBienvenida)
{
  cout << "[[001]] " << "Bienvenida: " << MensajeDeBienvenida << endl;
}


// ------------------------------
void pantallaMultiplayerIRC::onCONEXION(string Nick)
{
  cout << "[[CONEXION]] " << "Conexion." << endl;
  AddText("{Conectado]");
  MiNick = Nick;
  sendJOIN(CanalWar3D);
  Conectado = true;
  NuevoBotonNueva->Enable = Conectado;
}


// ------------------------------
void pantallaMultiplayerIRC::onMSG_PRIVADO(string Nick, string Mensaje)
{
  cout << "[[MENSAJE]] " << Nick << " te dice: " << Mensaje << endl;
}


// ------------------------------
void pantallaMultiplayerIRC::onMSG_CANAL(string Nick, string Canal, string Mensaje)
{

  //cout << "[[MENSAJE]] " << Nick << " dice al canal " << Canal << ": " << Mensaje << endl;

  AddText(Nick + ": " + Mensaje);
}

// ------------------------------
void pantallaMultiplayerIRC::onJOIN_YO (string Canal)
{
  cout << "[[JOIN_YO]] " << "He entrado al canal: " << Canal << endl;
  sendGETIP();

  timebase = glutGet(GLUT_ELAPSED_TIME);
}


// ------------------------------
void pantallaMultiplayerIRC::onJOIN_OTRO (string Nick, string Canal)
{
  cout << "[[JOIN_OTRO]] " << Nick << " entra al canal: " << Canal << endl;
  AddText(string("*") + Nick + " entro a la sala.");
  ActualizaNicks();
}


// ------------------------------
void pantallaMultiplayerIRC::onLISTA_DE_NICKS (vector<string> Nicks, string Canal)
{
  ActualizaNicks();
}

// ------------------------------
void pantallaMultiplayerIRC::onPART(string Nick, string Canal)
{
  cout << "[[PART]] " << Nick << " sale del canal: " << Canal << endl;
  AddText(string("*") + Nick + " salio de la sala.");
  ActualizaNicks();
}



// ------------------------------
void pantallaMultiplayerIRC::onQUIT(string Nick)
{
  cout << "[[QUIT]] " << Nick << " sale del servidor." << endl;
  AddText(string("*") + Nick + " se desconecto.");
  ActualizaNicks();
}

// ------------------------------
void pantallaMultiplayerIRC::onNOCONEXION()
{
   AddText("Conexion rechazada.");
   AddText(string("Intentando de nuevo con ") + IRCServer + "..."); 
   Conectado = false;
   NuevoBotonNueva->Enable = Conectado;
   zSleep(20000);
   Conectar(IRCServer);
}


// ------------------------------
void pantallaMultiplayerIRC::onNick(string VNick, string NNick)
{
  AddText(VNick + " cambia de nick a: " + NNick);
  ActualizaNicks();
}



// ---------------------------------
void pantallaMultiplayerIRC::onERROR(string Mensaje)
{
  AddText(string("ERROR: " + Mensaje)); 
}



// ------------------------------
void pantallaMultiplayerIRC::ActualizaNicks()
{
  string Texto;
  vector<IRCCanal>::iterator TmpCanal = getCanal("war3d"/*"war3dparTIdas"*/);

  if (TmpCanal != (vector<IRCCanal>::iterator)NULL)
    {
      for (vector<IRCNickEnCanal>::iterator Ite = TmpCanal->getNicks()->begin();
	   Ite != TmpCanal->getNicks()->end();
	   Ite++)
	{
	  Texto = Texto + Ite->getNick() + "\n ";
	}
      NickChat->SetTexto(Texto);
    }
}

// ------------------------------
void pantallaMultiplayerIRC::onTextoDeSalidaChat_keyPress(const char key, Solar3DWidGetBase* This)
{
  string Texto;
  pantallaMultiplayerIRC *Padre = (pantallaMultiplayerIRC*)(This->getPadre());

  if (key == 13)
    {
      cout << "||ENTER||" << endl;

      Padre->AddText(string("Yo") + ": " + ((Solar3DWidGetText*)This)->GetTexto());

      Padre->sendMENSAJE(CanalWar3D, ((Solar3DWidGetText*)This)->GetTexto());

      ((Solar3DWidGetText*)This)->Clean();
    }
}


// ---------------------------------------
void pantallaMultiplayerIRC::BotonNuevaPartida(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  Eventos::ME()->SetRenderModo(pModoNuevaPartida);
}


// ---------------------------------------
void pantallaMultiplayerIRC::BotonSalir(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  pantallaMultiplayerIRC *Padre = (pantallaMultiplayerIRC*)(This->getPadre());
  Padre->sendQUIT();
  Eventos::ME()->SetRenderModo(pModoMenu);
}


// ---------------------------------------
void pantallaMultiplayerIRC::PartidaMouseDobleClic(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  cout << "Iniciando partida multiplayer ..." << ((IRCParida*)(This->Etiqueta))->getNombre() << endl;

  Eventos::ME()->SetRenderModo(pModoPartida);
      
  cout << "Conectando ... con: " << ((IRCParida*)(This->Etiqueta))->getIP() << endl;
  pantallaInicio::ME()->Conectar(((IRCParida*)(This->Etiqueta))->getIP());

  //Eventos::ME()->SetRenderModo(pModoPartida);

  pantallaInicio::ME()->setRoll(pantallaNuevaPartidaRollCliente);

}


// ---------------------------------------
void pantallaMultiplayerIRC::Clean()
{
  TextoChat->SetTexto("Conectando ...");
  NickChat->SetTexto("");
}


// ---------------------------------------
void pantallaMultiplayerIRC::Render(Solar3DWidGetBase* This)
{


   int Tiempo = glutGet(GLUT_ELAPSED_TIME) - pantallaMultiplayerIRC::ME()->timebase;

   if (Tiempo > 1000)
     {

       pantallaMultiplayerIRC::ME()->timebase = glutGet(GLUT_ELAPSED_TIME);

       for (vector<IRCParida>::iterator Ite = pantallaMultiplayerIRC::ME()->Partidas.begin(); 
	    Ite != pantallaMultiplayerIRC::ME()->Partidas.end(); 
	    Ite++)
	 {
	   
	   Ite->DecrementaTiempo(Tiempo);
	   
	   if (Ite->getActiva())
	     {
	       pantallaMultiplayerIRC::ME()->Partidas.erase(Ite);
	       return;
	     }
	 }
     }
}
