//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#ifndef __pantallaMultiplayerIRC_h__
#define __pantallaMultiplayerIRC_h__

#include "singleton.h"

#include "Solar3DWidGets/Solar3DWidGetPanel.h"

#include "Solar3DWidGets/Solar3DWidGetTextBox.h"
#include "Solar3DWidGets/Solar3DWidGetBoton.h"
#include "Solar3DWidGets/Solar3DWidGetText.h"
#include "Solar3DWidGets/Solar3DWidGetLabel.h"

#include "IRCcomunicaciones.h"


class pantallaMultiplayerIRC;

class interfaceDePartidas
{
 public:
  interfaceDePartidas (pantallaMultiplayerIRC* padre, float desplazamiento);
  void setVisible(bool Value);
  void setValores(string Nick, string Nombre, int Slots, string Mapa);
  void setBackCall(IRCParida* PartidaAsociada);
 public:
  Solar3DWidGetBoton * cmd_BotonDeSeleccion;
  Solar3DWidGetLabel * lbl_NombreDeLaPartida;
  Solar3DWidGetLabel * lbl_Mapa;
  Solar3DWidGetLabel * lbl_SlotsLibres;
  Solar3DWidGetLabel * lbl_Nick;
};


class pantallaMultiplayerIRC: public singleton<pantallaMultiplayerIRC>, public Solar3DWidGetPanel, public IRCcomunicaciones
{

 public:

  pantallaMultiplayerIRC();

 
 private:
  Solar3DWidGetTextBox * TextoChat;
  Solar3DWidGetTextBox * NickChat;
  Solar3DWidGetText    * TextoDeSalidaChat;

  Solar3DWidGetBoton * NuevoBotonNueva;
  Solar3DWidGetBoton * NuevoBotonSalir;


  vector <interfaceDePartidas*> interfacePartidas;

  bool Conectado;

 private:

  int timebase;

 private:
  // Eventos de RED.
  void onPING (string Numero);
  void on001 (string MensajeDeBienvenida);
  void onCONEXION (string Nick);
  void onMSG_PRIVADO (string Nick, string Mensaje);
  void onMSG_CANAL (string Nick, string Canal, string Mensaje);
  void onJOIN_YO (string Canal);
  void onJOIN_OTRO (string Nick, string Canal);
  void onLISTA_DE_NICKS (vector<string> Nicks, string Canal);
  void onPART(string Nick, string Canal);
  void onQUIT(string Nick);
  void onNOCONEXION();
  void onNUEVAPARTIDA(string Nick, string Nombre, string IP, string IP2, int Slots, string Mapa);  
  void onNick(string VNick, string NNick);
  void onERROR(string Mensaje);



  void ActualizaNicks();


  static void onTextoDeSalidaChat_keyPress(const char key, Solar3DWidGetBase* This);
  static void BotonNuevaPartida(unsigned int boton, float x, float y, Solar3DWidGetBase* This);
  static void BotonSalir(unsigned int boton, float x, float y, Solar3DWidGetBase* This);
  static void PartidaMouseDobleClic(unsigned int boton, float x, float y, Solar3DWidGetBase* This);

 public: 

  void ActualizaPartidas();
  void AddText(string text);
  void Clean();

 private:
 
  static void Render(Solar3DWidGetBase* This);

};

#endif
