//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "pantallaNuevaPartida.h"



#include "Solar3DWidGets/Solar3DWidGetBoton.h"
#include "Solar3DWidGets/Solar3DWidGetText.h"
#include "Solar3DWidGets/Solar3DWidGetLabel.h"

#include "pantallaMultiplayerIRC.h"

#include "pantallaInicio.h"

#include "ServerDedicado/W3DServer.h"


#include "eventos.h"

pantallaNuevaPartida::pantallaNuevaPartida()
{
  // Singleton     ZG: ODIO Windows y VC++
  // zMacro_SingletonHack;
  
  Nombre = "pantallaNuevaPartida";
  setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/MenuPrincipalFondo.png");
  izq = 0.20;
  arriba = 0.20;
  ancho = 0.60;
  alto = 0.60;

  Solar3DWidGetBoton * NuevoBotonA;
  // ZG Creamos un nuevo boton
  NuevoBotonA = new Solar3DWidGetBoton("Aceptar", 0.01, 0.22, 0.25, 0.06, "Aceptar");
  //NuevoBotonA->setTexturaDeFondo("Interface/Pantallas/NuevaPartida/botonAceptar.png");
  NuevoBotonA->onMouseClic = BotonAceptar;
  agregarHijo(NuevoBotonA);

  Solar3DWidGetBoton * NuevoBotonC;
  // ZG Creamos un nuevo boton
  NuevoBotonC = new Solar3DWidGetBoton("Cancelar", 0.31, 0.22, 0.25, 0.06, "Cancelar");
  //NuevoBotonC->setTexturaDeFondo("Interface/Pantallas/NuevaPartida/botonCancelar.png");
  NuevoBotonC->onMouseClic = BotonCancelar;
  agregarHijo(NuevoBotonC);

  Solar3DWidGetLabel * NuevoLabel;
  NuevoLabel = new Solar3DWidGetLabel ("lbl_01", 0.1, 0.10, 0.1, 0.1, "Nombre de la partida");
  NuevoLabel->FontColor.setColor(0.1, 0.1 ,0.2, 1.0);
  NuevoLabel->SetFontSize(8);
  agregarHijo(NuevoLabel);

  TextoNombreDePartida = new Solar3DWidGetText("Texto_01", 0.01, 0.17, 0.58, 0.04);
  TextoNombreDePartida->SetFontSize(7);
  TextoNombreDePartida->FontColor.setColor(0.0, 0.0 ,0.5, 1.0);
  TextoNombreDePartida->onKeyPress = onTextoNombreDePartida_keyPress;
  agregarHijo(TextoNombreDePartida);
}


// -------------------------------------
void pantallaNuevaPartida::BotonAceptar(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  pantallaNuevaPartida *Padre = (pantallaNuevaPartida*)(This->getPadre());
  Padre->Texto = Padre->TextoNombreDePartida->GetTexto();

  W3DServer::ME()->Inicializa();

  cout << "Starting multiplayer player game..." << endl;
      
  cout << "Conectando ..." << endl;
  pantallaInicio::ME()->Conectar("localhost");


  Eventos::ME()->SetRenderModo(pModoPartida);
  pantallaInicio::ME()->setRoll(pantallaNuevaPartidaRollServer);
  
  pantallaInicio::ME()->datosDePartida(Padre->TextoNombreDePartida->GetTexto(), "mapa");

}

// -------------------------------------
void pantallaNuevaPartida::BotonCancelar(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  pantallaNuevaPartida *Padre = (pantallaNuevaPartida*)(This->getPadre());
  Padre->Texto = "";

  Eventos::ME()->SetRenderModo(Eventos::ME()->getRenderModoAnterior());
}

// -------------------------------------
void pantallaNuevaPartida::onTextoNombreDePartida_keyPress(const char key, Solar3DWidGetBase* This)
{
  
}
