
//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "texturas.h"


// ---------------------------------
Textura::Textura () 
{
  Frame = 0;
  OldTime = glutGet(GLUT_ELAPSED_TIME);
  isInicializada = false;
}


// ---------------------------------
void Textura::Inicializa (string Nombre, GLuint GLTexturaAlta, GLuint GLTexturaBaja)
{
  this->Nombre = Nombre;

  this->GLTexturaAlta.push_back(GLTexturaAlta);
  this->GLTexturaBaja.push_back(GLTexturaBaja);

  isInicializada = true;
}


// ---------------------------------
void Textura::usaGLTextura(int Calidad)
{
  switch(Calidad)
    {
    case TextAltaCalidad:
      {
	if (GLTexturaAlta.size() > 0)
	  {
	    GLuint Time = glutGet(GLUT_ELAPSED_TIME);
	    if (Time > (OldTime + 1000/30))
	      {
		OldTime = Time;
		Frame++;
		if (Frame >= GLTexturaAlta.size()) Frame = 0;
	      }
	    glBindTexture(GL_TEXTURE_2D, GLTexturaAlta[Frame]); 
	  }
	else
	  {
	    //War3DError("TEXTURAS", "Textura no inicializada: "+getNombre()+", usa el Servidor de Tecturas para ello");
	  }
	break;
      }
    case TextBajaCalidad:
      {
	if (GLTexturaBaja.size() > 0)
	  {
	    GLuint Time = glutGet(GLUT_ELAPSED_TIME);
	    if (Time > (OldTime + 1000/30))
	      {
		Frame++;
		if (Frame >= GLTexturaAlta.size()) Frame = 0;
	      }
	    glBindTexture(GL_TEXTURE_2D, GLTexturaBaja[Frame]); 
	  }
	else
	  {
	    //War3DError("TEXTURAS", "Textura no inicializada: "+getNombre()+", usa el Servidor de Tecturas para ello");
	  }
	break;
      }
    default:
      {
	War3DError("TEXTURAS", "Calidad no soportada");
	break;
      }
    }
}

//-------------------------------------
//-------------------------------------
//-------------------------------------

//-------------------------------------
Textura ServidorDeTexturas::Nueva(string Archivo)
{

  vector<Textura>::iterator Tex;
  for (Tex = Texturas.begin() ; Tex != Texturas.end() ; Tex++)
    {
      if (Tex->getNombre() == Archivo)
	{
	  return *Tex;
	}
    }

  string Extension = Archivo.substr(Archivo.length()-3, 3);

  unsigned int i;
  char Ext[10]; 
  for (i = 0; i < Extension.length() ; i++)
    Ext[i] = tolower(Extension.c_str()[i]);
  Ext[i] = '\0';

  Extension = Ext;
  Textura NuevaTextura;

  if (Extension == "tga")
    {
 
      GLuint GLTexturaAlta,GLTexturaBaja;
      GLTexturaAlta = cargarTGA(Archivo);
      GLTexturaBaja = bajaCalidad(GLTexturaAlta,4);
      NuevaTextura.Inicializa(Archivo, GLTexturaAlta, GLTexturaBaja);
      Texturas.push_back(NuevaTextura);
      return NuevaTextura;
    }

  if (Extension == "png")
    {
 
      GLuint GLTexturaAlta,GLTexturaBaja;
      GLTexturaAlta = cargarPNG(Archivo);
      GLTexturaBaja = bajaCalidad(GLTexturaAlta,4);
      NuevaTextura.Inicializa(Archivo, GLTexturaAlta, GLTexturaBaja);
      Texturas.push_back(NuevaTextura);
      return NuevaTextura;
    }

  War3DError("TEXTURAS", string("Extencion desconocida: ") + Archivo);
  return NuevaTextura;
}


// ----------------------------------
Textura ServidorDeTexturas::NuevaMultiTextura(string Archivo, unsigned int Length)
{
  vector<Textura>::iterator Tex;
  for (Tex = Texturas.begin() ; Tex != Texturas.end() ; Tex++)
    {
      if (Tex->getNombre() == Archivo)
	{
	  return *Tex;
	}
    }

  string Extension = Archivo.substr(Archivo.length()-3, 3);

  unsigned int i;
  char Ext[10]; 
  for (i = 0; i < Extension.length() ; i++)
    Ext[i] = tolower(Extension.c_str()[i]);
  Ext[i] = '\0';

  Extension = Ext;
  Archivo = Archivo.substr(0,Archivo.length()-4);

  Textura NuevaTextura;

  char Numero[10];
  
  for (i=1 ; i<=Length ; i++)
    {
      if (i<10)
	{
	  sprintf(Numero, "0%d", i);
	}
      else
	{
	  sprintf(Numero, "%d", i);
	}


      if (Extension == "tga")
	{

	  cout << "Cargando: " << Archivo+Numero+"."+Extension << endl;

	  GLuint GLTexturaAlta,GLTexturaBaja;
	  GLTexturaAlta = cargarTGA(Archivo+Numero+"."+Extension);
	  GLTexturaBaja = bajaCalidad(GLTexturaAlta,4);
	  NuevaTextura.Inicializa(Archivo, GLTexturaAlta, GLTexturaBaja);
	  continue;
	}
      
      if (Extension == "png")
	{

	  GLuint GLTexturaAlta,GLTexturaBaja;
	  GLTexturaAlta = cargarPNG(Archivo+Numero+"."+Extension);
	  GLTexturaBaja = bajaCalidad(GLTexturaAlta,4);
	  NuevaTextura.Inicializa(Archivo, GLTexturaAlta, GLTexturaBaja);
	  continue;
	}
      
      War3DError("TEXTURAS", string("Extencion desconocida: ") + Archivo);
	 
    }

  Texturas.push_back(NuevaTextura);
  return NuevaTextura;
}




// ----------------------------------
void ServidorDeTexturas::AddMultiTextura(Textura &LATextura, string Archivo)
{
  string Extension = Archivo.substr(Archivo.length()-3, 3);
  
  unsigned int i;
  char Ext[10]; 
  for (i = 0; i < Extension.length() ; i++)
    Ext[i] = tolower(Extension.c_str()[i]);
  Ext[i] = '\0';
  
  Extension = Ext;

  if (Extension == "tga")
    {
 
      GLuint GLTexturaAlta,GLTexturaBaja;
      GLTexturaAlta = cargarTGA(Archivo);
      GLTexturaBaja = bajaCalidad(GLTexturaAlta,4);
      LATextura.Inicializa(Archivo, GLTexturaAlta, GLTexturaBaja);
      return;
    }

  if (Extension == "png")
    {
 
      GLuint GLTexturaAlta,GLTexturaBaja;
      GLTexturaAlta = cargarPNG(Archivo);
      GLTexturaBaja = bajaCalidad(GLTexturaAlta,4);
      LATextura.Inicializa(Archivo, GLTexturaAlta, GLTexturaBaja);
      return;
    }

  War3DError("TEXTURAS", string("Extencion desconocida: ") + Archivo);
  return;

}

//-------------------------------------
void ServidorDeTexturas::BorrarTextura(Textura &Tex)
{
  // Borramos una textura
  // !!TODO!!
}

//-------------------------------------
void ServidorDeTexturas::Clean()
{
  // Borramos todas las textura
  // !! TODO !!
}


//-------------------------------------
GLuint ServidorDeTexturas::cargarTGA(string Archivo) 
{

  GLuint    GLTextura = 0;
  GLubyte   compararTGA[12];	
  GLubyte   cabezera[6];						
  GLuint    bytesporpunto;					      
  GLuint    tamanoimagen;	
  GLuint    temp,i;
  GLuint    tipo=GL_RGBA;	
  



  //Abrimos el archivo y leemos parte de la cabezera.
  FILE *archivo=fopen(Archivo.c_str(), "rb");
  if ((archivo == NULL) || 
      (fread(compararTGA,1,sizeof(compararTGA),archivo)!=sizeof(compararTGA)) ||	
      (fread(cabezera,1,sizeof(cabezera),archivo)!=sizeof(cabezera))) 
    {
      War3DError ("TEXTURAS", string("No se encontro el Archivo: ") + Archivo);
	 
      return 0;	
    }
  
  int ancho=256*cabezera[1]+ cabezera[0];
  int alto=256*cabezera[3]+ cabezera[2];

  //Seguimos leyendo
  if ((ancho <= 0) || (alto <= 0) ||	
      (cabezera[4]!=24 && cabezera[4]!=32)) 
    {	
      fclose(archivo);
      War3DError ("TEXTURAS","En el archivo" + Archivo);
      return 0;
    }
  
  int bpp = cabezera[4];	
  bytesporpunto = cabezera[4]/8;
  tamanoimagen = ancho * alto * bytesporpunto;	
  GLubyte *dibujo = new GLubyte [tamanoimagen];

  // Leemos los datos de la imagen
  if(dibujo== NULL ||		
     fread(dibujo, 1, tamanoimagen, archivo) != tamanoimagen ) 
    {	
      if(dibujo != NULL)
	{
	  delete dibujo;
	}
      fclose(archivo);
      War3DError ("TEXTURAS","En el archivo" + Archivo);
      return 0;
    }
  
  // Los TGA se guardan en GRB lo convertimos a RGB
  for(i=0; i < (GLuint)tamanoimagen; i+=bytesporpunto)
    {
      temp=dibujo[i];			           	
      dibujo[i] = dibujo[i + 2];	
      dibujo[i + 2] = temp;   			
    }
  // Cerramos el archivo
  fclose (archivo);	      

  glGenTextures(1, &GLTextura);
  glBindTexture(GL_TEXTURE_2D, GLTextura); 

  // se crea una textura rgb, sino una rgba
  if(bpp ==24) tipo= GL_RGB;	

  //glTexImage2D(GL_TEXTURE_2D, 0, tipo, ancho, alto, 0, tipo, GL_UNSIGNED_BYTE, dibujo);

  gluBuild2DMipmaps(GL_TEXTURE_2D, 4, ancho, alto, tipo, GL_UNSIGNED_BYTE, dibujo);

  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, /*GL_NEAREST*/ GL_LINEAR);		// La m
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, /*GL_NEAREST*/ GL_LINEAR); 

  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);


  delete [] dibujo; 

  War3DAccion ("TEX", Archivo + " cargada."); // "ID: " + stringContadorDeTexturas;

  return GLTextura;	
  // Todo sali bien
}

//-------------------------------------
GLuint ServidorDeTexturas::cargarPNG(string Archivo)
{

  GLuint    GLTextura = 0;
  GLuint    tipo=GL_RGBA;


  png_structp png_ptr;
  png_infop info_ptr;
  unsigned int sig_read = 0;

  int bit_depth;
  FILE *fp;

  if ((fp = fopen(Archivo.c_str(), "rb")) == NULL)
    {
      War3DError ("TEXTURAS", string("No se encontro el Archivo: ") + Archivo);
      return (GLTextura);
    }

  /* Create and initialize the png_struct with the desired error handler
   * functions.  If you want to use the default stderr and longjump method,
   * you can supply NULL for the last three parameters.  We also supply the
   * the compiler header file version, so that we know if the application
   * was compiled with a compatible version of the library.  REQUIRED
   */
  png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING,
				   NULL, NULL, NULL);

  if (png_ptr == NULL)
    {
      fclose(fp);
      return (GLTextura);
    }

  /* Allocate/initialize the memory for image information.  REQUIRED. */
  info_ptr = png_create_info_struct(png_ptr);
  if (info_ptr == NULL)
    {
      fclose(fp);
      png_destroy_read_struct(&png_ptr, png_infopp_NULL, png_infopp_NULL);
      return (GLTextura);
    }

  /* Set error handling if you are using the setjmp/longjmp method (this is
   * the normal method of doing things with libpng).  REQUIRED unless you
   * set up your own error handlers in the png_create_read_struct() earlier.
   */

  if (setjmp(png_jmpbuf(png_ptr)))
    {
      /* Free all of the memory associated with the png_ptr and info_ptr */
      png_destroy_read_struct(&png_ptr, &info_ptr, png_infopp_NULL);
      fclose(fp);
      /* If we get here, we had a problem reading the file */
      return (GLTextura);
    }

  /* Set up the input control if you are using standard C streams */
  png_init_io(png_ptr, fp);

  /* If we have already read some of the signature */
  png_set_sig_bytes(png_ptr, sig_read);

  /*
   * If you have enough memory to read in the entire image at once,
   * and you need to specify only transforms that can be controlled
   * with one of the PNG_TRANSFORM_* bits (this presently excludes
   * dithering, filling, setting background, and doing gamma
   * adjustment), then you can read the entire image (including
   * pixels) into the info structure with this call:
   */
  png_read_png(png_ptr, info_ptr, PNG_TRANSFORM_IDENTITY, png_voidp_NULL);

  /* At this point you have read the entire image */

  bit_depth = png_get_bit_depth(png_ptr, info_ptr);


  // ------------------------


  int colour_type = png_get_color_type(png_ptr, info_ptr);
 
  if (colour_type == PNG_COLOR_TYPE_PALETTE) {
    png_set_palette_to_rgb(png_ptr);
    colour_type = PNG_COLOR_TYPE_RGB;
  }
 
  if (colour_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8) {
    png_set_gray_1_2_4_to_8(png_ptr);
  }
  if (colour_type != PNG_COLOR_TYPE_RGB
      && colour_type != PNG_COLOR_TYPE_GRAY
      && colour_type != PNG_COLOR_TYPE_RGBA) {
    png_destroy_read_struct(&png_ptr, 0, 0);
    War3DError ("PNG", "Invalid colour type 1");
  }
 

   
   
  int m_depth = 0;
  int m_width = png_get_image_width(png_ptr, info_ptr);
  int m_height = png_get_image_height(png_ptr, info_ptr);
  switch (colour_type) {
  case PNG_COLOR_TYPE_RGB:
    m_depth = 3;
    break;
  case PNG_COLOR_TYPE_RGBA:
    m_depth = 4;
    break;
  default:
    War3DError ("PNG", "Invalid colour type 2");
    break;
  }
   
  png_bytep* row_pointers = png_get_rows(png_ptr, info_ptr);
 
  GLubyte *dibujo = new GLubyte[m_width * m_height * m_depth];

  for (int y = 0; y < m_height; y++) {
    for (int x = 0; x < m_width; x++) {
      for (int i = 0; i < m_depth; i++) {
	png_byte *row = row_pointers[y];
	int index = m_depth * (((m_height-1)-y) * m_width + x) + i;
	dibujo[index] = row[(x * m_depth + i) * bit_depth/8 + 0];
      }
    }
  }


  // ------------------------


  /* clean up after the read, and free any memory allocated - REQUIRED */
  png_destroy_read_struct(&png_ptr, &info_ptr, png_infopp_NULL);

  /* close the file */
  fclose(fp);


  // ------------------------

  glGenTextures(1, &GLTextura);
  glBindTexture(GL_TEXTURE_2D, GLTextura); 

  // se crea una textura rgb, sino una rgba
  if(m_depth ==3) tipo= GL_RGB;	

  //glTexImage2D(GL_TEXTURE_2D, 0, tipo, m_width, m_height, 0, tipo, GL_UNSIGNED_BYTE, dibujo);

  gluBuild2DMipmaps(GL_TEXTURE_2D, 4, m_width, m_height, tipo, GL_UNSIGNED_BYTE, dibujo);

  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, /*GL_NEAREST*/ GL_LINEAR);		// La m
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, /*GL_NEAREST*/ GL_LINEAR); 

  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);


  delete [] dibujo; 

  War3DAccion ("TEX", Archivo + " cargada."); // "ID: " + stringContadorDeTexturas;

  return GLTextura;	

}

//-------------------------------------
GLuint ServidorDeTexturas::bajaCalidad(GLuint altaCalidad,char iRate) 
{
  glBindTexture(GL_TEXTURE_2D,altaCalidad);

  GLint width,height,bpp,format;
  glGetTexLevelParameteriv(GL_TEXTURE_2D,0,GL_TEXTURE_WIDTH,&width);
  glGetTexLevelParameteriv(GL_TEXTURE_2D,0,GL_TEXTURE_HEIGHT,&height);
  glGetTexLevelParameteriv(GL_TEXTURE_2D,0,GL_TEXTURE_INTERNAL_FORMAT,&format);
  bpp=(format==GL_RGBA) ? 4 : 3;

  unsigned char *hData=new unsigned char[width*height*bpp];
  glGetTexImage(GL_TEXTURE_2D,0,format,GL_UNSIGNED_BYTE,hData);

  unsigned char *lData=new unsigned char[width/iRate*height/iRate*bpp];
  for(short y=0;y<height;y+=iRate)
    {
      for(short x=0;x<width;x+=iRate)
	{
	  for(char z=0;z<bpp;z++)
	    {
	      lData[(y/iRate*width/iRate+x/iRate)*bpp+z]=hData[(y*width+x)*bpp+z];
	    }
	}
    }
  if(hData){	delete[] hData;	hData=NULL;	}

  GLuint bajaCalidad;
  glGenTextures(1,&bajaCalidad);
  glBindTexture(GL_TEXTURE_2D,bajaCalidad);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexImage2D(GL_TEXTURE_2D,0,bpp,width/iRate,height/iRate,0,format,GL_UNSIGNED_BYTE,lData);
  //	if(lData){	delete[] lData;	lData=NULL;	}

  return bajaCalidad;
}




