//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

// ZeruGiran (c)

#include "zeru_mat.h"


void iniciaZeruMat (void)
{
  for (int i=0; i<2160; i++)
    {
      __zcosArray[i]=cos(i* 0.0029088820);
      __zsinArray[i]=sin(i* 0.0029088820);
    }
  __zeruMatIni = true;
	cout << "ZeruMatinicializada." << endl;
}

//-----------------
float zcos(float t)
{
  while (t<0)
    {
      t += 360;
    };
  
  if (__zeruMatIni ==false)
    {
      cout << "ZeruMat no inicializada\n";
      return(0);
    }
  return (__zcosArray[(int)((int)(t*6)%2160)]);
}

//-----------------
float zsin(float t)
{
  
  while (t<0)
    {
      t += 360;
    };
  
  if (__zeruMatIni ==false)
    {
      cout << "ZeruMat no inicializada\n";
      return(0);
    }
  return (__zsinArray[(int)((int)(t*6)%2160)]);
}
//-----------------


int zsgn(float x)
{
  if (x == 0.0)
    {
      return 0;
    }
  if (x > 0.0)
    {
      return 1;
    }
  return -1;
}

float zangulo(float y, float x)
{
	float Ang;
  Ang = atan2(y,x) / 0.0174532924;


	if (Ang < 0)
		{
			Ang += 360;
		}

	//cout << "Y= " << y << "  X= " << x << "  Ang= " << Ang << endl;

	return Ang;
}

// Hay que optimizar esta.
float zDistancia( float x1, float y1, float x2, float y2)
{

	float r;
	
	float a = fabs (x2 - x1);
	float b = fabs (y2 - y1);

	float fmin = a < b? a : b;

	r = a+b - (fmin/2) - (fmin/4) + (fmin/16);
	
	// r = (float)sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
       
	return (r);

}



// ----------------------------------------
// Calcula el vector que se forma a partir de dos puntos.
z3DVector CalcVector(z3DVector Punto1, z3DVector Punto2)
{
  z3DVector Vector;
  
  Vector.x = Punto1.x - Punto2.x;
  Vector.y = Punto1.y - Punto2.y;
  Vector.z = Punto1.z - Punto2.z;
  
  return Vector;		
}


// ----------------------------------------
// Calcula el producto Cruz.
z3DVector CalcCruz(z3DVector Vector1, z3DVector Vector2)
{
  z3DVector Cruz;
  
  Cruz.x = ((Vector1.y * Vector2.z) - (Vector1.z * Vector2.y));
  Cruz.y = ((Vector1.z * Vector2.x) - (Vector1.x * Vector2.z));
  Cruz.z = ((Vector1.x * Vector2.y) - (Vector1.y * Vector2.x));
  
  return Cruz;							
}


// ----------------------------------------
// Normaliza el vector
z3DVector CalcNormalizar(z3DVector Normal)
{
  double Magnitud;									
  Magnitud = sqrt(Normal.x*Normal.x + Normal.y*Normal.y + Normal.z*Normal.z);					
  Normal.x = Normal.x / (float)Magnitud;				
  Normal.y = Normal.y / (float)Magnitud;				
  Normal.z = Normal.z / (float)Magnitud;				
  
  return Normal;							
}



// ----------------------------------------
// Suma dos vectores.
z3DVector CalcSuma(z3DVector Suma1, z3DVector Suma2)
{
  z3DVector Total;		
  
  Total.x = Suma1.x + Suma2.x;
  Total.y = Suma1.y + Suma2.y;
  Total.z = Suma1.z + Suma2.z;
  
  return Total;				
}


// ----------------------------------------
// Dividir entre escalar.
z3DVector CalcDividirPorEscalar(z3DVector Vector, float Escalar)
{
  z3DVector Total;	
  
  Total.x = Vector.x / Escalar;	
  Total.y = Vector.y / Escalar;	
  Total.z = Vector.z / Escalar;	
  
  return Total;			 
}


float GiroSuave(float Inicio, float Destino, int Retrazo)
{

  if (Retrazo < 1) return Destino;

  if (Destino < 360)
    Destino = Destino + 360;
  if (Destino > 720)
    Destino = Destino - 360;
  
  if (Inicio < 360)
    Inicio = Inicio + 360;
  if (Inicio > 720)
    Inicio = Inicio - 360;

  if ((Destino - Inicio) > 180)
    Destino = Destino - 360;
  if ((Inicio - Destino) > 180)
    Inicio = Inicio - 360;
  return  (Destino + Inicio*(Retrazo-1))/Retrazo;
}


//----------------------
z3DVector VectorSuave(z3DVector Inicio, z3DVector Destino, int Retrazo)
{
  if (Retrazo < 1) return Destino;
  Inicio.x = (Destino.x + Inicio.x*(Retrazo-1))/Retrazo;
  Inicio.y = (Destino.y + Inicio.y*(Retrazo-1))/Retrazo;
  Inicio.z = (Destino.z + Inicio.z*(Retrazo-1))/Retrazo;
  return Inicio;
}


//----------------------
float LineaSuave(float Inicio, float Destino, int Retrazo)
{
  if (Retrazo < 1) return Destino;
  Inicio = (Destino + Inicio*(Retrazo-1))/Retrazo;
  return Inicio;
}


//----------------------

/*
	Matrix.cpp

		Matrix manipulation.

	Author:	Brett Porter
	Email: brettporter@yahoo.com
	Website: http://rsn.gamedev.net/pl3d
	Copyright (C)2000, 2001, Brett Porter. All Rights Reserved.
	This source code is released under the LGPL. See license.txt for details.

	Created: 9 December 2000
	Last Edited: 8 January 2001

	Please see the file ChangeLog.html for a revision history.
*/


#define PI	3.14159268

Matrix::Matrix()
{
	loadIdentity();
}

Matrix::~Matrix()
{
}

void Matrix::postMultiply( const Matrix& matrix )
{
	float newMatrix[16];
	const float *m1 = m_matrix, *m2 = matrix.m_matrix;

	newMatrix[0] = m1[0]*m2[0] + m1[4]*m2[1] + m1[8]*m2[2];
	newMatrix[1] = m1[1]*m2[0] + m1[5]*m2[1] + m1[9]*m2[2];
	newMatrix[2] = m1[2]*m2[0] + m1[6]*m2[1] + m1[10]*m2[2];
	newMatrix[3] = 0;

	newMatrix[4] = m1[0]*m2[4] + m1[4]*m2[5] + m1[8]*m2[6];
	newMatrix[5] = m1[1]*m2[4] + m1[5]*m2[5] + m1[9]*m2[6];
	newMatrix[6] = m1[2]*m2[4] + m1[6]*m2[5] + m1[10]*m2[6];
	newMatrix[7] = 0;

	newMatrix[8] = m1[0]*m2[8] + m1[4]*m2[9] + m1[8]*m2[10];
	newMatrix[9] = m1[1]*m2[8] + m1[5]*m2[9] + m1[9]*m2[10];
	newMatrix[10] = m1[2]*m2[8] + m1[6]*m2[9] + m1[10]*m2[10];
	newMatrix[11] = 0;

	newMatrix[12] = m1[0]*m2[12] + m1[4]*m2[13] + m1[8]*m2[14] + m1[12];
	newMatrix[13] = m1[1]*m2[12] + m1[5]*m2[13] + m1[9]*m2[14] + m1[13];
	newMatrix[14] = m1[2]*m2[12] + m1[6]*m2[13] + m1[10]*m2[14] + m1[14];
	newMatrix[15] = 1;

	set( newMatrix );
}

void Matrix::setTranslation( const float *translation )
{
	m_matrix[12] = translation[0];
	m_matrix[13] = translation[1];
	m_matrix[14] = translation[2];
}

void Matrix::setInverseTranslation( const float *translation )
{
	m_matrix[12] = -translation[0];
	m_matrix[13] = -translation[1];
	m_matrix[14] = -translation[2];
}

void Matrix::setRotationDegrees( const float *angles )
{
	float vec[3];
	vec[0] = ( float )( angles[0]*180.0/PI );
	vec[1] = ( float )( angles[1]*180.0/PI );
	vec[2] = ( float )( angles[2]*180.0/PI );
	setRotationRadians( vec );
}

void Matrix::setInverseRotationDegrees( const float *angles )
{
	float vec[3];
	vec[0] = ( float )( angles[0]*180.0/PI );
	vec[1] = ( float )( angles[1]*180.0/PI );
	vec[2] = ( float )( angles[2]*180.0/PI );
	setInverseRotationRadians( vec );
}

void Matrix::setRotationRadians( const float *angles )
{
	double cr = cos( angles[0] );
	double sr = sin( angles[0] );
	double cp = cos( angles[1] );
	double sp = sin( angles[1] );
	double cy = cos( angles[2] );
	double sy = sin( angles[2] );

	m_matrix[0] = ( float )( cp*cy );
	m_matrix[1] = ( float )( cp*sy );
	m_matrix[2] = ( float )( -sp );

	double srsp = sr*sp;
	double crsp = cr*sp;

	m_matrix[4] = ( float )( srsp*cy-cr*sy );
	m_matrix[5] = ( float )( srsp*sy+cr*cy );
	m_matrix[6] = ( float )( sr*cp );

	m_matrix[8] = ( float )( crsp*cy+sr*sy );
	m_matrix[9] = ( float )( crsp*sy-sr*cy );
	m_matrix[10] = ( float )( cr*cp );
}

void Matrix::setInverseRotationRadians( const float *angles )
{
	double cr = cos( angles[0] );
	double sr = sin( angles[0] );
	double cp = cos( angles[1] );
	double sp = sin( angles[1] );
	double cy = cos( angles[2] );
	double sy = sin( angles[2] );

	m_matrix[0] = ( float )( cp*cy );
	m_matrix[4] = ( float )( cp*sy );
	m_matrix[8] = ( float )( -sp );

	double srsp = sr*sp;
	double crsp = cr*sp;

	m_matrix[1] = ( float )( srsp*cy-cr*sy );
	m_matrix[5] = ( float )( srsp*sy+cr*cy );
	m_matrix[9] = ( float )( sr*cp );

	m_matrix[2] = ( float )( crsp*cy+sr*sy );
	m_matrix[6] = ( float )( crsp*sy-sr*cy );
	m_matrix[10] = ( float )( cr*cp );
}






